namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gemm_with_post_ops_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_io.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_math_utils.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#undef SRC_OFF)==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define BIAS_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==(OFF_MD(BIAS, (x0 % BIAS_PD0), (x1 % BIAS_PD1), (x2 % BIAS_PD2), \)==""\n"
R"==((x3 % BIAS_PD3), (x4 % BIAS_PD4), (x5 % BIAS_PD5)))==""\n"
R"==(__kernel void gemm_post_ops(__global SRC_DATA_T *src,)==""\n"
R"==(__global BIAS_DATA_T *bias, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(global float *a_scales, global WEI_SCALES_DATA_T *b_scales,)==""\n"
R"==(global DST_SCALES_DATA_T *c_scales, int scale_stride,)==""\n"
R"==(global int *dst_zp) {)==""\n"
R"==(const uint d0 = GWS_GET_D0();)==""\n"
R"==(const uint d1 = GWS_GET_D1();)==""\n"
R"==(const uint d2 = GWS_GET_D2();)==""\n"
R"==(const uint d3 = GWS_GET_D3();)==""\n"
R"==(size_t data_idx = SRC_OFF(d0, d1, d2, d3, 0, 0);)==""\n"
R"==(ACC_DATA_T acc;)==""\n"
R"==(load(&acc, src + data_idx);)==""\n"
R"==(POST_OP_DATA_T accumulator = 0;)==""\n"
R"==(if (d0 < DST_D0 && d1 < DST_D1 && d2 < DST_D2 && d3 < DST_D3) {)==""\n"
R"==(const float a_scale = A_SCALES ? a_scales[0] : 1;)==""\n"
R"==(const uint b_scale_dim = (NDIMS == 2) ? d1 : (NDIMS == 3) ? d2 : d3;)==""\n"
R"==(float b_scale = 1;)==""\n"
R"==(if (B_SCALES) load(&b_scale, b_scales + scale_stride * b_scale_dim);)==""\n"
R"==(if (A_SCALES || B_SCALES) acc *= a_scale * b_scale;)==""\n"
R"==(if (bias) {)==""\n"
R"==(ACC_DATA_T b;)==""\n"
R"==(load(&b, bias + BIAS_OFF(d0, d1, d2, d3, 0, 0));)==""\n"
R"==(acc += b;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T sum_src = 0.0f;)==""\n"
R"==(if (WITH_SUM) load(&sum_src, dst + data_idx);)==""\n"
R"==(accumulator = AS_POST_OP_DATA_T(acc);)==""\n"
R"==(APPLY_POST_OPS_SERIAL(accumulator, POST_OP_DATA_T, sum_src,)==""\n"
R"==(POST_OP_DATA_T, d0, 1, d1, 1, d2, 1, d3, 1, 0, 1, 0, 1);)==""\n"
R"==(if (C_SCALES) accumulator /= DST_SCALES_TO_REF(c_scales[0]);)==""\n"
R"==(if (DST_ZERO_POINT) accumulator += dst_zp[0];)==""\n"
R"==(})==""\n"
R"==(write(dst + data_idx, accumulator);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}