namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_bnorm_bwd_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm.h")==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm_reduce.h")==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP(n, dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(for (int k = 0; k < n; ++k) { \)==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[k * IC_BLOCK_STRIDE]); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_UINT_Nx16_USING_LOOP(n, dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(for (int k = 0; k < n; ++k) { \)==""\n"
R"==(dest[k] = LOAD_UINT_1x16(&src[k * IC_BLOCK_STRIDE]); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_CHAR_Nx16_USING_LOOP(n, dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(for (int k = 0; k < n; ++k) { \)==""\n"
R"==(dest[k] = LOAD_CHAR_1x16(&src[k * IC_BLOCK_STRIDE]); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_DATA_8x16_USING_LAYOUT(dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(if (USE_NHWC) { \)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, dest, src); \)==""\n"
R"==(} else { \)==""\n"
R"==(dest = LOAD_DATA_8x16(src); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_UINT_8x16_USING_LAYOUT(dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(if (USE_NHWC) { \)==""\n"
R"==(LOAD_UINT_Nx16_USING_LOOP(8, dest, src); \)==""\n"
R"==(} else { \)==""\n"
R"==(dest = LOAD_UINT_8x16(src); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_CHAR_8x16_USING_LAYOUT(dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(if (USE_NHWC) { \)==""\n"
R"==(LOAD_CHAR_Nx16_USING_LOOP(8, dest, src); \)==""\n"
R"==(} else { \)==""\n"
R"==(dest = LOAD_CHAR_8x16(src); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP_HALF(n, dest, src) \)==""\n"
R"==({ \)==""\n"
R"==(for (int k = 0; k < n; k += 2) { \)==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[k * IC_BLOCK_STRIDE]); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calculate_stats(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global DATA_T *diff_dst, __global char *ws,)==""\n"
R"==(__global float *temp_reduce, volatile __global atomic_float *diff_scale,)==""\n"
R"==(volatile __global atomic_float *diff_shift) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx;)==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(const bool is_last_sp_block = (sp_block_idx == STAT_SP_NBLOCKS - 1);)==""\n"
R"==(#endif)==""\n"
R"==(temp_reduce += group_c_offset;)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(const int offset = c + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(#else)==""\n"
R"==(const int offset = (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16)==""\n"
R"==(+ (c & ~15) * SP + mb * SP * IC;)==""\n"
R"==(#endif)==""\n"
R"==(src += offset;)==""\n"
R"==(diff_dst += offset;)==""\n"
R"==(ws += offset;)==""\n"
R"==(float v_mean = MAYBE_LAST_IC_LOAD_FLOAT_1x16(mean, c);)==""\n"
R"==(float8 diff_gamma = 0.0f;)==""\n"
R"==(float8 diff_beta = 0.0f;)==""\n"
R"==(#if HAS_STAT_SP_TAIL)==""\n"
R"==(int sp;)==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) {)==""\n"
R"==(sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK;)==""\n"
R"==(} else {)==""\n"
R"==(sp = STAT_SP_BLOCK;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(int sp = STAT_SP_BLOCK;)==""\n"
R"==(#endif)==""\n"
R"==(const int C_PARALLEL_FACTOR = 8;)==""\n"
R"==(for (; sp > C_PARALLEL_FACTOR - 1; sp -= C_PARALLEL_FACTOR) {)==""\n"
R"==(float8 src_data;)==""\n"
R"==(float8 dd_data;)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(char8 ws_data;)==""\n"
R"==(LOAD_CHAR_8x16_USING_LAYOUT(ws_data, ws);)==""\n"
R"==(#endif )==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, src_data, src);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, dd_data, diff_dst);)==""\n"
R"==(float8 t_src = intel_sub_group_shuffle_down(src_data, src_data, 8);)==""\n"
R"==(float8 t_dd = intel_sub_group_shuffle_down(dd_data, dd_data, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2) {)==""\n"
R"==(dd_data[k + 1] = t_dd[k];)==""\n"
R"==(src_data[k + 1] = t_src[k];)==""\n"
R"==(})==""\n"
R"==(#elif HAS_IC_TAIL)==""\n"
R"==(const bool is_last_sp = sp - C_PARALLEL_FACTOR <= C_PARALLEL_FACTOR - 1;)==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, src_data, src);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, dd_data, diff_dst);)==""\n"
R"==(dd_data[7] = simd_id < 8)==""\n"
R"==(? CONVERT_FLOAT_T(diff_dst[7 * IC_BLOCK_STRIDE + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(src_data[7] = simd_id < 8)==""\n"
R"==(? CONVERT_FLOAT_T(src[7 * IC_BLOCK_STRIDE + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, src_data, src);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, dd_data, diff_dst);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(src_data, src);)==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(dd_data, diff_dst);)==""\n"
R"==(#endif)==""\n"
R"==(src += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(diff_dst += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(ws += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(#endif )==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(const float8 C_ZERO = 0.0;)==""\n"
R"==(dd_data = select(C_ZERO, dd_data, convert_int8(ws_data));)==""\n"
R"==(#endif )==""\n"
R"==(const float8 v0 = src_data - v_mean;)==""\n"
R"==(diff_gamma = fma(v0, dd_data, diff_gamma);)==""\n"
R"==(diff_beta += dd_data;)==""\n"
R"==(})==""\n"
R"==(#if HAS_STAT_SP_TAIL)==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) {)==""\n"
R"==(sp = (SP - STAT_SP_TAIL * STAT_SP_BLOCK) % C_PARALLEL_FACTOR;)==""\n"
R"==(while (sp-- >= 1) {)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(const char ws_data = LOAD_CHAR_1x16(&ws[0]);)==""\n"
R"==(#else)==""\n"
R"==(const char ws_data = 1;)==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(float src_data, dd_data;)==""\n"
R"==(if (sp == 0 && is_last_ic_block) {)==""\n"
R"==(src_data = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f;)==""\n"
R"==(dd_data = simd_id < 8 ? CONVERT_FLOAT_T(diff_dst[simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(src_data = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(dd_data = LOAD_DATA_1x16(&diff_dst[0]);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const float src_data = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(const float dd_data = LOAD_DATA_1x16(&diff_dst[0]);)==""\n"
R"==(#endif)==""\n"
R"==(src += IC_BLOCK_STRIDE;)==""\n"
R"==(diff_dst += IC_BLOCK_STRIDE;)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(ws += IC_BLOCK_STRIDE;)==""\n"
R"==(#endif )==""\n"
R"==(if (ws_data != 0) {)==""\n"
R"==(const float v0 = src_data - v_mean;)==""\n"
R"==(const float diff_gamma_tmp = fma(v0, dd_data, diff_gamma[0]);)==""\n"
R"==(diff_gamma[0] = diff_gamma_tmp;)==""\n"
R"==(diff_beta[0] += dd_data;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 1; i < 8; i++) {)==""\n"
R"==(diff_gamma[0] += diff_gamma[i];)==""\n"
R"==(diff_beta[0] += diff_beta[i];)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local float local_gamma[2 * CALC_SLM_SIZE];)==""\n"
R"==(__local float *local_beta = local_gamma + CALC_SLM_SIZE;)==""\n"
R"==(gen9_calc_fused_reduction(diff_scale, diff_shift, c, diff_gamma, diff_beta,)==""\n"
R"==(NULL, NULL, local_gamma, local_beta);)==""\n"
R"==(#else)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[PADDED_IC + mb_sp_idx * 16], diff_gamma[0]);)==""\n"
R"==(STORE_FLOAT_1x16()==""\n"
R"==(&temp_reduce[2 * PADDED_IC + REDUCE_STAT_NBLOCKS * PADDED_IC)==""\n"
R"==(+ mb_sp_idx * 16],)==""\n"
R"==(diff_beta[0]);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(inline void write_8x16_block(__global DATA_T *ptr, int c, float8 val) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(if (is_last_ic_block) {)==""\n"
R"==(if (simd_id < 8) {)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(ptr[k * IC_BLOCK_STRIDE + simd_id] = CONVERT_DATA_T(val[k]);)==""\n"
R"==(})==""\n"
R"==(} else)==""\n"
R"==(#endif )==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(STORE_DATA_1x16(&ptr[k * IC_BLOCK_STRIDE], val[k]);)==""\n"
R"==(#else)==""\n"
R"==(STORE_DATA_8x16(&ptr[0], val);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(inline void write_1x16_block(__global DATA_T *ptr, int c, float val) {)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(if (!is_last_ic_block) {)==""\n"
R"==(STORE_DATA_1x16(&ptr[0], val);)==""\n"
R"==(} else {)==""\n"
R"==(if (simd_id < 8) { ptr[simd_id] = CONVERT_DATA_T(val); })==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(STORE_DATA_1x16(&ptr[0], val);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_bnorm_bwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global float *scaleshift, __global char *ws,)==""\n"
R"==(__global DATA_T *diff_src, __global float *diff_scale,)==""\n"
R"==(__global float *diff_shift, float eps, __global DATA_T *diff_src_add) {)==""\n"
R"==(const int c = GWS_GET_IC();)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(#endif)==""\n"
R"==(const float v_variance = MAYBE_LAST_IC_LOAD_FLOAT_1x16(variance, c);)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(const float v_mean = MAYBE_LAST_IC_LOAD_FLOAT_1x16(mean, c);)==""\n"
R"==(const float diff_gamma = MAYBE_LAST_IC_LOAD_FLOAT_1x16(diff_scale, c);)==""\n"
R"==(#if DIFF_SHIFT == 1)==""\n"
R"==(const float diff_beta = MAYBE_LAST_IC_LOAD_FLOAT_1x16(diff_shift, c);)==""\n"
R"==(#else)==""\n"
R"==(const float diff_beta = MAYBE_LAST_IC_LOAD_FLOAT_1x16()==""\n"
R"==(diff_shift, PADDED_IC + REDUCE_STAT_NBLOCKS * PADDED_IC + c);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(const float gamma = MAYBE_LAST_IC_LOAD_FLOAT_1x16(scaleshift, c);)==""\n"
R"==(#else)==""\n"
R"==(const float gamma = 1;)==""\n"
R"==(#endif )==""\n"
R"==(const int sp_block_idx = GWS_GET_SP();)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(const int offset = c + sp_block_idx * VECT_SIZE * IC;)==""\n"
R"==(#else)==""\n"
R"==(const int mb = GWS_GET_MB();)==""\n"
R"==(const int offset = (c & 15) + sp_block_idx * VECT_SIZE * 16 + (c & ~15) * SP)==""\n"
R"==(+ mb * SP * IC;)==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_sp_block = sp_block_idx == SP / VECT_SIZE - 1;)==""\n"
R"==(#endif)==""\n"
R"==(src += offset;)==""\n"
R"==(diff_dst += offset;)==""\n"
R"==(ws += offset;)==""\n"
R"==(diff_src += offset;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(diff_src_add += offset;)==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_SP_TAIL)==""\n"
R"==(int sp;)==""\n"
R"==(if (sp_block_idx == SP_TAIL / VECT_SIZE) {)==""\n"
R"==(sp = SP - SP_TAIL;)==""\n"
R"==(} else {)==""\n"
R"==(sp = VECT_SIZE;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(int sp = VECT_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(const float sqrt_variance = 1.0f / sqrt(v_variance + eps);)==""\n"
R"==(const int C_PARALLEL_FACTOR = 8;)==""\n"
R"==(for (; sp > C_PARALLEL_FACTOR - 1; sp -= C_PARALLEL_FACTOR) {)==""\n"
R"==(float8 src_data;)==""\n"
R"==(float8 dd_data;)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(char8 ws_data;)==""\n"
R"==(LOAD_CHAR_8x16_USING_LAYOUT(ws_data, ws);)==""\n"
R"==(#endif )==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, src_data, src);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, dd_data, diff_dst);)==""\n"
R"==(float8 t_dd = intel_sub_group_shuffle_down(dd_data, dd_data, 8);)==""\n"
R"==(float8 t_src = intel_sub_group_shuffle_down(src_data, src_data, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2) {)==""\n"
R"==(dd_data[k + 1] = t_dd[k];)==""\n"
R"==(src_data[k + 1] = t_src[k];)==""\n"
R"==(})==""\n"
R"==(#elif HAS_IC_TAIL && !HAS_SP_TAIL)==""\n"
R"==(const bool is_last_sp = sp - C_PARALLEL_FACTOR <= C_PARALLEL_FACTOR - 1;)==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, src_data, src);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, dd_data, diff_dst);)==""\n"
R"==(dd_data[7] = simd_id < 8)==""\n"
R"==(? CONVERT_FLOAT_T(diff_dst[7 * IC_BLOCK_STRIDE + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(src_data[7] = simd_id < 8)==""\n"
R"==(? CONVERT_FLOAT_T(src[7 * IC_BLOCK_STRIDE + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, src_data, src);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, dd_data, diff_dst);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(dd_data, diff_dst);)==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(src_data, src);)==""\n"
R"==(#endif )==""\n"
R"==(src += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(diff_dst += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(ws += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(#endif )==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(const float8 C_ZERO = 0.0;)==""\n"
R"==(dd_data = select(C_ZERO, dd_data, convert_int8(ws_data));)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(write_8x16_block(diff_src_add, c, dd_data);)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(dd_data -= (diff_beta)==""\n"
R"==(+ (src_data - v_mean) * diff_gamma * sqrt_variance))==""\n"
R"==(/ (MB * ID * IH * IW);)==""\n"
R"==(#endif )==""\n"
R"==(dd_data *= gamma * sqrt_variance;)==""\n"
R"==(write_8x16_block(diff_src, c, dd_data);)==""\n"
R"==(diff_src += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(diff_src_add += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if HAS_SP_TAIL)==""\n"
R"==(if (sp_block_idx == SP_TAIL / VECT_SIZE) {)==""\n"
R"==(sp = (SP - SP_TAIL) % C_PARALLEL_FACTOR;)==""\n"
R"==(while (sp-- >= 1) {)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(const char ws_data = LOAD_CHAR_1x16(&ws[0]);)==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(float dd_data;)==""\n"
R"==(if (sp == 0 && is_last_ic_block))==""\n"
R"==(dd_data = simd_id < 8 ? CONVERT_FLOAT_T(diff_dst[simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(else)==""\n"
R"==(dd_data = LOAD_DATA_1x16(&diff_dst[0]);)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(float src_data;)==""\n"
R"==(if (sp == 0 && is_last_ic_block))==""\n"
R"==(src_data = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f;)==""\n"
R"==(else)==""\n"
R"==(src_data = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(float dd_data = LOAD_DATA_1x16(&diff_dst[0]);)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(const float src_data = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(src += IC_BLOCK_STRIDE;)==""\n"
R"==(diff_dst += IC_BLOCK_STRIDE;)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(ws += IC_BLOCK_STRIDE;)==""\n"
R"==(#endif )==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(if (ws_data == 0) dd_data = 0;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(write_1x16_block(diff_src_add, c, dd_data);)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(dd_data -= (diff_beta)==""\n"
R"==(+ (src_data - v_mean) * diff_gamma)==""\n"
R"==(* sqrt_variance))==""\n"
R"==(/ (MB * ID * IH * IW);)==""\n"
R"==(#endif )==""\n"
R"==(dd_data *= gamma * sqrt_variance;)==""\n"
R"==(write_1x16_block(diff_src, c, dd_data);)==""\n"
R"==(diff_src += IC_BLOCK_STRIDE;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(diff_src_add += IC_BLOCK_STRIDE;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}