namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_bnorm_reduce_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_BNORM_GEN9_BNORM_REDUCE_H)==""\n"
R"==(#define GPU_INTEL_OCL_BNORM_GEN9_BNORM_REDUCE_H)==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm.h")==""\n"
R"==(NAMED_KERNEL_ATTR(AUX))==""\n"
R"==(__kernel void gen9_fused_reduce_init()==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__global float *mean, __global float *variance)==""\n"
R"==(#else)==""\n"
R"==(__global float *diff_scale, __global float *diff_shift)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int c = GWS_GET_IC_AUX();)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(mean[c] = 0.0f;)==""\n"
R"==(variance[c] = 0.0f;)==""\n"
R"==(#else)==""\n"
R"==(diff_scale[c] = 0.0f;)==""\n"
R"==(#if DIFF_SHIFT == 1)==""\n"
R"==(diff_shift[c] = 0.0f;)==""\n"
R"==(#else)==""\n"
R"==(diff_shift[IC + IC * REDUCE_STAT_NBLOCKS + c] = 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#if IS_FWD)==""\n"
R"==(NAMED_KERNEL_ATTR(AUX))==""\n"
R"==(__kernel void gen9_fused_reduce_final()==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(__global float *mean, __global float *variance)==""\n"
R"==(#else)==""\n"
R"==(__global float *data_reduce)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int c = GWS_GET_IC_AUX();)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(mean[c] = mean[c] / (MB * ID * IH * IW);)==""\n"
R"==(float tmp_var = max()==""\n"
R"==(0.0f, (variance[c] / (MB * ID * IH * IW)) - (mean[c] * mean[c]));)==""\n"
R"==(variance[c] = tmp_var;)==""\n"
R"==(#else)==""\n"
R"==(data_reduce[c] /= (MB * ID * IH * IW);)==""\n"
R"==(#endif)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(NAMED_KERNEL_ATTR(AUX))==""\n"
R"==(__kernel void gen9_fused_reduce_final()==""\n"
R"==(__global float *diff_scale, __global float *variance, float eps) {)==""\n"
R"==(const int c = GWS_GET_IC_AUX();)==""\n"
R"==(diff_scale[c] *= 1.0f / sqrt(variance[c] + eps);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if IS_FWD)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void gen9_reduce_mean_var(__global ACCUM_DATA_T *reduce_temp,)==""\n"
R"==(__global float *mean, __global float *variance) {)==""\n"
R"==(__local SUM_DATA_T local_sum[SG_SIZE * REDUCE_IC_SUB_GROUPS];)==""\n"
R"==(__local SUM_DATA_T local_sum_sq[SG_SIZE * REDUCE_IC_SUB_GROUPS];)==""\n"
R"==(const int ic_sub_group = get_global_id(0) / SG_SIZE;)==""\n"
R"==(const int group_c = get_global_id(1);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int c = group_c * SG_SIZE + simd_id;)==""\n"
R"==(SUM_DATA_T sum;)==""\n"
R"==(SUM_DATA_T sum_sq;)==""\n"
R"==(sum.s0 = 0;)==""\n"
R"==(sum.s1 = 0;)==""\n"
R"==(sum_sq.s0 = 0;)==""\n"
R"==(sum_sq.s1 = 0;)==""\n"
R"==(int offs_sq = REDUCE_STAT_NBLOCKS * IC;)==""\n"
R"==(int offs = REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS * SG_SIZE)==""\n"
R"==(* ic_sub_group)==""\n"
R"==(+ REDUCE_STAT_NBLOCKS * SG_SIZE * group_c + simd_id;)==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(float tmp = reduce_temp[offs + i * SG_SIZE];)==""\n"
R"==(sum = summation(tmp, sum);)==""\n"
R"==(})==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(float tmp = reduce_temp[offs_sq + offs + i * SG_SIZE];)==""\n"
R"==(sum_sq = summation(tmp, sum_sq);)==""\n"
R"==(})==""\n"
R"==(if (ic_sub_group > 0) {)==""\n"
R"==(local_sum[ic_sub_group * SG_SIZE + simd_id] = sum;)==""\n"
R"==(local_sum_sq[ic_sub_group * SG_SIZE + simd_id] = sum_sq;)==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (ic_sub_group == 0) {)==""\n"
R"==(for (int i = 1; i < REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(SUM_DATA_T tmp = local_sum[i * SG_SIZE + simd_id];)==""\n"
R"==(SUM_DATA_T tmp_sq = local_sum_sq[i * SG_SIZE + simd_id];)==""\n"
R"==(sum = summation(tmp.s1, sum);)==""\n"
R"==(sum_sq = summation(tmp_sq.s1, sum_sq);)==""\n"
R"==(sum = summation(tmp.s0, sum);)==""\n"
R"==(sum_sq = summation(tmp_sq.s0, sum_sq);)==""\n"
R"==(})==""\n"
R"==(float tmp_mean = sum.s0 / (MB * ID * IH * IW);)==""\n"
R"==(mean[c] = tmp_mean;)==""\n"
R"==(float tmp_var = max(0.0f,)==""\n"
R"==((sum_sq.s0 / (MB * ID * IH * IW)) - (tmp_mean * tmp_mean));)==""\n"
R"==(variance[c] = tmp_var;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(void gen9_reduce_common(__global float *reduce_temp, __local float *local_sum,)==""\n"
R"==(__global float *dst) {)==""\n"
R"==(const int ic_sub_group = get_global_id(0) / SG_SIZE;)==""\n"
R"==(const int group_c = get_global_id(1);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int c = group_c * SG_SIZE + simd_id;)==""\n"
R"==(const bool is_last_ic_block = (IC - group_c * SG_SIZE) < SG_SIZE;)==""\n"
R"==(float sum = 0.0f;)==""\n"
R"==(reduce_temp += REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS * SG_SIZE)==""\n"
R"==(* ic_sub_group)==""\n"
R"==(+ REDUCE_STAT_NBLOCKS * SG_SIZE * group_c + simd_id;)==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(sum += reduce_temp[i * SG_SIZE];)==""\n"
R"==(})==""\n"
R"==(if (ic_sub_group > 0) { local_sum[ic_sub_group * SG_SIZE + simd_id] = sum; })==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (ic_sub_group == 0) {)==""\n"
R"==(for (int i = 1; i < REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(sum += local_sum[i * SG_SIZE + simd_id];)==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (!is_last_ic_block || (is_last_ic_block && simd_id < 8)))==""\n"
R"==(#endif)==""\n"
R"==(dst[c] = sum / (MB * ID * IH * IW);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void gen9_reduce_mean()==""\n"
R"==(__global float *reduce_temp, __global float *mean) {)==""\n"
R"==(__local float local_sum[SG_SIZE * REDUCE_IC_SUB_GROUPS];)==""\n"
R"==(gen9_reduce_common(reduce_temp, local_sum, mean);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void gen9_reduce_variance()==""\n"
R"==(__global float *reduce_temp, __global float *variance) {)==""\n"
R"==(__local float local_sum[SG_SIZE * REDUCE_IC_SUB_GROUPS];)==""\n"
R"==(gen9_reduce_common()==""\n"
R"==(reduce_temp + REDUCE_STAT_NBLOCKS * PADDED_IC, local_sum, variance);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_BWD)==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void gen9_reduce_stats(__global float *temp_reduce,)==""\n"
R"==(__global float *diff_scale, __global float *diff_shift,)==""\n"
R"==(__global float *variance, float eps) {)==""\n"
R"==(__local float local_gamma[SG_SIZE * REDUCE_IC_SUB_GROUPS];)==""\n"
R"==(__local float local_beta[SG_SIZE * REDUCE_IC_SUB_GROUPS];)==""\n"
R"==(const int ic_sub_group = get_global_id(0) / SG_SIZE;)==""\n"
R"==(const int group_c = get_global_id(1);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int c = group_c * SG_SIZE + simd_id;)==""\n"
R"==(float diff_gamma = 0.0f;)==""\n"
R"==(float diff_beta = 0.0f;)==""\n"
R"==(temp_reduce += PADDED_IC + REDUCE_STAT_NBLOCKS * SG_SIZE * group_c)==""\n"
R"==(+ REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS * SG_SIZE)==""\n"
R"==(* ic_sub_group)==""\n"
R"==(+ simd_id;)==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(diff_gamma += temp_reduce[i * SG_SIZE];)==""\n"
R"==(})==""\n"
R"==(temp_reduce += PADDED_IC + PADDED_IC * REDUCE_STAT_NBLOCKS;)==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(diff_beta += temp_reduce[i * SG_SIZE];)==""\n"
R"==(})==""\n"
R"==(if (ic_sub_group > 0) {)==""\n"
R"==(local_gamma[ic_sub_group * SG_SIZE + simd_id] = diff_gamma;)==""\n"
R"==(local_beta[ic_sub_group * SG_SIZE + simd_id] = diff_beta;)==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (ic_sub_group == 0) {)==""\n"
R"==(for (int i = 1; i < REDUCE_IC_SUB_GROUPS; i++) {)==""\n"
R"==(diff_gamma += local_gamma[i * SG_SIZE + simd_id];)==""\n"
R"==(diff_beta += local_beta[i * SG_SIZE + simd_id];)==""\n"
R"==(})==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(variance[c] + eps);)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = group_c * SG_SIZE + SG_SIZE > IC;)==""\n"
R"==(if (!is_last_ic_block || (is_last_ic_block && simd_id < 8)))==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(diff_scale[c] = diff_gamma * sqrt_variance;)==""\n"
R"==(#if DIFF_SHIFT == 1)==""\n"
R"==(diff_shift[c] = diff_beta;)==""\n"
R"==(#else)==""\n"
R"==(diff_shift[PADDED_IC + PADDED_IC * REDUCE_STAT_NBLOCKS + c])==""\n"
R"==(= diff_beta;)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}