namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_concat_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/concat_common.h")==""\n"
R"==(#define SCALE_PTR(n) __global const float *scale##n)==""\n"
R"==(#define IS_IN_PART(x) (dst_dims[CONCAT_AXIS] < CONCAT3(SRC, x, _END)))==""\n"
R"==(#define WRITE_DST_X(x) dst[dst_off] = TO_DST(x);)==""\n"
R"==(#if SCALES_MASK > 0)==""\n"
R"==(#define EXTRACT_SCALES_IF(n) \)==""\n"
R"==(if (SCALES_MASK & (1 << n)) tmp_src_scale = *scale##n;)==""\n"
R"==(#define WRITE_DST WRITE_DST_X((float)src_val *tmp_src_scale))==""\n"
R"==(#define INIT_FLOAT_SCALE float tmp_src_scale = 1.0;)==""\n"
R"==(#define SCALE_PTRS , REDUCE(NUM_INPUTS, JOIN_COMMA, SCALE_PTR))==""\n"
R"==(#else)==""\n"
R"==(#define WRITE_DST WRITE_DST_X(src_val))==""\n"
R"==(#define EXTRACT_SCALES_IF(n))==""\n"
R"==(#define INIT_FLOAT_SCALE)==""\n"
R"==(#define SCALE_PTRS)==""\n"
R"==(#define WRITE_SCALE dst[dst_off] = TO_DST(src_val);)==""\n"
R"==(#endif)==""\n"
R"==(#define SET_DIMS(x, y) \)==""\n"
R"==({ \)==""\n"
R"==(part = y; \)==""\n"
R"==(EXTRACT_SCALES_IF(y); \)==""\n"
R"==(if (y > 0) { \)==""\n"
R"==(src_dims[CONCAT_AXIS] \)==""\n"
R"==(= dst_dims[CONCAT_AXIS] - CONCAT3(SRC, x, _END); \)==""\n"
R"==(} \)==""\n"
R"==(src_off = OFF_MD(CONCAT2(SRC, y), src_dims[0], src_dims[1], \)==""\n"
R"==(src_dims[2], src_dims[3], src_dims[4], src_dims[5]); \)==""\n"
R"==(src = CONCAT2(src, y); \)==""\n"
R"==(})==""\n"
R"==(#define SRC_DATA_T SRC0_DATA_T)==""\n"
R"==(#define DD(i) CONCAt2(DST_D, i))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, dim5) \)==""\n"
R"==(dim0 >= DD(0) || dim1 >= DD(1) || dim2 >= DD(2) || dim3 >= DD(3) \)==""\n"
R"==(|| dim4 >= DD(4) || dim5 >= DD(5))==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_concat(__global DST_DATA_T *dst, long dst_offset0,)==""\n"
R"==(__global const SRC_DATA_T *src0, __global const SRC_DATA_T *src1,)==""\n"
R"==(__global const SRC_DATA_T *src2, __global const SRC_DATA_T *src3,)==""\n"
R"==(__global const SRC_DATA_T *src4, __global const SRC_DATA_T *src5,)==""\n"
R"==(__global const SRC_DATA_T *src6, __global const SRC_DATA_T *src7,)==""\n"
R"==(__global const SRC_DATA_T *src8, __global const SRC_DATA_T *src9,)==""\n"
R"==(__global const SRC_DATA_T *src10, __global const SRC_DATA_T *src11,)==""\n"
R"==(__global const SRC_DATA_T *src12, __global const SRC_DATA_T *src13,)==""\n"
R"==(__global const SRC_DATA_T *src14,)==""\n"
R"==(__global const SRC_DATA_T *src15 SCALE_PTRS) {)==""\n"
R"==(dst += dst_offset0;)==""\n"
R"==(int dst_dims[6], src_dims[6];)==""\n"
R"==(src_dims[0] = dst_dims[0] = GWS_GET_D0();)==""\n"
R"==(src_dims[1] = dst_dims[1] = GWS_GET_D1();)==""\n"
R"==(src_dims[2] = dst_dims[2] = GWS_GET_D2();)==""\n"
R"==(src_dims[3] = dst_dims[3] = GWS_GET_D3();)==""\n"
R"==(src_dims[4] = dst_dims[4] = GWS_GET_D4();)==""\n"
R"==(src_dims[5] = dst_dims[5] = GWS_GET_D5();)==""\n"
R"==(const int iter_dim_end = min()==""\n"
R"==(dst_dims[ITER_DIM_IDX] + ITER_DIM_CHUNK, ITER_DIM_PADDED_SIZE);)==""\n"
R"==(if (NEEDS_PADDING(dst_dims[0], dst_dims[1], dst_dims[2], dst_dims[3],)==""\n"
R"==(dst_dims[4], dst_dims[5])) {)==""\n"
R"==(for (; dst_dims[ITER_DIM_IDX] < iter_dim_end;)==""\n"
R"==(dst_dims[ITER_DIM_IDX]++) {)==""\n"
R"==(const int dst_off = OFF_MD(DST, dst_dims[0], dst_dims[1],)==""\n"
R"==(dst_dims[2], dst_dims[3], dst_dims[4], dst_dims[5]);)==""\n"
R"==(#if SUB_GROUP_SIZE > 1)==""\n"
R"==(BLOCK_WRITE_DST(&dst[dst_off], TO_DST(0.0f));)==""\n"
R"==(#else )==""\n"
R"==(dst[dst_off] = TO_DST(0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(for (; dst_dims[ITER_DIM_IDX] < min(DD(ITER_DIM_IDX), iter_dim_end);)==""\n"
R"==(dst_dims[ITER_DIM_IDX]++, src_dims[ITER_DIM_IDX]++) {)==""\n"
R"==(int part;)==""\n"
R"==(int src_off;)==""\n"
R"==(const __global SRC_DATA_T *src;)==""\n"
R"==(INIT_FLOAT_SCALE;)==""\n"
R"==(if (IS_IN_PART(0)) SET_DIMS(0, 0))==""\n"
R"==(#if NUM_INPUTS >= 2)==""\n"
R"==(else if (IS_IN_PART(1)))==""\n"
R"==(SET_DIMS(0, 1))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 3)==""\n"
R"==(else if (IS_IN_PART(2)))==""\n"
R"==(SET_DIMS(1, 2))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 4)==""\n"
R"==(else if (IS_IN_PART(3)))==""\n"
R"==(SET_DIMS(2, 3))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 5)==""\n"
R"==(else if (IS_IN_PART(4)))==""\n"
R"==(SET_DIMS(3, 4))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 6)==""\n"
R"==(else if (IS_IN_PART(5)))==""\n"
R"==(SET_DIMS(4, 5))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 7)==""\n"
R"==(else if (IS_IN_PART(6)))==""\n"
R"==(SET_DIMS(5, 6))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 8)==""\n"
R"==(else if (IS_IN_PART(7)))==""\n"
R"==(SET_DIMS(6, 7))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 9)==""\n"
R"==(else if (IS_IN_PART(8)))==""\n"
R"==(SET_DIMS(7, 8))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 10)==""\n"
R"==(else if (IS_IN_PART(9)))==""\n"
R"==(SET_DIMS(8, 9))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 11)==""\n"
R"==(else if (IS_IN_PART(10)))==""\n"
R"==(SET_DIMS(9, 10))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 12)==""\n"
R"==(else if (IS_IN_PART(11)))==""\n"
R"==(SET_DIMS(10, 11))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 13)==""\n"
R"==(else if (IS_IN_PART(12)))==""\n"
R"==(SET_DIMS(11, 12))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 14)==""\n"
R"==(else if (IS_IN_PART(13)))==""\n"
R"==(SET_DIMS(12, 13))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 15)==""\n"
R"==(else if (IS_IN_PART(14)))==""\n"
R"==(SET_DIMS(13, 14))==""\n"
R"==(#endif)==""\n"
R"==(#if NUM_INPUTS >= 16)==""\n"
R"==(else if (IS_IN_PART(15)))==""\n"
R"==(SET_DIMS(14, 15))==""\n"
R"==(#endif)==""\n"
R"==(const int dst_off = OFF_MD(DST, dst_dims[0], dst_dims[1], dst_dims[2],)==""\n"
R"==(dst_dims[3], dst_dims[4], dst_dims[5]);)==""\n"
R"==(#if SUB_GROUP_SIZE > 1)==""\n"
R"==(#if DT_BF16 == 1)==""\n"
R"==(float src_val = DATA_TO_REF(AS_DATA_T()==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(#else )==""\n"
R"==(SRC_DATA_T src_val = AS_DATA_T()==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off]));)==""\n"
R"==(#endif )==""\n"
R"==(#if SCALES_MASK > 0)==""\n"
R"==(BLOCK_WRITE_DST(&dst[dst_off], TO_DST((float)src_val * tmp_src_scale));)==""\n"
R"==(#else)==""\n"
R"==(BLOCK_WRITE_DST(&dst[dst_off], TO_DST(src_val));)==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(#if DT_BF16 == 1)==""\n"
R"==(float src_val = DATA_TO_REF(src[src_off]);)==""\n"
R"==(#else )==""\n"
R"==(SRC_DATA_T src_val = src[src_off];)==""\n"
R"==(#endif )==""\n"
R"==(WRITE_DST)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(for (; dst_dims[ITER_DIM_IDX] < iter_dim_end; dst_dims[ITER_DIM_IDX]++) {)==""\n"
R"==(const int dst_off = OFF_MD(DST, dst_dims[0], dst_dims[1], dst_dims[2],)==""\n"
R"==(dst_dims[3], dst_dims[4], dst_dims[5]);)==""\n"
R"==(#if SUB_GROUP_SIZE > 1)==""\n"
R"==(BLOCK_WRITE_DST(&dst[dst_off], TO_DST(0.0f));)==""\n"
R"==(#else )==""\n"
R"==(dst[dst_off] = TO_DST(0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}