namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_softmax_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define LOAD_FLOAT8(prefix, ptr) \)==""\n"
R"==(DATA_TO_FLOAT8(prefix, \)==""\n"
R"==(BLOCK_TO_DATA8(prefix, \)==""\n"
R"==(READ_BLOCK8(prefix, \)==""\n"
R"==((__global BLOCK_T(ALIAS(prefix)) *)(ptr)))))==""\n"
R"==(#define STORE_FLOAT8(prefix, ptr, val) \)==""\n"
R"==(WRITE_BLOCK8(prefix, (__global BLOCK_T(ALIAS(prefix)) *)(ptr), \)==""\n"
R"==(DATA_TO_BLOCK8(prefix, FLOAT_TO_DATA8(prefix, val))))==""\n"
R"==(#define LOAD_DOUBLE8(prefix, ptr) \)==""\n"
R"==(DATA_TO_DOUBLE8(prefix, \)==""\n"
R"==(BLOCK_TO_DATA8(prefix, \)==""\n"
R"==(READ_BLOCK8(prefix, \)==""\n"
R"==((__global BLOCK_T(ALIAS(prefix)) *)(ptr)))))==""\n"
R"==(#define STORE_DOUBLE8(prefix, ptr, val) \)==""\n"
R"==(WRITE_BLOCK8(prefix, (__global BLOCK_T(ALIAS(prefix)) *)(ptr), \)==""\n"
R"==(DATA_TO_BLOCK8(prefix, DOUBLE_TO_DATA8(prefix, val))))==""\n"
R"==(#if DST_DT_F64)==""\n"
R"==(#define UP_CASE_DATA DOUBLE)==""\n"
R"==(#define COMMON_DATA_T double)==""\n"
R"==(#define COMMON_DATA_MAX DBL_MAX)==""\n"
R"==(#define COMMON_DATA_ZERO 0.0)==""\n"
R"==(#else)==""\n"
R"==(#define UP_CASE_DATA FLOAT)==""\n"
R"==(#define COMMON_DATA_T float)==""\n"
R"==(#define COMMON_DATA_MAX FLT_MAX)==""\n"
R"==(#define COMMON_DATA_ZERO 0.0f)==""\n"
R"==(#endif)==""\n"
R"==(#define COMMON_DATA8_T CONCAT2(COMMON_DATA_T, 8))==""\n"
R"==(#define COMMON_DATA_TO_X(x, y) CONCAT2(DATA_TO_, UP_CASE_DATA)(x, y))==""\n"
R"==(#define COMMON_X_TO_DATA(x, y) CONCAT2(UP_CASE_DATA, _TO_DATA)(x, y))==""\n"
R"==(#define COMMON_LOAD_DATA8(x, y) CONCAT3(LOAD_, UP_CASE_DATA, 8)(x, y))==""\n"
R"==(#define COMMON_STORE_DATA8(x, y, z) CONCAT3(STORE_, UP_CASE_DATA, 8)(x, y, z))==""\n"
R"==(#define VECT_SIZE 8)==""\n"
R"==(#define SV (GROUP_SIZE * VECT_SIZE))==""\n"
R"==(#define HAS_TAIL (SOFTMAX_AXIS_SIZE % SV != 0))==""\n"
R"==(#define NUM_BUF ((SOFTMAX_AXIS_SIZE + SV - 1) / SV))==""\n"
R"==(#define SMALL_BUFFER (REPEAT_SUBGRP_BUF_SIZE < THREAD_BUF_SIZE))==""\n"
R"==(#if IS_FWD)==""\n"
R"==(int find_axis_offset(int index, int local_id, int subgroup) {)==""\n"
R"==(const int group_axis_block = GROUP_SIZE * THREAD_BUF_SIZE * CHANNELS;)==""\n"
R"==(int offset = CHANNELS * THREAD_BUF_SIZE * local_id;)==""\n"
R"==(if (index > 0) { offset += group_axis_block; })==""\n"
R"==(if (index > 0 && subgroup == (SUBGROUPS_REPEATED - 1) && SMALL_BUFFER) {)==""\n"
R"==(offset = group_axis_block)==""\n"
R"==(+ (CHANNELS * REPEAT_SUBGRP_BUF_SIZE * local_id);)==""\n"
R"==(})==""\n"
R"==(return offset;)==""\n"
R"==(})==""\n"
R"==(int get_local_off(int subgroup, int subgroup_local_id) {)==""\n"
R"==(if (subgroup == (SUBGROUPS_REPEATED - 1)) {)==""\n"
R"==(if (SMALL_BUFFER) {)==""\n"
R"==(return ((GROUP_SIZE + SUB_GROUP_SIZE * subgroup) * THREAD_BUF_SIZE)==""\n"
R"==(+ subgroup_local_id * REPEAT_SUBGRP_BUF_SIZE);)==""\n"
R"==(} else { )==""\n"
R"==(return ((GROUP_SIZE + SUB_GROUP_SIZE * subgroup + subgroup_local_id))==""\n"
R"==(* THREAD_BUF_SIZE);)==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(return 1; )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(int get_buffer_size(int index, int subgroup, int local_off) {)==""\n"
R"==(if (index > 0 && subgroup == (SUBGROUPS_REPEATED - 1)) {)==""\n"
R"==(if (SMALL_BUFFER) {)==""\n"
R"==(int tail = SOFTMAX_AXIS_SIZE)==""\n"
R"==(- ((GROUP_SIZE + subgroup) * THREAD_BUF_SIZE);)==""\n"
R"==(return ((local_off + REPEAT_SUBGRP_BUF_SIZE) <= SOFTMAX_AXIS_SIZE))==""\n"
R"==(? REPEAT_SUBGRP_BUF_SIZE)==""\n"
R"==(: tail % REPEAT_SUBGRP_BUF_SIZE;)==""\n"
R"==(} else {)==""\n"
R"==(return ((local_off + THREAD_BUF_SIZE) <= SOFTMAX_AXIS_SIZE))==""\n"
R"==(? THREAD_BUF_SIZE)==""\n"
R"==(: SOFTMAX_AXIS_SIZE % THREAD_BUF_SIZE;)==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(return THREAD_BUF_SIZE;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__attribute__((reqd_work_group_size(GROUP_SIZE, 1, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void)==""\n"
R"==(gen9_softmax_fwd(__global SRC_DATA_T *src, __global DST_DATA_T *dst,)==""\n"
R"==(__global float *src_scale, __global float *dst_scale) {)==""\n"
R"==(float scale = 1.0f;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(scale *= src_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(scale /= dst_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_NHWC || IS_BLOCKED)==""\n"
R"==(const int group = get_global_id(0) / GROUP_SIZE;)==""\n"
R"==(const int mb = group / CHANNELS_PADDED;)==""\n"
R"==(const int channel_id = group % CHANNELS_PADDED;)==""\n"
R"==(const int local_id = get_local_id(0);)==""\n"
R"==(const int subgroup_local_id = get_sub_group_local_id();)==""\n"
R"==(const int subgroup_id = get_sub_group_id();)==""\n"
R"==(int buf_chunk = (local_id / SUB_GROUP_SIZE) * SOFTMAX_BUF;)==""\n"
R"==(COMMON_DATA_T max_ = -COMMON_DATA_MAX;)==""\n"
R"==(COMMON_DATA_T denom_ = COMMON_DATA_ZERO;)==""\n"
R"==(#if SUBGROUPS_REPEATED )==""\n"
R"==(COMMON_DATA_T d[2][THREAD_BUF_SIZE];)==""\n"
R"==(int num_buf = (subgroup_id < SUBGROUPS_REPEATED) ? 2 : 1;)==""\n"
R"==(int local_off = get_local_off(subgroup_id, subgroup_local_id);)==""\n"
R"==(for (int i = 0; i < num_buf; i++) {)==""\n"
R"==(if (i > 0 && local_off >= SOFTMAX_AXIS_SIZE) break;)==""\n"
R"==(__global SRC_DATA_T *src_copy = src;)==""\n"
R"==(int axis_offset = find_axis_offset(i, subgroup_local_id, subgroup_id);)==""\n"
R"==(int data_off = mb * CHANNELS_PADDED * SOFTMAX_AXIS_SIZE + axis_offset)==""\n"
R"==(+ channel_id;)==""\n"
R"==(int buf_reads = get_buffer_size(i, subgroup_id, local_off);)==""\n"
R"==(src_copy += data_off;)==""\n"
R"==(for (int k = 0, axis_channel_id = CHANNELS * buf_chunk; k < buf_reads;)==""\n"
R"==(++k, axis_channel_id += CHANNELS) {)==""\n"
R"==(d[i][k] = COMMON_DATA_TO_X(SRC, src_copy[axis_channel_id]);)==""\n"
R"==(max_ = max(d[i][k], max_);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(max_ = sub_group_reduce_max(max_);)==""\n"
R"==(#else)==""\n"
R"==(max_ = work_group_reduce_max(max_);)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < num_buf; i++) {)==""\n"
R"==(if (i > 0 && local_off >= SOFTMAX_AXIS_SIZE) break;)==""\n"
R"==(int buf_reads = get_buffer_size(i, subgroup_id, local_off);)==""\n"
R"==(for (int k = 0; k < buf_reads; ++k) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ += exp(d[i][k] - max_);)==""\n"
R"==(#else)==""\n"
R"==(d[i][k] = exp(d[i][k] - max_);)==""\n"
R"==(denom_ += d[i][k];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(denom_ = sub_group_reduce_add(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = work_group_reduce_add(denom_);)==""\n"
R"==(#endif)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ = log(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = 1.0 / denom_;)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < num_buf; i++) {)==""\n"
R"==(if (i > 0 && local_off >= SOFTMAX_AXIS_SIZE) break;)==""\n"
R"==(__global DST_DATA_T *dst_copy = dst;)==""\n"
R"==(int axis_offset = find_axis_offset(i, subgroup_local_id, subgroup_id);)==""\n"
R"==(int data_off = mb * CHANNELS_PADDED * SOFTMAX_AXIS_SIZE + axis_offset)==""\n"
R"==(+ channel_id;)==""\n"
R"==(int buf_reads = get_buffer_size(i, subgroup_id, local_off);)==""\n"
R"==(dst_copy += data_off;)==""\n"
R"==(for (int k = 0, axis_channel_id = CHANNELS * buf_chunk; k < buf_reads;)==""\n"
R"==(++k, axis_channel_id += CHANNELS) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(d[i][k] = d[i][k] - max_ - denom_;)==""\n"
R"==(#else)==""\n"
R"==(d[i][k] = d[i][k] * denom_;)==""\n"
R"==(#endif)==""\n"
R"==(dst_copy[axis_channel_id] = COMMON_X_TO_DATA(DST, d[i][k] * scale);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const int channel_offset = CHANNELS * THREAD_BUF_SIZE * subgroup_local_id;)==""\n"
R"==(#if IS_BLOCKED)==""\n"
R"==(const int channel_block = channel_id / CHANNELS;)==""\n"
R"==(const int channel_in_block = channel_id % CHANNELS;)==""\n"
R"==(int data_off = mb * CHANNELS * SOFTMAX_AXIS_SIZE + channel_offset)==""\n"
R"==(+ channel_in_block;)==""\n"
R"==(const int buf_reads = THREAD_BUF_SIZE;)==""\n"
R"==(#else)==""\n"
R"==(int data_off = mb * CHANNELS_PADDED * SOFTMAX_AXIS_SIZE + channel_offset)==""\n"
R"==(+ channel_id;)==""\n"
R"==(const int local_off = local_id * THREAD_BUF_SIZE;)==""\n"
R"==(int buf_reads;)==""\n"
R"==(if (local_off >= SOFTMAX_AXIS_SIZE) {)==""\n"
R"==(buf_reads = 0;)==""\n"
R"==(} else {)==""\n"
R"==(buf_reads = ((local_off + THREAD_BUF_SIZE) <= SOFTMAX_AXIS_SIZE))==""\n"
R"==(? THREAD_BUF_SIZE)==""\n"
R"==(: (SOFTMAX_AXIS_SIZE % THREAD_BUF_SIZE);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(COMMON_DATA_T d[THREAD_BUF_SIZE];)==""\n"
R"==(src += data_off;)==""\n"
R"==(for (int k = 0, axis_channel_id = CHANNELS * buf_chunk; k < buf_reads;)==""\n"
R"==(++k, axis_channel_id += CHANNELS) {)==""\n"
R"==(d[k] = COMMON_DATA_TO_X(SRC, src[axis_channel_id]);)==""\n"
R"==(max_ = max(d[k], max_);)==""\n"
R"==(})==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(max_ = sub_group_reduce_max(max_);)==""\n"
R"==(#else)==""\n"
R"==(max_ = work_group_reduce_max(max_);)==""\n"
R"==(#endif)==""\n"
R"==(for (int k = 0; k < buf_reads; ++k) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ += exp(d[k] - max_);)==""\n"
R"==(#else)==""\n"
R"==(d[k] = exp(d[k] - max_);)==""\n"
R"==(denom_ += d[k];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(denom_ = sub_group_reduce_add(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = work_group_reduce_add(denom_);)==""\n"
R"==(#endif)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ = log(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = 1.0 / denom_;)==""\n"
R"==(#endif)==""\n"
R"==(dst += data_off;)==""\n"
R"==(for (int k = 0, axis_channel_id = CHANNELS * buf_chunk; k < buf_reads;)==""\n"
R"==(++k, axis_channel_id += CHANNELS) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(d[k] = d[k] - max_ - denom_;)==""\n"
R"==(#else)==""\n"
R"==(d[k] = d[k] * denom_;)==""\n"
R"==(#endif)==""\n"
R"==(dst[axis_channel_id] = COMMON_X_TO_DATA(DST, d[k] * scale);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(const int data_off = (get_global_id(0) / GROUP_SIZE) * SOFTMAX_AXIS_SIZE;)==""\n"
R"==(COMMON_DATA8_T d[NUM_BUF];)==""\n"
R"==(COMMON_DATA_T max_ = -COMMON_DATA_MAX;)==""\n"
R"==(COMMON_DATA_T denom_ = COMMON_DATA_ZERO;)==""\n"
R"==(int last_buf = HAS_TAIL ? (NUM_BUF - 1) : NUM_BUF;)==""\n"
R"==(src += data_off;)==""\n"
R"==(int sid = get_sub_group_id();)==""\n"
R"==(#if IS_READ_ALIGNED)==""\n"
R"==(for (int k = 0; k < last_buf; ++k) {)==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(int idx = k * SUB_GROUP_SIZE;)==""\n"
R"==(#else)==""\n"
R"==(int idx = HAS_TAIL ? k * SUB_GROUP_SIZE : sid * SUB_GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(d[k] = COMMON_LOAD_DATA8(SRC, &src[idx * VECT_SIZE]);)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) {)==""\n"
R"==(max_ = max(d[k][i], max_);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if HAS_TAIL)==""\n"
R"==({)==""\n"
R"==(int k = last_buf;)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) {)==""\n"
R"==(int off = k * VECT_SIZE * SUB_GROUP_SIZE + i * SUB_GROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id();)==""\n"
R"==(d[k][i] = (off < SOFTMAX_AXIS_SIZE ? COMMON_DATA_TO_X(SRC, src[off]))==""\n"
R"==(: -COMMON_DATA_MAX);)==""\n"
R"==(max_ = max(d[k][i], max_);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) {)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) {)==""\n"
R"==(int off = k * VECT_SIZE * SUB_GROUP_SIZE + i * SUB_GROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id();)==""\n"
R"==(d[k][i] = (off < SOFTMAX_AXIS_SIZE ? DATA_TO_FLOAT(SRC, src[off]))==""\n"
R"==(: -FLT_MAX);)==""\n"
R"==(max_ = max(d[k][i], max_);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(max_ = sub_group_reduce_max(max_);)==""\n"
R"==(#else)==""\n"
R"==(max_ = work_group_reduce_max(max_);)==""\n"
R"==(#endif)==""\n"
R"==(for (int k = 0; k < last_buf; ++k) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i))==""\n"
R"==(denom_ += exp(d[k][i] - max_);)==""\n"
R"==(#else)==""\n"
R"==(d[k] = exp(d[k] - max_);)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i))==""\n"
R"==(denom_ += d[k][i];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if HAS_TAIL)==""\n"
R"==({)==""\n"
R"==(int k = last_buf;)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) {)==""\n"
R"==(int off = k * VECT_SIZE * SUB_GROUP_SIZE + i * SUB_GROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id();)==""\n"
R"==(if (off < SOFTMAX_AXIS_SIZE) denom_ += exp(d[k][i] - max_);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(d[k] = exp(d[k] - max_);)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) {)==""\n"
R"==(int off = k * VECT_SIZE * SUB_GROUP_SIZE + i * SUB_GROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id();)==""\n"
R"==(if (off < SOFTMAX_AXIS_SIZE) denom_ += d[k][i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(denom_ = sub_group_reduce_add(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = work_group_reduce_add(denom_);)==""\n"
R"==(#endif)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ = log(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = 1.0 / denom_;)==""\n"
R"==(#endif)==""\n"
R"==(dst += data_off;)==""\n"
R"==(#if IS_WRITE_ALIGNED)==""\n"
R"==(for (int k = 0; k < last_buf; ++k) {)==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(int idx = k * SUB_GROUP_SIZE;)==""\n"
R"==(#else)==""\n"
R"==(int idx = HAS_TAIL ? k * SUB_GROUP_SIZE : sid * SUB_GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(d[k] = d[k] - max_ - denom_;)==""\n"
R"==(#else)==""\n"
R"==(d[k] = d[k] * denom_;)==""\n"
R"==(#endif)==""\n"
R"==(COMMON_STORE_DATA8(DST, &dst[idx * VECT_SIZE], scale * d[k]);)==""\n"
R"==(})==""\n"
R"==(#if HAS_TAIL )==""\n"
R"==({)==""\n"
R"==(int k = last_buf;)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(d[k] = d[k] - max_ - denom_;)==""\n"
R"==(#else)==""\n"
R"==(d[k] = d[k] * denom_;)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; i++) {)==""\n"
R"==(int off = k * VECT_SIZE * SUB_GROUP_SIZE + i * SUB_GROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id();)==""\n"
R"==(if (off < SOFTMAX_AXIS_SIZE))==""\n"
R"==(dst[off] = COMMON_X_TO_DATA(DST, scale * d[k][i]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(for (int k = 0; k < NUM_BUF; k++) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(d[k] = d[k] - max_ - denom_;)==""\n"
R"==(#else)==""\n"
R"==(d[k] = d[k] * denom_;)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; i++) {)==""\n"
R"==(int off = k * VECT_SIZE * SUB_GROUP_SIZE + i * SUB_GROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id();)==""\n"
R"==(if (off < SOFTMAX_AXIS_SIZE))==""\n"
R"==(dst[off] = COMMON_X_TO_DATA(DST, scale * d[k][i]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD)==""\n"
R"==(__attribute__((reqd_work_group_size(GROUP_SIZE, 1, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void)==""\n"
R"==(gen9_softmax_bwd(__global DST_DATA_T *dst, __global SRC_DATA_T *diff_src,)==""\n"
R"==(__global DST_DATA_T *diff_dst) {)==""\n"
R"==(#if IS_NHWC || IS_16C)==""\n"
R"==(const int groups = get_global_id(0) / GROUP_SIZE;)==""\n"
R"==(const int batch = groups / IC_PADDED;)==""\n"
R"==(const int ic = groups % IC_PADDED;)==""\n"
R"==(const int sub_grp_id = get_sub_group_local_id();)==""\n"
R"==(const int local_id = get_local_id(0);)==""\n"
R"==(const int slice = local_id / SUB_GROUP_SIZE;)==""\n"
R"==(const int ic_buff = IC * VECT_SIZE;)==""\n"
R"==(#if IS_16C)==""\n"
R"==(const int ic_blk = ic / IC;)==""\n"
R"==(const int ic_in_blk = ic % IC;)==""\n"
R"==(int data_off = BATCH * IC * SOFTMAX_AXIS_SIZE * ic_blk)==""\n"
R"==(+ batch * IC * SOFTMAX_AXIS_SIZE + ic_buff * sub_grp_id + ic_in_blk;)==""\n"
R"==(#else)==""\n"
R"==(int data_off = batch * IC * SOFTMAX_AXIS_SIZE + ic_buff * sub_grp_id + ic;)==""\n"
R"==(#endif)==""\n"
R"==(COMMON_DATA_T sbr = COMMON_DATA_ZERO;)==""\n"
R"==(COMMON_DATA_T diff_d[VECT_SIZE];)==""\n"
R"==(COMMON_DATA_T dst_[VECT_SIZE];)==""\n"
R"==(diff_dst += data_off;)==""\n"
R"==(dst += data_off;)==""\n"
R"==(for (int i = 0, idx = IC * slice * SOFTMAX_BUF; i < VECT_SIZE;)==""\n"
R"==(++i, idx += IC) {)==""\n"
R"==(diff_d[i] = COMMON_DATA_TO_X(DST, diff_dst[idx]);)==""\n"
R"==(dst_[i] = COMMON_DATA_TO_X(DST, dst[idx]);)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(sbr += diff_d[i];)==""\n"
R"==(#else)==""\n"
R"==(sbr += dst_[i] * diff_d[i];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(sbr = sub_group_reduce_add(sbr);)==""\n"
R"==(#else)==""\n"
R"==(sbr = work_group_reduce_add(sbr);)==""\n"
R"==(#endif)==""\n"
R"==(diff_src += data_off;)==""\n"
R"==(for (int i = 0, idx = IC * slice * SOFTMAX_BUF; i < VECT_SIZE;)==""\n"
R"==(++i, idx += IC) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(diff_d[i] = diff_d[i] - exp(dst_[i]) * sbr;)==""\n"
R"==(#else)==""\n"
R"==(diff_d[i] = (diff_d[i] - sbr) * dst_[i];)==""\n"
R"==(#endif)==""\n"
R"==(diff_src[idx] = COMMON_X_TO_DATA(SRC, diff_d[i]);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const int data_off = (get_global_id(0) / GROUP_SIZE) * SOFTMAX_AXIS_SIZE;)==""\n"
R"==(COMMON_DATA_T sbr = COMMON_DATA_ZERO;)==""\n"
R"==(COMMON_DATA8_T diff_d[NUM_BUF];)==""\n"
R"==(COMMON_DATA8_T dst_[NUM_BUF];)==""\n"
R"==(diff_dst += data_off;)==""\n"
R"==(dst += data_off;)==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) {)==""\n"
R"==(diff_d[k] = COMMON_LOAD_DATA8()==""\n"
R"==(DST, &diff_dst[k * VECT_SIZE * SUB_GROUP_SIZE]);)==""\n"
R"==(dst_[k] = COMMON_LOAD_DATA8(DST, &dst[k * VECT_SIZE * SUB_GROUP_SIZE]);)==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(sbr += diff_d[k][i];)==""\n"
R"==(#else)==""\n"
R"==(sbr += dst_[k][i] * diff_d[k][i];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(sbr = sub_group_reduce_add(sbr);)==""\n"
R"==(diff_src += data_off;)==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(diff_d[k] = diff_d[k] - exp(dst_[k]) * sbr;)==""\n"
R"==(#else)==""\n"
R"==(diff_d[k] = (diff_d[k] - sbr) * dst_[k];)==""\n"
R"==(#endif)==""\n"
R"==(COMMON_STORE_DATA8()==""\n"
R"==(SRC, &diff_src[k * VECT_SIZE * SUB_GROUP_SIZE], diff_d[k]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}