namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *micro_sdpa_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/sdpa_utils.h")==""\n"
R"==(#include "gpu/intel/ocl/tile_ops.h")==""\n"
R"==(/* Microkernel headers -- generated at runtime */)==""\n"
R"==(#include "gemm_kq.h")==""\n"
R"==(#include "gemm_vs.h")==""\n"
R"==(/* The quantization parameter may be unique for each token/element */)==""\n"
R"==(#define QUANTIZE_2D 2)==""\n"
R"==(/* The quantization parameter shares the same value across the work-group */)==""\n"
R"==(#define QUANTIZE_COMMON 3)==""\n"
R"==(#define MAX(a, b) ((a) > (b) ? (a) : (b)))==""\n"
R"==(#define DIV_UP(x, y) (((x) + (y)-1) / (y)))==""\n"
R"==(#define sg_per_wg (ugemm_kq_sg_per_wg_m * ugemm_kq_sg_per_wg_n))==""\n"
R"==(#define q_tile_sg_n DIV_UP(ugemm_kq_wg_tile_n, sg_per_wg))==""\n"
R"==(/* Instantiate tile types and operations */)==""\n"
R"==(typedef ugemm_kq_c_type s_tile_type;)==""\n"
R"==(typedef ugemm_vs_c_type a_tile_type;)==""\n"
R"==(#ifdef QRY_DT_F16)==""\n"
R"==(#define VEC_TYPE2 half2)==""\n"
R"==(#elif defined(QRY_DT_BF16))==""\n"
R"==(#define VEC_TYPE2 ushort2)==""\n"
R"==(#else)==""\n"
R"==(#error "Data type not supported for VEC_TYPE2")==""\n"
R"==(#endif)==""\n"
R"==(#ifdef SCALE_DT_BF16)==""\n"
R"==(#define SCALES_TO_FLOAT cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define SCALES_TO_FLOAT convert_float)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef VAL_ATTR_SCALES_DT_BF16)==""\n"
R"==(#define VAL_SCALES_TO_FLOAT cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define VAL_SCALES_TO_FLOAT convert_float)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_ATTR_SCALES_DT_BF16)==""\n"
R"==(#define KEY_SCALES_TO_FLOAT cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define KEY_SCALES_TO_FLOAT convert_float)==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_2D_TILE(q_tile_type, uint, SUBGROUP_SIZE, D_MAX / 2, 1, 1, q_tile_sg_n))==""\n"
R"==(#ifdef BLOCK_Q)==""\n"
R"==(DECLARE_2D_TILE_BLOCK_OPS()==""\n"
R"==(q_tile_type, uint, SUBGROUP_SIZE, D_MAX / 2, 1, 1, q_tile_sg_n))==""\n"
R"==(#elif Q_ALIGN < 4)==""\n"
R"==(DECLARE_2D_TILE_LOAD_PACKED_VEC(q_tile_type, QRY_DATA_T, VEC_TYPE2,)==""\n"
R"==(SUBGROUP_SIZE, D_MAX / 2, 1, 1, q_tile_sg_n))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef BLOCK_A)==""\n"
R"==(DECLARE_2D_TILE(a_tile_type_dst, DST_DATA_T, SUBGROUP_SIZE, ugemm_vs_sg_tile_m,)==""\n"
R"==(1, 1, ugemm_vs_sg_tile_n))==""\n"
R"==(#else)==""\n"
R"==(DECLARE_2D_TILE(a_tile_type_dst, DST_DATA_T, SUBGROUP_SIZE, ugemm_vs_sg_tile_m,)==""\n"
R"==(8, 1, ugemm_vs_sg_tile_n / 8))==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_2D_TILE(s_tile_type_packed, uint, SUBGROUP_SIZE, ugemm_kq_c_type_block0,)==""\n"
R"==(ugemm_kq_c_type_block1 / 2, ugemm_kq_c_type_nblock0,)==""\n"
R"==(ugemm_kq_c_type_nblock1))==""\n"
R"==(DECLARE_2D_TILE()==""\n"
R"==(s_sum_tile_type, float, SUBGROUP_SIZE, ugemm_kq_sg_tile_n, 1, 1, 1))==""\n"
R"==(DECLARE_2D_TILE()==""\n"
R"==(a_scale_tile_type, float, SUBGROUP_SIZE, ugemm_vs_sg_tile_n, 1, 1, 1))==""\n"
R"==(#if BROADCAST_MASK_Q)==""\n"
R"==(#define mask_br ugemm_kq_sg_tile_m)==""\n"
R"==(#define mask_bc 1)==""\n"
R"==(#define mask_nbr 1)==""\n"
R"==(#define mask_nbc 1)==""\n"
R"==(#else)==""\n"
R"==(#define mask_br ugemm_kq_c_type_block0)==""\n"
R"==(#define mask_bc ugemm_kq_c_type_block1)==""\n"
R"==(#define mask_nbr ugemm_kq_c_type_nblock0)==""\n"
R"==(#define mask_nbc ugemm_kq_c_type_nblock1)==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_2D_TILE(kmask_tile_type_float, float, SUBGROUP_SIZE, ugemm_kq_sg_tile_m,)==""\n"
R"==(1, 1, 1))==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(DECLARE_2D_TILE(mask_tile_type, MSK_DATA_T, SUBGROUP_SIZE, mask_br, mask_bc,)==""\n"
R"==(mask_nbr, mask_nbc))==""\n"
R"==(#if BROADCAST_MASK_Q)==""\n"
R"==(DECLARE_2D_TILE_BLOCK_OPS(mask_tile_type, MSK_DATA_T, SUBGROUP_SIZE, mask_br,)==""\n"
R"==(mask_bc, mask_nbr, mask_nbc))==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_2D_TILE(mask_tile_type_float, float, SUBGROUP_SIZE, mask_br, mask_bc,)==""\n"
R"==(mask_nbr, mask_nbc))==""\n"
R"==(DECLARE_2D_TILE_COPY_REBLOCK(mask_tile_type, SUBGROUP_SIZE, mask_br, mask_bc,)==""\n"
R"==(mask_nbr, mask_nbc, mask_tile_type_float, SUBGROUP_SIZE, mask_br,)==""\n"
R"==(mask_bc, mask_nbr, mask_nbc, CONVERT_FLOAT_T))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef BLOCK_A)==""\n"
R"==(DECLARE_2D_TILE_BLOCK_OPS(a_tile_type_dst, DST_DATA_T, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_vs_sg_tile_m, 1, 1, ugemm_vs_sg_tile_n))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef BLOCK_2D_A)==""\n"
R"==(DECLARE_2D_TILE_BLOCK2D_OPS(a_tile_type_dst, DST_DATA_T, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_vs_sg_tile_m, 8, 1, ugemm_vs_sg_tile_n / 8))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef BLOCK_A)==""\n"
R"==(DECLARE_2D_TILE_COPY_REBLOCK(a_tile_type, SUBGROUP_SIZE, ugemm_vs_c_type_block0,)==""\n"
R"==(ugemm_vs_c_type_block1, ugemm_vs_c_type_nblock0,)==""\n"
R"==(ugemm_vs_c_type_nblock1, a_tile_type_dst, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_vs_sg_tile_m, 1, 1, ugemm_vs_sg_tile_n, CONVERT_DATA_T))==""\n"
R"==(#else)==""\n"
R"==(DECLARE_2D_TILE_COPY_REBLOCK(a_tile_type, SUBGROUP_SIZE, ugemm_vs_c_type_block0,)==""\n"
R"==(ugemm_vs_c_type_block1, ugemm_vs_c_type_nblock0,)==""\n"
R"==(ugemm_vs_c_type_nblock1, a_tile_type_dst, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_vs_sg_tile_m, 8, 1, ugemm_vs_sg_tile_n / 8, CONVERT_DATA_T))==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_2D_TILE_VREDUCE(s_tile_type, SUBGROUP_SIZE, ugemm_kq_c_type_block0,)==""\n"
R"==(ugemm_kq_c_type_block1, ugemm_kq_c_type_nblock0,)==""\n"
R"==(ugemm_kq_c_type_nblock1, s_sum_tile_type, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_kq_sg_tile_n, 1, 1, 1))==""\n"
R"==(DECLARE_2D_TILE_HREDUCE(s_tile_type, SUBGROUP_SIZE, ugemm_kq_c_type_block0,)==""\n"
R"==(ugemm_kq_c_type_block1, ugemm_kq_c_type_nblock0,)==""\n"
R"==(ugemm_kq_c_type_nblock1, kmask_tile_type_float, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_kq_sg_tile_m, 1, 1, 1))==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(DECLARE_2D_TILE_HREDUCE(s_tile_type, SUBGROUP_SIZE, ugemm_kq_c_type_block0,)==""\n"
R"==(ugemm_kq_c_type_block1, ugemm_kq_c_type_nblock0,)==""\n"
R"==(ugemm_kq_c_type_nblock1, mask_tile_type_float, SUBGROUP_SIZE, mask_br,)==""\n"
R"==(mask_bc, mask_nbr, mask_nbc))==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_2D_TILE_HREDUCE(a_tile_type, SUBGROUP_SIZE, ugemm_vs_c_type_block0,)==""\n"
R"==(ugemm_vs_c_type_block1, ugemm_vs_c_type_nblock0,)==""\n"
R"==(ugemm_vs_c_type_nblock1, a_scale_tile_type, SUBGROUP_SIZE,)==""\n"
R"==(ugemm_vs_sg_tile_n, 1, 1, 1))==""\n"
R"==(#if ugemm_kq_wg_tile_n == ugemm_vs_wg_tile_n \)==""\n"
R"==(&& (ugemm_kq_sg_tile_n % ugemm_vs_sg_tile_n) == 0)==""\n"
R"==(DECLARE_2D_TILE_RSELECT(a_scale_tile_type, SUBGROUP_SIZE, ugemm_vs_sg_tile_n, 1,)==""\n"
R"==(1, 1, s_sum_tile_type, SUBGROUP_SIZE, ugemm_kq_sg_tile_n, 1, 1, 1))==""\n"
R"==(#endif)==""\n"
R"==(#if PREFETCH_REMAINDER)==""\n"
R"==(#define cooperative_prefetch_2d_maybe_rem cooperative_prefetch_2d_rem)==""\n"
R"==(#else)==""\n"
R"==(#define cooperative_prefetch_2d_maybe_rem( \)==""\n"
R"==(ptr, r, c, rmax, cmax, ld, sg_id, n_sg, sg_size, caching) \)==""\n"
R"==(cooperative_prefetch_2d(ptr, rmax, cmax, ld, sg_id, n_sg, sg_size, caching))==""\n"
R"==(#endif)==""\n"
R"==(#if TRANSPOSE_K)==""\n"
R"==(#define cooperative_prefetch_2d_k( \)==""\n"
R"==(ptr, r, c, rmax, cmax, ld, sg_id, n_sg, sg_size, caching) \)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem( \)==""\n"
R"==(ptr, c, r, cmax, rmax, ld, sg_id, n_sg, sg_size, caching))==""\n"
R"==(#else)==""\n"
R"==(#define cooperative_prefetch_2d_k cooperative_prefetch_2d_maybe_rem)==""\n"
R"==(#endif)==""\n"
R"==(#if REMAINDER_Q)==""\n"
R"==(#define tile_load_block_rem_q tile_load_block)==""\n"
R"==(#define tile_store_block_rem_q tile_store_block)==""\n"
R"==(#else)==""\n"
R"==(#define tile_load_block_rem_q(t, ptr, n, ld, off_r, off_c) \)==""\n"
R"==(tile_load_block(t, ptr, ld, off_r, off_c))==""\n"
R"==(#define tile_store_block_rem_q(t, ptr, n, ld, off_r, off_c) \)==""\n"
R"==(tile_store_block(t, ptr, ld, off_r, off_c))==""\n"
R"==(#endif)==""\n"
R"==(#define binary_add(x, y) ((x) + (y)))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) kernel void)==""\n"
R"==(micro_sdpa(const global KEY_DATA_T *K, const global QRY_DATA_T *Q,)==""\n"
R"==(const global VAL_DATA_T *V, global DST_DATA_T *A,)==""\n"
R"==(const global SCALE_DATA_T *scale_ptr, int d, int k, int q,)==""\n"
R"==(const global KEY_ATTR_SCALES_DATA_T *K_scales,)==""\n"
R"==(const global KEY_ATTR_ZP_DATA_T *K_zp,)==""\n"
R"==(const global VAL_ATTR_SCALES_DATA_T *V_scales,)==""\n"
R"==(const global VAL_ATTR_ZP_DATA_T *V_zp)==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(,)==""\n"
R"==(const global MSK_DATA_T *msk)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(uint sg_ij = sub_group_broadcast(get_local_id(1), 0);)==""\n"
R"==(uint b0 = get_group_id(1);)==""\n"
R"==(uint b1 = get_group_id(2);)==""\n"
R"==(uint b0_kv = b0 / KV_GROUP_SIZE;)==""\n"
R"==(uint wg_j0 = get_group_id(0) * ugemm_kq_wg_tile_n;)==""\n"
R"==(/* Leading dimension for matrices */)==""\n"
R"==(uint ldk = TRANSPOSE_K ? KEY_S3 : KEY_S2;)==""\n"
R"==(uint ldq = QRY_S2;)==""\n"
R"==(uint ldv = VAL_S2;)==""\n"
R"==(uint lda = DST_S2;)==""\n"
R"==(#if KEY_SCALES || KEY_ZERO_POINTS)==""\n"
R"==(uint ldkq = KEY_D3;)==""\n"
R"==(uint num_key_groups = d / KEY_GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_SCALES || VAL_ZERO_POINTS)==""\n"
R"==(uint ldvq = div_up(d, VAL_GROUP_SIZE);)==""\n"
R"==(uint num_val_groups = d / VAL_GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(/* Subgroup IDs for each GEMM */)==""\n"
R"==(uint sg_i_kq = sg_ij % ugemm_kq_sg_per_wg_m;)==""\n"
R"==(uint sg_j_kq = sg_ij / ugemm_kq_sg_per_wg_m;)==""\n"
R"==(uint sg_i_vs = sg_ij % ugemm_vs_sg_per_wg_m;)==""\n"
R"==(uint sg_j_vs = sg_ij / ugemm_vs_sg_per_wg_m;)==""\n"
R"==(/* SLM allocations -- place in one array to work around compiler bug */)==""\n"
R"==(#define Q_slm_size (D_MAX * ugemm_kq_wg_tile_n * sizeof(QRY_DATA_T)))==""\n"
R"==(#define S_slm_size \)==""\n"
R"==((ugemm_kq_wg_tile_m * ugemm_kq_wg_tile_n * sizeof(QRY_DATA_T)))==""\n"
R"==(#define S_sum_slm_size \)==""\n"
R"==((ugemm_kq_wg_tile_n * ugemm_kq_sg_per_wg_m * sizeof(float)))==""\n"
R"==(#define S_max_slm_size (ugemm_kq_wg_tile_n * sizeof(float)))==""\n"
R"==(#define ugemm_slm_size MAX(ugemm_kq_slm_size, ugemm_vs_slm_size))==""\n"
R"==(local char slm[Q_slm_size + S_slm_size + S_sum_slm_size + S_max_slm_size)==""\n"
R"==(+ ugemm_slm_size];)==""\n"
R"==(local QRY_DATA_T *Q_slm = (local QRY_DATA_T *)&slm[0];)==""\n"
R"==(local QRY_DATA_T *S_slm = (local QRY_DATA_T *)&slm[Q_slm_size];)==""\n"
R"==(local float *S_sum_slm = (local float *)&slm[Q_slm_size + S_slm_size];)==""\n"
R"==(local float *S_max_slm)==""\n"
R"==(= (local float *)&slm[Q_slm_size + S_slm_size + S_sum_slm_size];)==""\n"
R"==(local uint *ugemm_slm = (local uint *)&slm[Q_slm_size + S_slm_size)==""\n"
R"==(+ S_sum_slm_size + S_max_slm_size];)==""\n"
R"==(const bool need_sum_barrier = (ugemm_vs_barrier_count == 0);)==""\n"
R"==(/* Locate K/Q/V/A matrices within batch */)==""\n"
R"==(K += KEY_OFF(b1, b0_kv, 0, 0) / KEY_ELEMENTS_PER_BYTE;)==""\n"
R"==(Q += QRY_OFF(b1, b0, 0, 0);)==""\n"
R"==(V += VAL_OFF(b1, b0_kv, 0, 0) / VAL_ELEMENTS_PER_BYTE;)==""\n"
R"==(A += DST_OFF(b1, b0, 0, 0, 0);)==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(uint ldmsk = MSK_S2;)==""\n"
R"==(msk += MSK_OFF(b1 % MSK_D0, b0 % MSK_D1, 0, 0);)==""\n"
R"==(#ifndef BLOCK_MSK)==""\n"
R"==(int mask_aligned = (((size_t)msk) % 4) == 0;)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_SCALES)==""\n"
R"==(K_scales += KEY_OFF(b1, b0_kv, 0, 0) / KEY_GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_SCALES == QUANTIZE_COMMON)==""\n"
R"==(float k_scale = KEY_SCALES_TO_FLOAT(*K_scales);)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_ZERO_POINTS)==""\n"
R"==(K_zp += KEY_OFF(b1, b0_kv, 0, 0) / KEY_GROUP_SIZE)==""\n"
R"==(/ KEY_ZP_ELEMENTS_PER_BYTE;)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_SCALES)==""\n"
R"==(V_scales += VAL_OFF(b1, b0_kv, 0, 0) / VAL_GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_SCALES == QUANTIZE_COMMON)==""\n"
R"==(float v_scale = VAL_SCALES_TO_FLOAT(*V_scales);)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_ZERO_POINTS)==""\n"
R"==(V_zp += VAL_OFF(b1, b0_kv, 0, 0) / VAL_GROUP_SIZE)==""\n"
R"==(/ VAL_ZP_ELEMENTS_PER_BYTE;)==""\n"
R"==(#endif)==""\n"
R"==(/* Load Q tile, destined for SLM */)==""\n"
R"==(q_tile_type Q_tile;)==""\n"
R"==(uint q0_copy = q_tile_sg_n * sg_ij;)==""\n"
R"==(#ifdef BLOCK_Q)==""\n"
R"==(tile_load_block_rem_q()==""\n"
R"==(&Q_tile, (global uint *)Q, q, ldq >> 1, 0, wg_j0 + q0_copy);)==""\n"
R"==(#elif Q_ALIGN >= 4)==""\n"
R"==(tile_load(&Q_tile, (global uint *)Q, (d + 1) >> 1, q, ldq >> 1, 0,)==""\n"
R"==(wg_j0 + q0_copy);)==""\n"
R"==(#else)==""\n"
R"==(tile_load_packed_vec2(&Q_tile, Q, d, q, ldq, 0, wg_j0 + q0_copy);)==""\n"
R"==(#endif)==""\n"
R"==(/* Load scale */)==""\n"
R"==(#if WITH_ATTN_SCALE)==""\n"
R"==(#if INVERT_SCALE)==""\n"
R"==(float iscale = SCALES_TO_FLOAT(*scale_ptr);)==""\n"
R"==(float scale = native_recip(iscale);)==""\n"
R"==(#else)==""\n"
R"==(float scale = SCALES_TO_FLOAT(*scale_ptr);)==""\n"
R"==(float iscale = native_recip(scale);)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(float scale = 1.0;)==""\n"
R"==(float iscale = 1.0;)==""\n"
R"==(#endif)==""\n"
R"==(scale *= 1.442695f; )==""\n"
R"==(#ifdef PREFETCH_K0)==""\n"
R"==(/* Prefetch first K tile. */)==""\n"
R"==(cooperative_prefetch_2d_k()==""\n"
R"==(/* ptr */ K,)==""\n"
R"==(/* r */ k,)==""\n"
R"==(/* c */ d,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ PREFETCH_D_MAX,)==""\n"
R"==(/* ld */ ldk,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#if KEY_SCALES == QUANTIZE_2D)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ K_scales,)==""\n"
R"==(/* r */ k,)==""\n"
R"==(/* c */ num_key_groups,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ D_MAX / KEY_GROUP_SIZE,)==""\n"
R"==(/* ld */ ldkq,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_ZERO_POINTS == QUANTIZE_2D)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ K_zp,)==""\n"
R"==(/* r */ k,)==""\n"
R"==(/* c */ num_key_groups,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ D_MAX / KEY_GROUP_SIZE,)==""\n"
R"==(/* ld */ ldkq,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(/* Initialize S column sums in SLM to -inf */)==""\n"
R"==(const uint n_col_sg = DIV_UP(ugemm_kq_wg_tile_n, SUBGROUP_SIZE * sg_per_wg);)==""\n"
R"==(const float neg_inf = -INFINITY;)==""\n"
R"==(#pragma unroll)==""\n"
R"==(for (int q = 0; q < n_col_sg; q++))==""\n"
R"==(intel_sub_group_block_write()==""\n"
R"==((local uint *)&S_max_slm[(q + sg_ij * n_col_sg))==""\n"
R"==(* SUBGROUP_SIZE],)==""\n"
R"==(as_uint(neg_inf));)==""\n"
R"==(/* Clear accumulator */)==""\n"
R"==(a_tile_type A_tile;)==""\n"
R"==(tile_fill(A_tile, 0.0f);)==""\n"
R"==(/* Store Q tile to SLM */)==""\n"
R"==(tile_store_t_sys_src1()==""\n"
R"==(Q_tile, (local uint *)&Q_slm[0], D_MAX / 2, q0_copy, 0);)==""\n"
R"==(/* Clear S column sums/maxes */)==""\n"
R"==(s_sum_tile_type S_sum_tile;)==""\n"
R"==(s_sum_tile_type S_max_tile, S_max_tile_old;)==""\n"
R"==(tile_fill(S_sum_tile, 0.0f);)==""\n"
R"==(tile_fill(S_max_tile, -INFINITY);)==""\n"
R"==(/* Wait for Q data to reach SLM */)==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(/* Main loop over k blocks */)==""\n"
R"==(for (int k0 = 0; k0 < k; k0 += ugemm_kq_wg_tile_m) {)==""\n"
R"==(bool first = (k0 == 0);)==""\n"
R"==(bool last = (k0 + ugemm_kq_wg_tile_m >= k);)==""\n"
R"==(uint sg_i0_kq = sg_i_kq * ugemm_kq_sg_tile_m;)==""\n"
R"==(uint sg_j0_kq = sg_j_kq * ugemm_kq_sg_tile_n;)==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(/* Load mask. No remainder handling needed assuming k block size is a power of 2. */)==""\n"
R"==(mask_tile_type mask_tile;)==""\n"
R"==(#if BROADCAST_MASK_Q)==""\n"
R"==(#if BLOCK_MSK)==""\n"
R"==(tile_load_block(&mask_tile, msk, 0, k0 + sg_i0_kq, 0);)==""\n"
R"==(#else)==""\n"
R"==(if (mask_aligned) {)==""\n"
R"==(tile_load_block(&mask_tile, msk, 0, k0 + sg_i0_kq, 0);)==""\n"
R"==(} else {)==""\n"
R"==(tile_load_full(&mask_tile, msk, 0, k0 + sg_i0_kq, 0);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(tile_load_t(&mask_tile, msk, q, k, sg_j0_kq + wg_j0, k0 + sg_i0_kq);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if REMAINDER_K)==""\n"
R"==(/* Prepare k mask: NaN in bounds, -inf out of bounds */)==""\n"
R"==(kmask_tile_type_float k_mask;)==""\n"
R"==(#pragma unroll)==""\n"
R"==(for (int ii = 0; ii < ugemm_kq_sg_tile_m / SUBGROUP_SIZE; ii++))==""\n"
R"==(k_mask.x[0][ii] = (k0 + sg_i0_kq + ii * SUBGROUP_SIZE)==""\n"
R"==(+ get_sub_group_local_id())==""\n"
R"==(< k))==""\n"
R"==(? nan(0u))==""\n"
R"==(: -INFINITY;)==""\n"
R"==(#endif)==""\n"
R"==(/* Calculate S = (K^T) * Q */)==""\n"
R"==(s_tile_type S_tile)==""\n"
R"==(= ugemm_kq(K, ldk, Q_slm, D_MAX, k, ugemm_kq_wg_tile_n, d, k0,)==""\n"
R"==(0, 0, sg_i_kq, sg_j_kq, (local char *)ugemm_slm)==""\n"
R"==(#if KEY_SCALES == QUANTIZE_2D)==""\n"
R"==(,)==""\n"
R"==(K_scales)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_ZERO_POINTS)==""\n"
R"==(,)==""\n"
R"==(K_zp)==""\n"
R"==(#endif)==""\n"
R"==(#if (KEY_SCALES == QUANTIZE_2D) || KEY_ZERO_POINTS)==""\n"
R"==(,)==""\n"
R"==(ldkq)==""\n"
R"==(#endif)==""\n"
R"==();)==""\n"
R"==(#if KEY_SCALES == QUANTIZE_COMMON)==""\n"
R"==(#define k_scale_op(x) ((x)*k_scale))==""\n"
R"==(tile_elementwise(S_tile, k_scale_op);)==""\n"
R"==(#endif)==""\n"
R"==(/* Apply attention mask */)==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(#define unscale(x) ((x)*iscale))==""\n"
R"==(mask_tile_type_float mask_tile_float;)==""\n"
R"==(tile_copy_reblock(mask_tile, &mask_tile_float);)==""\n"
R"==(#if WITH_ATTN_SCALE)==""\n"
R"==(tile_elementwise(mask_tile_float, unscale);)==""\n"
R"==(#endif)==""\n"
R"==(#if BROADCAST_MASK_Q)==""\n"
R"==(tile_hbroadcast_add(&S_tile, mask_tile_float);)==""\n"
R"==(#else)==""\n"
R"==(tile_binary(S_tile, mask_tile_float, binary_add);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(/* Apply k mask */)==""\n"
R"==(#if REMAINDER_K)==""\n"
R"==(tile_hbroadcast_min(&S_tile, k_mask);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_CAUSAL_MASK)==""\n"
R"==(#define greater_than(offset_k, offset_q) (offset_k > offset_q))==""\n"
R"==(/* Apply causal mask */)==""\n"
R"==(tile_predicated_assignment_t(S_tile, k0 + sg_i0_kq, wg_j0 + sg_j0_kq,)==""\n"
R"==(greater_than, -INFINITY, SUBGROUP_SIZE, ugemm_kq_c_type_block0,)==""\n"
R"==(ugemm_kq_c_type_block1, ugemm_kq_c_type_nblock0,)==""\n"
R"==(ugemm_kq_c_type_nblock1);)==""\n"
R"==(#endif)==""\n"
R"==(/* Before softmax, we will need to scale columns by maximum values to avoid overflow. */)==""\n"
R"==(/* Compute our maxima and reduce across SLM */)==""\n"
R"==(tile_vreduce_max(S_tile, &S_max_tile);)==""\n"
R"==(tile_atomic_max_full()==""\n"
R"==(S_max_tile, S_max_slm, ugemm_kq_wg_tile_n, sg_j0_kq, 0);)==""\n"
R"==(intel_work_group_barrier_arrive(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(int k_chunk = min(k - k0, ugemm_kq_wg_tile_m);)==""\n"
R"==(#ifdef PREFETCH_V)==""\n"
R"==(/* Prefetch V tile. */)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ V,)==""\n"
R"==(/* r */ d,)==""\n"
R"==(/* c */ k - k0,)==""\n"
R"==(/* rmax */ PREFETCH_D_MAX,)==""\n"
R"==(/* cmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* ld */ ldv,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#if VAL_SCALES == QUANTIZE_2D)==""\n"
R"==(/* Prefetch V scales. */)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ V_scales,)==""\n"
R"==(/* r */ num_val_groups,)==""\n"
R"==(/* c */ k - k0,)==""\n"
R"==(/* rmax */ PREFETCH_D_MAX / VAL_GROUP_SIZE,)==""\n"
R"==(/* cmax */ k_chunk,)==""\n"
R"==(/* ld */ ldvq,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_ZERO_POINTS == QUANTIZE_2D)==""\n"
R"==(/* Prefetch V zero points. */)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ V_zp,)==""\n"
R"==(/* r */ num_val_groups,)==""\n"
R"==(/* c */ k - k0,)==""\n"
R"==(/* rmax */ PREFETCH_D_MAX / VAL_GROUP_SIZE,)==""\n"
R"==(/* cmax */ k_chunk,)==""\n"
R"==(/* ld */ ldvq,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifndef ALT_MAX)==""\n"
R"==(/* Read back WG-wide maxima */)==""\n"
R"==(intel_work_group_barrier_wait(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(tile_load_full(&S_max_tile, S_max_slm, ugemm_kq_wg_tile_n, sg_j0_kq, 0);)==""\n"
R"==(#endif)==""\n"
R"==(tile_vbroadcast_sub(&S_tile, S_max_tile);)==""\n"
R"==(/* Scale + exponentiate */)==""\n"
R"==(#define scaled_exp(x) native_vexp2(x *scale))==""\n"
R"==(tile_elementwise(S_tile, scaled_exp);)==""\n"
R"==(#ifdef ALT_MAX)==""\n"
R"==(/* Read back WG-wide maxima and adjust S to match */)==""\n"
R"==(intel_work_group_barrier_wait(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(s_sum_tile_type S_max_tile1;)==""\n"
R"==(tile_copy(S_max_tile, S_max_tile1);)==""\n"
R"==(tile_load_full(&S_max_tile, S_max_slm, ugemm_kq_wg_tile_n, sg_j0_kq, 0);)==""\n"
R"==(#define binary_exp_neg(x, y) native_vexp2(scale *((x) - (y))))==""\n"
R"==(tile_binary(S_max_tile1, S_max_tile, binary_exp_neg);)==""\n"
R"==(tile_vbroadcast_mul(&S_tile, S_max_tile1);)==""\n"
R"==(#endif)==""\n"
R"==(/* Accumulate sums. S tile is transposed for easy summation. */)==""\n"
R"==(s_sum_tile_type S_sum_tile1;)==""\n"
R"==(tile_fill(S_sum_tile1, 0.0f);)==""\n"
R"==(tile_vreduce_add(S_tile, &S_sum_tile1);)==""\n"
R"==(/* Convert to half or bf16, VNNI format */)==""\n"
R"==(s_tile_type_packed S_tile_packed;)==""\n"
R"==(tile_copy_to_vec2(S_tile, S_tile_packed, VEC_TYPE2);)==""\n"
R"==(/* Store to SLM, in packed format */)==""\n"
R"==(tile_store_t_sys_src2(S_tile_packed, (local uint *)S_slm,)==""\n"
R"==(ugemm_vs_sg_tile_n, ugemm_kq_wg_tile_m / 2, sg_i0_kq / 2,)==""\n"
R"==(sg_j0_kq);)==""\n"
R"==(intel_work_group_barrier_arrive(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(/* Rescale existing accumulator and sums to match new maxima */)==""\n"
R"==(if (!first) {)==""\n"
R"==(#define binary_exp_sub(x, y) native_vexp2(scale *((x) - (y))))==""\n"
R"==(#define binary_mul(x, y) ((x) * (y)))==""\n"
R"==(tile_binary(S_max_tile_old, S_max_tile, binary_exp_sub);)==""\n"
R"==(tile_binary(S_sum_tile, S_max_tile_old, binary_mul);)==""\n"
R"==(/* Find the subset of sums that applies to the accumulation tile */)==""\n"
R"==(a_scale_tile_type A_scale_tile;)==""\n"
R"==(#if ugemm_kq_wg_tile_n == ugemm_vs_wg_tile_n \)==""\n"
R"==(&& ugemm_kq_sg_tile_n == ugemm_vs_sg_tile_n)==""\n"
R"==(tile_copy(S_max_tile_old, A_scale_tile);)==""\n"
R"==(#elif ugemm_kq_wg_tile_n == ugemm_vs_wg_tile_n \)==""\n"
R"==(&& (ugemm_kq_sg_tile_n % ugemm_vs_sg_tile_n) == 0)==""\n"
R"==(tile_rselect(&A_scale_tile, S_max_tile_old,)==""\n"
R"==(sg_j_vs % (ugemm_kq_sg_tile_n / ugemm_vs_sg_tile_n));)==""\n"
R"==(#else)==""\n"
R"==(#error unimplemented)==""\n"
R"==(#endif)==""\n"
R"==(tile_hbroadcast_mul(&A_tile, A_scale_tile);)==""\n"
R"==(})==""\n"
R"==(/* Accumulate sums */)==""\n"
R"==(tile_binary(S_sum_tile, S_sum_tile1, binary_add);)==""\n"
R"==(/* Save maxima */)==""\n"
R"==(tile_copy(S_max_tile, S_max_tile_old);)==""\n"
R"==(/* Last iteration: store column sums in SLM */)==""\n"
R"==(if (last) {)==""\n"
R"==(tile_store_full(S_sum_tile, S_sum_slm, ugemm_kq_wg_tile_n, sg_j0_kq,)==""\n"
R"==(sg_i_kq);)==""\n"
R"==(})==""\n"
R"==(#ifdef PREFETCH_K)==""\n"
R"==(/* Prefetch next K tile. */)==""\n"
R"==(if (!last) {)==""\n"
R"==(#if TRANSPOSE_K)==""\n"
R"==(const uint stride_k = ldk;)==""\n"
R"==(#else)==""\n"
R"==(const uint stride_k = 1;)==""\n"
R"==(#endif)==""\n"
R"==(cooperative_prefetch_2d_k()==""\n"
R"==(/* ptr */ K + (k0 + ugemm_kq_wg_tile_m) * stride_k,)==""\n"
R"==(/* r */ k - k0 - ugemm_kq_wg_tile_m,)==""\n"
R"==(/* c */ d,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ D_MAX,)==""\n"
R"==(/* ld*/ ldk,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache*/ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#if KEY_SCALES == QUANTIZE_2D)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ K_scales + (k0 + ugemm_kq_wg_tile_m),)==""\n"
R"==(/* r */ k - k0 - ugemm_kq_wg_tile_m,)==""\n"
R"==(/* c */ num_key_groups,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ D_MAX / KEY_GROUP_SIZE,)==""\n"
R"==(/* ld */ ldkq,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(#if KEY_ZERO_POINTS == QUANTIZE_2D)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ K_zp + (k0 + ugemm_kq_wg_tile_m),)==""\n"
R"==(/* r */ k - k0 - ugemm_kq_wg_tile_m,)==""\n"
R"==(/* c */ num_key_groups,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ D_MAX / KEY_GROUP_SIZE,)==""\n"
R"==(/* ld */ ldkq,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_ATTN_MASK && defined(PREFETCH_MASK))==""\n"
R"==(/* Prefetch next mask tile. */)==""\n"
R"==(if (!last) {)==""\n"
R"==(#if BROADCAST_MASK_Q)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ msk + k0 + ugemm_kq_wg_tile_m,)==""\n"
R"==(/* r */ k - k0,)==""\n"
R"==(/* c */ 1,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ 1,)==""\n"
R"==(/* ld */ 0,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1C_L3C);)==""\n"
R"==(#else)==""\n"
R"==(cooperative_prefetch_2d_maybe_rem()==""\n"
R"==(/* ptr */ msk + k0 + ugemm_kq_sg_tile_m + (wg_j0)*ldmsk,)==""\n"
R"==(/* r */ k - k0 - ugemm_kq_wg_tile_m,)==""\n"
R"==(/* c */ q - wg_j0,)==""\n"
R"==(/* rmax */ ugemm_kq_wg_tile_m,)==""\n"
R"==(/* cmax */ (ugemm_kq_wg_tile_n * PREFETCH_D_MAX) / D_MAX,)==""\n"
R"==(/* ld */ ldmsk,)==""\n"
R"==(/* sg_id */ sg_ij,)==""\n"
R"==(/* n_sg */ sg_per_wg,)==""\n"
R"==(/* sg_size */ SUBGROUP_SIZE,)==""\n"
R"==(/* cache */ LSC_LDCC_L1UC_L3C);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(/* Wait for S stores */)==""\n"
R"==(intel_work_group_barrier_wait(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(/* Last iteration: signal column sums are ready */)==""\n"
R"==(if (last && need_sum_barrier))==""\n"
R"==(intel_work_group_barrier_arrive(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(/* Accumulate A += V * S */)==""\n"
R"==(a_tile_type A_tile1 = ugemm_vs()==""\n"
R"==(V, ldv, S_slm, ugemm_kq_wg_tile_m, d, ugemm_kq_wg_tile_n,)==""\n"
R"==(k_chunk, 0, 0, 0, sg_i_vs, sg_j_vs, (local char *)ugemm_slm)==""\n"
R"==(#if VAL_SCALES == QUANTIZE_2D)==""\n"
R"==(,)==""\n"
R"==(V_scales)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_ZERO_POINTS)==""\n"
R"==(,)==""\n"
R"==(V_zp)==""\n"
R"==(#endif)==""\n"
R"==(#if (VAL_SCALES == QUANTIZE_2D) || VAL_ZERO_POINTS)==""\n"
R"==(,)==""\n"
R"==(ldvq)==""\n"
R"==(#endif)==""\n"
R"==();)==""\n"
R"==(V += ldv * ugemm_kq_wg_tile_m / VAL_ELEMENTS_PER_BYTE;)==""\n"
R"==(#if VAL_SCALES == QUANTIZE_2D)==""\n"
R"==(V_scales += ldvq * ugemm_kq_wg_tile_m;)==""\n"
R"==(#endif)==""\n"
R"==(#if VAL_ZERO_POINTS == QUANTIZE_2D)==""\n"
R"==(V_zp += ldvq * ugemm_kq_wg_tile_m / VAL_ZP_ELEMENTS_PER_BYTE;)==""\n"
R"==(#endif)==""\n"
R"==(tile_binary(A_tile, A_tile1, binary_add);)==""\n"
R"==(})==""\n"
R"==(/* Wait for column sums to be ready */)==""\n"
R"==(if (need_sum_barrier) intel_work_group_barrier_wait(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(/* Load column sums from SLM + reduce in registers */)==""\n"
R"==(a_scale_tile_type A_scale_tile, A_scale_tile_load;)==""\n"
R"==(tile_fill(A_scale_tile, 0.0f);)==""\n"
R"==(#pragma unroll)==""\n"
R"==(for (uint sg1 = 0; sg1 < ugemm_kq_sg_per_wg_m; sg1++) {)==""\n"
R"==(tile_load_full(&A_scale_tile_load, S_sum_slm, ugemm_kq_wg_tile_n,)==""\n"
R"==(ugemm_vs_sg_tile_n * sg_j_vs, sg1);)==""\n"
R"==(tile_binary(A_scale_tile, A_scale_tile_load, binary_add);)==""\n"
R"==(})==""\n"
R"==(#if VAL_SCALES == QUANTIZE_COMMON)==""\n"
R"==(#define v_scale_op(x) ((x)*v_scale))==""\n"
R"==(tile_elementwise(A_tile, v_scale_op);)==""\n"
R"==(#endif)==""\n"
R"==(/* Rescale by 1 / (column sums) */)==""\n"
R"==(tile_elementwise(A_scale_tile, native_vrecip);)==""\n"
R"==(tile_hbroadcast_mul(&A_tile, A_scale_tile);)==""\n"
R"==(/* Convert to half precision and store */)==""\n"
R"==(a_tile_type_dst A_tile_dst;)==""\n"
R"==(tile_copy_reblock(A_tile, &A_tile_dst);)==""\n"
R"==(uint sg_i0_vs = sg_i_vs * ugemm_vs_sg_tile_m;)==""\n"
R"==(uint sg_j0_vs = sg_j_vs * ugemm_vs_sg_tile_n + wg_j0;)==""\n"
R"==(#ifdef BLOCK_2D_A)==""\n"
R"==(tile_store_block2d(A_tile_dst, A, d, q, lda, sg_i0_vs, sg_j0_vs);)==""\n"
R"==(#elif defined(BLOCK_A))==""\n"
R"==(tile_store_block_rem_q(A_tile_dst, A, q, lda, sg_i0_vs, sg_j0_vs);)==""\n"
R"==(#else)==""\n"
R"==(tile_store(A_tile_dst, A, d, q, lda, sg_i0_vs, sg_j0_vs);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}