namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_conversion_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_CONVERSION_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_CONVERSION_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_custom_types.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_math_utils.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_utils.h")==""\n"
R"==(#define def_identity_into(dt) \)==""\n"
R"==(dt __attribute__((overloadable)) CONCAT2(into_, dt)(dt val) { return val; })==""\n"
R"==(def_identity_into(float);)==""\n"
R"==(def_identity_into(char);)==""\n"
R"==(def_identity_into(uchar);)==""\n"
R"==(def_identity_into(int);)==""\n"
R"==(def_identity_into(bf16);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_identity_into(double));)==""\n"
R"==(IF_HALF_SUPPORTED(def_identity_into(half));)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_BF8)==""\n"
R"==(def_identity_into(f8_e5m2);)==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_HF8)==""\n"
R"==(def_identity_into(f8_e4m3);)==""\n"
R"==(#endif )==""\n"
R"==(#undef def_identity_into)==""\n"
R"==(#define def_std_into(out_type, in_type) \)==""\n"
R"==(out_type __attribute__((overloadable)) \)==""\n"
R"==(CONCAT2(into_, out_type)(in_type val) { \)==""\n"
R"==(return CONCAT2(convert_, out_type)(val); \)==""\n"
R"==(})==""\n"
R"==(#define def_std_into_sat(out_type, in_type) \)==""\n"
R"==(out_type __attribute__((overloadable)) \)==""\n"
R"==(CONCAT2(into_, out_type)(in_type val) { \)==""\n"
R"==(return CONCAT3(convert_, out_type, _sat_rte)(val); \)==""\n"
R"==(})==""\n"
R"==(def_std_into_sat(char, uchar);)==""\n"
R"==(def_std_into_sat(char, float);)==""\n"
R"==(def_std_into_sat(char, int);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into_sat(char, double));)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into_sat(char, half));)==""\n"
R"==(def_std_into_sat(uchar, char);)==""\n"
R"==(def_std_into_sat(uchar, float);)==""\n"
R"==(def_std_into_sat(uchar, int);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into_sat(uchar, double));)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into_sat(uchar, half));)==""\n"
R"==(def_std_into_sat(int, float);)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into(half, char));)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into(half, uchar));)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into(half, float));)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into(half, int));)==""\n"
R"==(IF_HALF_SUPPORTED(IF_DOUBLE_SUPPORTED(def_std_into(half, double)));)==""\n"
R"==(def_std_into(float, char);)==""\n"
R"==(def_std_into(float, uchar);)==""\n"
R"==(def_std_into(float, int);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into(float, double));)==""\n"
R"==(IF_HALF_SUPPORTED(def_std_into(float, half));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into(double, char));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into(double, uchar));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into(double, float));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_std_into(double, int));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(IF_HALF_SUPPORTED(def_std_into(double, half)));)==""\n"
R"==(#undef def_std_into)==""\n"
R"==(#undef def_std_into_sat)==""\n"
R"==(#define def_two_step_conversion(out_type, in_type, mid_type) \)==""\n"
R"==(out_type __attribute__((overloadable)) \)==""\n"
R"==(CONCAT2(into_, out_type)(in_type val) { \)==""\n"
R"==(return CONCAT2(into_, out_type)(CONCAT2(into_, mid_type)(val)); \)==""\n"
R"==(})==""\n"
R"==(#ifdef cl_future_bf16_cvt)==""\n"
R"==(short __builtin_IB_ftobf_1(float a) __attribute__((const));)==""\n"
R"==(short2 __builtin_IB_ftobf_2(float2 a) __attribute__((const));)==""\n"
R"==(short4 __builtin_IB_ftobf_4(float4 a) __attribute__((const));)==""\n"
R"==(short8 __builtin_IB_ftobf_8(float8 a) __attribute__((const));)==""\n"
R"==(short16 __builtin_IB_ftobf_16(float16 a) __attribute__((const));)==""\n"
R"==(float __builtin_IB_bftof_1(short a) __attribute__((const));)==""\n"
R"==(float2 __builtin_IB_bftof_2(short2 a) __attribute__((const));)==""\n"
R"==(float4 __builtin_IB_bftof_4(short4 a) __attribute__((const));)==""\n"
R"==(float8 __builtin_IB_bftof_8(short8 a) __attribute__((const));)==""\n"
R"==(float16 __builtin_IB_bftof_16(short16 a) __attribute__((const));)==""\n"
R"==(bf16 __attribute__((overloadable)) into_bf16(float x) {)==""\n"
R"==(return as_bf16(__builtin_IB_ftobf_1(x));)==""\n"
R"==(})==""\n"
R"==(float __attribute__((overloadable)) into_float(bf16 x) {)==""\n"
R"==(return __builtin_IB_bftof_1(x.data);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(bf16 __attribute__((overloadable)) into_bf16(float f) {)==""\n"
R"==(uint i = as_uint(f);)==""\n"
R"==(i += 0x00007FFF + ((i & 0x10000) >> 16);)==""\n"
R"==(ushort2 r = as_ushort2(i);)==""\n"
R"==(return as_bf16(r[1]);)==""\n"
R"==(})==""\n"
R"==(float __attribute__((overloadable)) into_float(bf16 b) {)==""\n"
R"==(ushort2 r = {0, b.data};)==""\n"
R"==(float f = as_float(r);)==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(def_two_step_conversion(bf16, int, float);)==""\n"
R"==(IF_HALF_SUPPORTED(def_two_step_conversion(bf16, half, float));)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_BF8)==""\n"
R"==(f8_e5m2 __attribute__((overloadable)) into_f8_e5m2(half f) {)==""\n"
R"==(ushort fraw = as_ushort(f);)==""\n"
R"==(ushort naninf_mask = 0x7c00;)==""\n"
R"==(bool is_special = (fraw & naninf_mask) == naninf_mask;)==""\n"
R"==(bool is_nan = is_special && (fraw & 0x03ff); )==""\n"
R"==(if (is_nan) { return as_f8_e5m2((fraw >> 8) | 0x02); })==""\n"
R"==(if (is_special) {)==""\n"
R"==(uchar raw_bits = fraw >> 8;)==""\n"
R"==(return as_f8_e5m2(raw_bits);)==""\n"
R"==(})==""\n"
R"==(ushort rounding_nudge = 0x007f + ((fraw & 0x0100) >> 8);)==""\n"
R"==(fraw = fraw + rounding_nudge;)==""\n"
R"==(uchar raw_bits = fraw >> 8;)==""\n"
R"==(return as_f8_e5m2(raw_bits);)==""\n"
R"==(})==""\n"
R"==(half __attribute__((overloadable)) into_half(f8_e5m2 b) {)==""\n"
R"==(uchar2 iraw = {0, b.data};)==""\n"
R"==(return as_half(iraw);)==""\n"
R"==(})==""\n"
R"==(def_two_step_conversion(f8_e5m2, float, half);)==""\n"
R"==(def_two_step_conversion(f8_e5m2, int, half);)==""\n"
R"==(def_two_step_conversion(float, f8_e5m2, half);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_two_step_conversion(f8_e5m2, double, float));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_two_step_conversion(double, f8_e5m2, float));)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef MATH_UTILS_DECLARE_HF8)==""\n"
R"==(f8_e4m3 __attribute__((overloadable)) into_f8_e4m3(half f) {)==""\n"
R"==(uchar raw_bits = 0;)==""\n"
R"==(ushort fraw = as_ushort(f);)==""\n"
R"==(uint s8 = (fraw & 0x8000) >> 8;)==""\n"
R"==(fraw = fraw & 0x7fff;)==""\n"
R"==(if (fraw >= 0x5f40) {)==""\n"
R"==(raw_bits = s8 | 0x7f;)==""\n"
R"==(return as_f8_e4m3(raw_bits);)==""\n"
R"==(})==""\n"
R"==(if (fraw <= 0x1400) {)==""\n"
R"==(raw_bits = s8;)==""\n"
R"==(return as_f8_e4m3(raw_bits);)==""\n"
R"==(})==""\n"
R"==(ushort a = 0x7c00, b = 0x1c00;)==""\n"
R"==(ushort shifter = (fraw & a) + b;)==""\n"
R"==(const int exp_threshold = 0x4000; )==""\n"
R"==(ushort is_denorm = shifter < exp_threshold;)==""\n"
R"==(if (is_denorm) shifter = exp_threshold;)==""\n"
R"==(ushort rounded)==""\n"
R"==(= as_ushort((as_half(fraw) + as_half(shifter)) - as_half(shifter));)==""\n"
R"==(int e8 = ((rounded & 0x7c00) >> 10) - 8;)==""\n"
R"==(uchar m8 = (rounded & 0x03ff) >> 7;)==""\n"
R"==(if (is_denorm) {)==""\n"
R"==(m8 = (m8 | 0x08) >> (-e8 + 1);)==""\n"
R"==(e8 = 0;)==""\n"
R"==(})==""\n"
R"==(raw_bits = s8 | (e8 << 3) | m8;)==""\n"
R"==(return as_f8_e4m3(raw_bits);)==""\n"
R"==(})==""\n"
R"==(half __attribute__((overloadable)) into_half(f8_e4m3 b) {)==""\n"
R"==(uchar raw_bits_ = b.data;)==""\n"
R"==(ushort s8 = (raw_bits_ & 0x80) >> 7;)==""\n"
R"==(ushort e8 = (raw_bits_ & 0x78) >> 3;)==""\n"
R"==(ushort m8 = (raw_bits_ & 0x7);)==""\n"
R"==(ushort s16 = s8;)==""\n"
R"==(ushort e16 = e8 + 8; /* 15 - 7 = e16_bias - e8_bias */)==""\n"
R"==(ushort m16 = m8;)==""\n"
R"==(if (e8 == 0 && m8 != 0) {)==""\n"
R"==(ushort count = 2;)==""\n"
R"==(count = m8 > 0x1 ? 1 : count;)==""\n"
R"==(count = m8 > 0x3 ? 0 : count;)==""\n"
R"==(e16 -= count;)==""\n"
R"==(m16 = (m16 << (count + 1)) & 0x7;)==""\n"
R"==(} else if (e8 == 0 && m8 == 0) {)==""\n"
R"==(e16 = 0;)==""\n"
R"==(} else if (e8 == 0xf && m8 == 0x7) {)==""\n"
R"==(e16 = 0x1f;)==""\n"
R"==(m16 = 0x4; )==""\n"
R"==(})==""\n"
R"==(s16 <<= 15;)==""\n"
R"==(e16 <<= 10;)==""\n"
R"==(m16 <<= 7;)==""\n"
R"==(ushort u16 = s16 | e16 | m16;)==""\n"
R"==(return as_half(u16);)==""\n"
R"==(})==""\n"
R"==(def_two_step_conversion(f8_e4m3, float, half);)==""\n"
R"==(def_two_step_conversion(f8_e4m3, int, half);)==""\n"
R"==(def_two_step_conversion(float, f8_e4m3, half);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_two_step_conversion(f8_e4m3, double, float));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_two_step_conversion(double, f8_e4m3, float));)==""\n"
R"==(#endif )==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_two_step_conversion(bf16, double, float));)==""\n"
R"==(IF_DOUBLE_SUPPORTED(def_two_step_conversion(double, bf16, float));)==""\n"
R"==(#undef def_two_step_conversion)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}