namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_eltwise_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_ELTWISE_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_ELTWISE_H)==""\n"
R"==(#if WITH_ELTWISE)==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if DT_F16 == 1)==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable)==""\n"
R"==(#endif)==""\n"
R"==(#ifndef DATA_MAX)==""\n"
R"==(#if DT_F16 == 1)==""\n"
R"==(#define DATA_MAX HALF_MAX)==""\n"
R"==(#elif DT_S8 == 1)==""\n"
R"==(#define DATA_MAX CHAR_MAX)==""\n"
R"==(#elif DT_U8 == 1)==""\n"
R"==(#define DATA_MAX UCHAR_MAX)==""\n"
R"==(#else)==""\n"
R"==(#define DATA_MAX FLT_MAX)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(POST_OP_DATA_T relu_fwd(POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(return s > 0 ? s : s * alpha;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T relu_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(return s > 0 ? dd : dd * alpha;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T relu_bwd_use_dst()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T d, float alpha) {)==""\n"
R"==(return d > 0 ? dd : dd * alpha;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T linear_fwd(POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(return alpha * s + beta;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T linear_bwd(POST_OP_DATA_T dd, float alpha) {)==""\n"
R"==(return dd * alpha;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T soft_relu_fwd(POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(s = alpha * s;)==""\n"
R"==(POST_OP_DATA_T v = (s < log((POST_OP_DATA_T)DATA_MAX) ? log1p(exp(s)) : s);)==""\n"
R"==(return v / alpha;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T soft_relu_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(s = alpha * s;)==""\n"
R"==(return dd / ((POST_OP_DATA_T)1 + exp(-s));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T logistic_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return (AS_POST_OP_DATA_T(1.0)) / (AS_POST_OP_DATA_T(1.0) + exp(-s));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T logistic_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(POST_OP_DATA_T v = logistic_fwd(s);)==""\n"
R"==(return dd * v * (1 - v);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T logistic_bwd_use_dst(POST_OP_DATA_T dd, POST_OP_DATA_T d) {)==""\n"
R"==(return dd * d * (1 - d);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T square_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return s * s;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T square_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(return dd * 2 * s;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T sqrt_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return sqrt(s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T sqrt_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(return dd / (2 * sqrt(s));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T sqrt_bwd_use_dst(POST_OP_DATA_T dd, POST_OP_DATA_T d) {)==""\n"
R"==(return dd / (2 * d);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T abs_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return s > 0 ? s : -s;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T abs_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(return s > 0 ? dd : s < 0 ? -dd : 0;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T tanh_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return tanh(s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T tanh_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(POST_OP_DATA_T e = tanh_fwd(s);)==""\n"
R"==(return dd * (1 - e) * (1 + e);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T tanh_bwd_use_dst(POST_OP_DATA_T dd, POST_OP_DATA_T d) {)==""\n"
R"==(return dd * (1 - d) * (1 + d);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T mish_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return s * tanh_fwd(soft_relu_fwd(s, 1.f));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T mish_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(const POST_OP_DATA_T tanh = tanh_fwd(soft_relu_fwd(s, (POST_OP_DATA_T)1.0));)==""\n"
R"==(const POST_OP_DATA_T srelu_bwd)==""\n"
R"==(= soft_relu_bwd((POST_OP_DATA_T)1.0, s, (POST_OP_DATA_T)1.0);)==""\n"
R"==(const POST_OP_DATA_T derivative = tanh)==""\n"
R"==(+ s * srelu_bwd)==""\n"
R"==(* ((POST_OP_DATA_T)1 - pow(tanh, (POST_OP_DATA_T)2.0));)==""\n"
R"==(return dd * derivative;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T elu_fwd(POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(return s > 0 ? s : alpha * expm1(s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T elu_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(return dd * (s > 0 ? 1 : alpha * exp(s));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T elu_bwd_use_dst()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T d, float alpha) {)==""\n"
R"==(return dd * (d > 0 ? 1 : d + alpha);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T exp_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return exp(s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T exp_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(return dd * exp_fwd(s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T exp_bwd_use_dst(POST_OP_DATA_T dd, POST_OP_DATA_T d) {)==""\n"
R"==(return dd * d;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T gelu_tanh_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(const POST_OP_DATA_T sqrt_2_over_pi)==""\n"
R"==(= AS_POST_OP_DATA_T(0.79788458347320556640625);)==""\n"
R"==(const POST_OP_DATA_T fitting_const = AS_POST_OP_DATA_T(0.044715);)==""\n"
R"==(const POST_OP_DATA_T g = sqrt_2_over_pi * s)==""\n"
R"==(* ((POST_OP_DATA_T)1.0 + fitting_const * s * s);)==""\n"
R"==(return ((POST_OP_DATA_T)0.5 * s * ((POST_OP_DATA_T)1.0 + tanh_fwd(g)));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T gelu_tanh_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(const POST_OP_DATA_T sqrt_2_over_pi)==""\n"
R"==(= AS_POST_OP_DATA_T(0.79788458347320556640625);)==""\n"
R"==(const POST_OP_DATA_T fitting_const = AS_POST_OP_DATA_T(0.044715);)==""\n"
R"==(const POST_OP_DATA_T g = sqrt_2_over_pi * s)==""\n"
R"==(* ((POST_OP_DATA_T)1.0 + fitting_const * s * s);)==""\n"
R"==(const POST_OP_DATA_T dg = sqrt_2_over_pi)==""\n"
R"==(* ((POST_OP_DATA_T)1.0)==""\n"
R"==(+ (POST_OP_DATA_T)3.0 * fitting_const * s * s);)==""\n"
R"==(const POST_OP_DATA_T v = tanh_fwd(g);)==""\n"
R"==(return dd * (POST_OP_DATA_T)0.5 * ((POST_OP_DATA_T)1.0 + v))==""\n"
R"==(* ((POST_OP_DATA_T)1.0 + s * ((POST_OP_DATA_T)1.0 - v) * dg);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T swish_fwd(POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(POST_OP_DATA_T w = -alpha * s;)==""\n"
R"==(return s / ((POST_OP_DATA_T)1.0 + exp(w));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T swish_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha) {)==""\n"
R"==(POST_OP_DATA_T v = logistic_fwd(alpha * s);)==""\n"
R"==(return dd * (v + s * alpha * v * ((POST_OP_DATA_T)1.0 - v));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T log_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return log(s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T log_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(return dd / s;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T clip_fwd(POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(s = s > alpha ? s : alpha;)==""\n"
R"==(return s > beta ? beta : s;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T clip_bwd()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(return dd * (alpha < s && s <= beta ? 1 : 0);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T clip_v2_fwd(POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(s = s > alpha ? s : alpha;)==""\n"
R"==(return s < beta ? s : beta;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T clip_v2_bwd()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(return dd * (alpha < s && s < beta ? 1 : 0);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T clip_v2_bwd_use_dst()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T d, float alpha, float beta) {)==""\n"
R"==(return dd * (alpha < d && d < beta ? 1 : 0);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T pow_fwd(POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(return alpha * pow(s, (POST_OP_DATA_T)(beta));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T pow_bwd()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(if (beta == 0) return 0;)==""\n"
R"==(POST_OP_DATA_T v = pow_fwd(s, alpha * beta, beta - 1);)==""\n"
R"==(return dd * v;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T gelu_erf_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(const POST_OP_DATA_T sqrt_2_over_2)==""\n"
R"==(= AS_POST_OP_DATA_T(0.707106769084930419921875);)==""\n"
R"==(POST_OP_DATA_T v = s * sqrt_2_over_2;)==""\n"
R"==(return (POST_OP_DATA_T)0.5 * s * ((POST_OP_DATA_T)1.0 + erf(v));)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T gelu_erf_bwd(POST_OP_DATA_T dd, POST_OP_DATA_T s) {)==""\n"
R"==(const POST_OP_DATA_T two_over_sqrt_pi)==""\n"
R"==(= AS_POST_OP_DATA_T(1.12837922573089599609375);)==""\n"
R"==(const POST_OP_DATA_T sqrt_2_over_2)==""\n"
R"==(= AS_POST_OP_DATA_T(0.707106769084930419921875);)==""\n"
R"==(POST_OP_DATA_T v = s * sqrt_2_over_2;)==""\n"
R"==(return dd * (POST_OP_DATA_T)0.5)==""\n"
R"==(* ((POST_OP_DATA_T)1.0 + erf(v))==""\n"
R"==(+ v * two_over_sqrt_pi * exp(-v * v));)==""\n"
R"==(})==""\n"
R"==(float round_fwd(POST_OP_DATA_T s) {)==""\n"
R"==(return (float)rint((float)s);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T hardsigmoid_fwd(POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(POST_OP_DATA_T v = (POST_OP_DATA_T)alpha * s + (POST_OP_DATA_T)beta;)==""\n"
R"==(return v <= AS_POST_OP_DATA_T(0.0) ? AS_POST_OP_DATA_T(0.0))==""\n"
R"==(: v >= AS_POST_OP_DATA_T(1.0) ? AS_POST_OP_DATA_T(1.0))==""\n"
R"==(: v;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T hardsigmoid_bwd()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(POST_OP_DATA_T v = alpha * s + beta;)==""\n"
R"==(return v <= 0.f ? 0.f : v >= 1.f ? 0.f : dd * alpha;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T hardswish_fwd(POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(return s * hardsigmoid_fwd(s, alpha, beta);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T hardswish_bwd()==""\n"
R"==(POST_OP_DATA_T dd, POST_OP_DATA_T s, float alpha, float beta) {)==""\n"
R"==(POST_OP_DATA_T v = alpha * s + beta;)==""\n"
R"==(POST_OP_DATA_T w = 2.f * alpha * s + beta;)==""\n"
R"==(return (v <= 0.f ? 0.f : v >= 1.f ? dd : dd * w);)==""\n"
R"==(})==""\n"
R"==(float fwd_eltwise_common(int eltwise_alg, POST_OP_DATA_T x, float alpha_,)==""\n"
R"==(float beta_, float scale_) {)==""\n"
R"==(switch (eltwise_alg) {)==""\n"
R"==(case RELU: return scale_ * relu_fwd(x, alpha_); break;)==""\n"
R"==(case LINEAR: return scale_ * linear_fwd(x, alpha_, beta_); break;)==""\n"
R"==(case SOFT_RELU: return scale_ * soft_relu_fwd(x, alpha_); break;)==""\n"
R"==(case MISH: return scale_ * mish_fwd(x); break;)==""\n"
R"==(case LOGISTIC: return scale_ * logistic_fwd(x); break;)==""\n"
R"==(case TANH: return scale_ * tanh_fwd(x); break;)==""\n"
R"==(case ELU: return scale_ * elu_fwd(x, alpha_); break;)==""\n"
R"==(case SQUARE: return scale_ * square_fwd(x); break;)==""\n"
R"==(case SQRT: return scale_ * sqrt_fwd(x); break;)==""\n"
R"==(case ABS: return scale_ * abs_fwd(x); break;)==""\n"
R"==(case EXP: return scale_ * exp_fwd(x); break;)==""\n"
R"==(case GELU_TANH: return scale_ * gelu_tanh_fwd(x); break;)==""\n"
R"==(case SWISH: return scale_ * swish_fwd(x, alpha_); break;)==""\n"
R"==(case LOG: return scale_ * log_fwd(x); break;)==""\n"
R"==(case CLIP: return scale_ * clip_fwd(x, alpha_, beta_); break;)==""\n"
R"==(case CLIP_V2: return scale_ * clip_v2_fwd(x, alpha_, beta_); break;)==""\n"
R"==(case POW: return scale_ * pow_fwd(x, alpha_, beta_); break;)==""\n"
R"==(case GELU_ERF: return scale_ * gelu_erf_fwd(x); break;)==""\n"
R"==(case ROUND: return scale_ * round_fwd(x); break;)==""\n"
R"==(case HARDSWISH: return scale_ * hardswish_fwd(x, alpha_, beta_); break;)==""\n"
R"==(case HARDSIGMOID:)==""\n"
R"==(return scale_ * hardsigmoid_fwd(x, alpha_, beta_);)==""\n"
R"==(break;)==""\n"
R"==(case RELU_DST: return scale_ * relu_fwd(x, alpha_); break;)==""\n"
R"==(case LOGISTIC_DST: return scale_ * logistic_fwd(x); break;)==""\n"
R"==(case TANH_DST: return scale_ * tanh_fwd(x); break;)==""\n"
R"==(case ELU_DST: return scale_ * elu_fwd(x, alpha_); break;)==""\n"
R"==(case SQRT_DST: return scale_ * sqrt_fwd(x); break;)==""\n"
R"==(case EXP_DST: return scale_ * exp_fwd(x); break;)==""\n"
R"==(case CLIP_V2_DST: return scale_ * clip_v2_fwd(x, alpha_, beta_); break;)==""\n"
R"==(default: return x; break;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(float fwd_eltwise(POST_OP_DATA_T x, float alpha_, float beta_, float scale_) {)==""\n"
R"==(#ifdef ELTWISE_ALG)==""\n"
R"==(return fwd_eltwise_common(ELTWISE_ALG, x, alpha_, beta_, scale_);)==""\n"
R"==(#else)==""\n"
R"==(return x;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float bwd_eltwise()==""\n"
R"==(POST_OP_DATA_T x, POST_OP_DATA_T y, float alpha_, float beta_) {)==""\n"
R"==(#ifdef ELTWISE_ALG)==""\n"
R"==(switch (ELTWISE_ALG) {)==""\n"
R"==(case RELU: return relu_bwd(x, y, alpha_); break;)==""\n"
R"==(case LINEAR: return linear_bwd(x, alpha_); break;)==""\n"
R"==(case SOFT_RELU: return soft_relu_bwd(x, y, alpha_); break;)==""\n"
R"==(case MISH: return mish_bwd(x, y); break;)==""\n"
R"==(case LOGISTIC: return logistic_bwd(x, y); break;)==""\n"
R"==(case TANH: return tanh_bwd(x, y); break;)==""\n"
R"==(case ELU: return elu_bwd(x, y, alpha_); break;)==""\n"
R"==(case SQUARE: return square_bwd(x, y); break;)==""\n"
R"==(case SQRT: return sqrt_bwd(x, y); break;)==""\n"
R"==(case ABS: return abs_bwd(x, y); break;)==""\n"
R"==(case EXP: return exp_bwd(x, y); break;)==""\n"
R"==(case GELU_TANH: return gelu_tanh_bwd(x, y); break;)==""\n"
R"==(case SWISH: return swish_bwd(x, y, alpha_); break;)==""\n"
R"==(case LOG: return log_bwd(x, y); break;)==""\n"
R"==(case CLIP: return clip_bwd(x, y, alpha_, beta_); break;)==""\n"
R"==(case CLIP_V2: return clip_v2_bwd(x, y, alpha_, beta_); break;)==""\n"
R"==(case POW: return pow_bwd(x, y, alpha_, beta_); break;)==""\n"
R"==(case GELU_ERF: return gelu_erf_bwd(x, y); break;)==""\n"
R"==(case HARDSWISH: return hardswish_bwd(x, y, alpha_, beta_); break;)==""\n"
R"==(case HARDSIGMOID: return hardsigmoid_bwd(x, y, alpha_, beta_); break;)==""\n"
R"==(case RELU_DST: return relu_bwd_use_dst(x, y, alpha_); break;)==""\n"
R"==(case LOGISTIC_DST: return logistic_bwd_use_dst(x, y); break;)==""\n"
R"==(case TANH_DST: return tanh_bwd_use_dst(x, y); break;)==""\n"
R"==(case ELU_DST: return elu_bwd_use_dst(x, y, alpha_); break;)==""\n"
R"==(case SQRT_DST: return sqrt_bwd_use_dst(x, y); break;)==""\n"
R"==(case EXP_DST: return exp_bwd_use_dst(x, y); break;)==""\n"
R"==(case CLIP_V2_DST:)==""\n"
R"==(return clip_v2_bwd_use_dst(x, y, alpha_, beta_);)==""\n"
R"==(break;)==""\n"
R"==(default: return x; break;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(return x;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}