namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_post_ops_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_POST_OPS_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_POST_OPS_H)==""\n"
R"==(#if WITH_POST_OP)==""\n"
R"==(#if !WITH_ELTWISE)==""\n"
R"==(#undef WITH_ELTWISE)==""\n"
R"==(#define WITH_ELTWISE 1)==""\n"
R"==(#endif)==""\n"
R"==(#include "gpu/intel/ocl/ocl_conversion.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_eltwise.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_io.h")==""\n"
R"==(float fwd_Xnary(unsigned kind, unsigned algorithm, float x, float y,)==""\n"
R"==(float alpha, float beta, float scale) {)==""\n"
R"==(if (kind == PO_BINARY) {)==""\n"
R"==(switch (algorithm) {)==""\n"
R"==(case BINARY_ADD: return x + y; break;)==""\n"
R"==(case BINARY_MUL: return x * y; break;)==""\n"
R"==(case BINARY_MIN: return x < y ? x : y; break;)==""\n"
R"==(case BINARY_MAX: return x > y ? x : y; break;)==""\n"
R"==(case BINARY_DIV: return x / y; break;)==""\n"
R"==(case BINARY_SUB: return x - y; break;)==""\n"
R"==(case BINARY_GE: return x >= y; break;)==""\n"
R"==(case BINARY_GT: return x > y; break;)==""\n"
R"==(case BINARY_LE: return x <= y; break;)==""\n"
R"==(case BINARY_LT: return x < y; break;)==""\n"
R"==(case BINARY_EQ: return x == y; break;)==""\n"
R"==(case BINARY_NE: return x != y; break;)==""\n"
R"==(case RELU: )==""\n"
R"==(return fwd_eltwise_common(RELU, x, y, beta, scale);)==""\n"
R"==(break;)==""\n"
R"==(default: return 0.f;)==""\n"
R"==(})==""\n"
R"==(} else { )==""\n"
R"==(return fwd_eltwise_common(algorithm, x, alpha, beta, scale);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#define FWD_XNARY_GENERIC_DT(po_kind, algorithm, res_ptr, arg0_ptr, arg0_len, \)==""\n"
R"==(arg1_ptr, arg1_len, alpha, beta, scale) \)==""\n"
R"==({ \)==""\n"
R"==(auto ty = arg0_len + arg1_len; \)==""\n"
R"==(const typeof(ty) out_len \)==""\n"
R"==(= max((typeof(ty))arg0_len, (typeof(ty))arg1_len); \)==""\n"
R"==(unroll_for(typeof(out_len + 0) idx = 0; idx < out_len; ++idx) { \)==""\n"
R"==(const int arg0_idx = arg0_len == 1 ? 0 : idx; \)==""\n"
R"==(const int arg1_idx = arg1_len == 1 ? 0 : idx; \)==""\n"
R"==(res_ptr[arg0_len == 1 && arg1_len == 1 ? 0 : idx] = fwd_Xnary( \)==""\n"
R"==(po_kind, algorithm, into_float(arg0_ptr[arg0_idx]), \)==""\n"
R"==(into_float(arg1_ptr[arg1_idx]), alpha, beta, scale); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define FMA_BLOCK( \)==""\n"
R"==(block_size, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b) \)==""\n"
R"==(unroll_for(; nof_elems >= block_size; acc_ptr += block_size, \)==""\n"
R"==(a_ptr += block_size, nof_elems -= block_size) { \)==""\n"
R"==(CONCAT2(acc_elem_dt, block_size) \)==""\n"
R"==(a_conv = CONCAT3(convert_, acc_elem_dt, block_size)( \)==""\n"
R"==(*((CONCAT2(a_elem_dt, block_size) *)a_ptr)); \)==""\n"
R"==(*((CONCAT2(acc_elem_dt, block_size) *)acc_ptr) = fma( \)==""\n"
R"==(a_conv, b, *((CONCAT2(acc_elem_dt, block_size) *)acc_ptr)); \)==""\n"
R"==(})==""\n"
R"==(#define FMA_MIXED(acc_nof_elems, a, a_elem_dt, b, acc_ptr, acc_elem_dt) \)==""\n"
R"==({ \)==""\n"
R"==(auto nof_elems = acc_nof_elems; \)==""\n"
R"==(a_elem_dt *a_ptr = (a_elem_dt *)(&a); \)==""\n"
R"==(FMA_BLOCK(8, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \)==""\n"
R"==(FMA_BLOCK(4, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \)==""\n"
R"==(FMA_BLOCK(2, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \)==""\n"
R"==(if (nof_elems == 1) { *acc_ptr += (*a_ptr) * b; } \)==""\n"
R"==(})==""\n"
R"==(#define po_dt(idx) CONCAT3(PO_, idx, _BIN_ARG_ACTUAL_DATA_T))==""\n"
R"==(#define po_buf(idx) ((__global po_dt(idx) *)(CONCAT3(po_, idx, _binary_arg))))==""\n"
R"==(#define FILL_BIN_ARG_SERIAL(idx, dest_ptr, x0, x0_s, x1, x1_s, x1_incr, x2, \)==""\n"
R"==(x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \)==""\n"
R"==(unroll_for(typeof(x0 + x0_s) x0_idx = x0, bin_arg_offset = 0; \)==""\n"
R"==(x0_idx < x0 + x0_s; ++x0_idx) { \)==""\n"
R"==(unroll_for(typeof(x1 + x1_s + x1_incr) x1_idx = x1; \)==""\n"
R"==(x1_idx < x1 + x1_s; x1_idx += x1_incr) { \)==""\n"
R"==(unroll_for(typeof(x2 + x2_s) x2_idx = x2; x2_idx < x2 + x2_s; \)==""\n"
R"==(++x2_idx) { \)==""\n"
R"==(unroll_for(typeof(x3 + x3_s) x3_idx = x3; x3_idx < x3 + x3_s; \)==""\n"
R"==(++x3_idx) { \)==""\n"
R"==(unroll_for(typeof(x4 + x4_s) x4_idx = x4; \)==""\n"
R"==(x4_idx < x4 + x4_s; ++x4_idx) { \)==""\n"
R"==(unroll_for(typeof(x5 + x5_s) x5_idx = x5; \)==""\n"
R"==(x5_idx < x5 + x5_s; \)==""\n"
R"==(++x5_idx, ++bin_arg_offset) { \)==""\n"
R"==(const auto bin_arg_glob_off = OFF_MD( \)==""\n"
R"==(CONCAT3(PO_, idx, _BIN_ARG), \)==""\n"
R"==(x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \)==""\n"
R"==(x1_idx % CONCAT3(PO_, idx, _BIN_ARG_D1), \)==""\n"
R"==(x2_idx % CONCAT3(PO_, idx, _BIN_ARG_D2), \)==""\n"
R"==(x3_idx % CONCAT3(PO_, idx, _BIN_ARG_D3), \)==""\n"
R"==(x4_idx % CONCAT3(PO_, idx, _BIN_ARG_D4), \)==""\n"
R"==(x5_idx % CONCAT3(PO_, idx, _BIN_ARG_D5)); \)==""\n"
R"==(dest_ptr[bin_arg_offset] = into_float( \)==""\n"
R"==(po_buf(idx)[bin_arg_glob_off]); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define FILL_WITH_BLOCK_READ(src_ptr, dst_ptr, nelem) \)==""\n"
R"==(unroll_for(typeof(nelem + 0) load_idx = 0; load_idx < nelem; ++load_idx) { \)==""\n"
R"==(block_load(&dst_ptr[load_idx], \)==""\n"
R"==(src_ptr + load_idx * get_sub_group_size()); \)==""\n"
R"==(})==""\n"
R"==(#define X_NELEMS(x) (x / get_sub_group_size()))==""\n"
R"==(#define CONDITIONAL_FILL(blocked_coord, nelem, src_ptr, dst_ptr) \)==""\n"
R"==(if (blocked_coord / get_sub_group_size() == nelem) \)==""\n"
R"==(FILL_WITH_BLOCK_READ(src_ptr, dst_ptr, nelem);)==""\n"
R"==(#define FILL_BIN_ARG_TRY_BLOCK(idx, dest_ptr, dest_size, x0, x0_s, x1, x1_s, \)==""\n"
R"==(x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \)==""\n"
R"==({ \)==""\n"
R"==(unroll_for(typeof(x0 + x0_s) x0_idx = x0, arg_off = 0; \)==""\n"
R"==(x0_idx < x0 + x0_s; ++x0_idx, arg_off += X_NELEMS(x1_s)) { \)==""\n"
R"==(const auto bin_arg_glob_off = OFF_MD(CONCAT3(PO_, idx, _BIN_ARG), \)==""\n"
R"==(x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \)==""\n"
R"==(x1 % CONCAT3(PO_, idx, _BIN_ARG_D1), \)==""\n"
R"==(x2 % CONCAT3(PO_, idx, _BIN_ARG_D2), \)==""\n"
R"==(x3 % CONCAT3(PO_, idx, _BIN_ARG_D3), \)==""\n"
R"==(x4 % CONCAT3(PO_, idx, _BIN_ARG_D4), \)==""\n"
R"==(x5 % CONCAT3(PO_, idx, _BIN_ARG_D5)); \)==""\n"
R"==(\)==""\n"
R"==(CONDITIONAL_FILL(x1_s, 1, (po_buf(idx) + bin_arg_glob_off), \)==""\n"
R"==((dest_ptr + arg_off)); \)==""\n"
R"==(CONDITIONAL_FILL(x1_s, 2, (po_buf(idx) + bin_arg_glob_off), \)==""\n"
R"==((dest_ptr + arg_off)); \)==""\n"
R"==(CONDITIONAL_FILL(x1_s, 4, (po_buf(idx) + bin_arg_glob_off), \)==""\n"
R"==((dest_ptr + arg_off)); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define REPLICATE_DATA( \)==""\n"
R"==(dest_ptr, dest_size, x0_s, x1_s, x2_s, x3_s, x4_s, x5_s) \)==""\n"
R"==({ \)==""\n"
R"==(const auto copy_size = x0_s * x1_s * x2_s * x3_s * x4_s * x5_s; \)==""\n"
R"==(unroll_for(typeof(dest_size + 0) fid = copy_size; fid < dest_size; \)==""\n"
R"==(++fid) { \)==""\n"
R"==(*(dest_ptr + fid) = *(dest_ptr + (fid % copy_size)); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, x2_s, x3, x3_s, x4, x4_s, \)==""\n"
R"==(x5, x5_s, is_burst) \)==""\n"
R"==(({ \)==""\n"
R"==(bool is_burstable = is_burst; \)==""\n"
R"==(if (x0_s > CONCAT3(PO_, idx, _BIN_ARG_D0) && x0_s > 1) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(if (x1_s > CONCAT3(PO_, idx, _BIN_ARG_D1) && x1_s > 1) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(if (x2_s > CONCAT3(PO_, idx, _BIN_ARG_D2) && x2_s > 1) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(if (x3_s > CONCAT3(PO_, idx, _BIN_ARG_D3) && x3_s > 1) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(if (x4_s > CONCAT3(PO_, idx, _BIN_ARG_D4) && x4_s > 1) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(if (x5_s > CONCAT3(PO_, idx, _BIN_ARG_D5) && x5_s > 1) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(if ((CONCAT3(PO_, idx, _BIN_ARG_D0) == 1) \)==""\n"
R"==(&& (CONCAT3(PO_, idx, _BIN_ARG_D1) == 1) \)==""\n"
R"==(&& (CONCAT3(PO_, idx, _BIN_ARG_D2) == 1) \)==""\n"
R"==(&& (CONCAT3(PO_, idx, _BIN_ARG_D2) == 1) \)==""\n"
R"==(&& (CONCAT3(PO_, idx, _BIN_ARG_D3) == 1) \)==""\n"
R"==(&& (CONCAT3(PO_, idx, _BIN_ARG_D4) == 1) \)==""\n"
R"==(&& (CONCAT3(PO_, idx, _BIN_ARG_D5) == 1)) \)==""\n"
R"==(is_burstable = false; \)==""\n"
R"==(\)==""\n"
R"==(is_burstable; \)==""\n"
R"==(}))==""\n"
R"==(#define APPLY_PO_BINARY(idx, accumulator, x0, x0_s, x1, x1_s, x1_incr, x2, \)==""\n"
R"==(x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst, bin_arg_size) \)==""\n"
R"==({ \)==""\n"
R"==(float bin_arg[bin_arg_size]; \)==""\n"
R"==(__private float *bin_arg_ptr = &bin_arg[0]; \)==""\n"
R"==(const bool use_burst_read = IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, \)==""\n"
R"==(x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst); \)==""\n"
R"==(if (use_burst_read) { \)==""\n"
R"==(FILL_BIN_ARG_TRY_BLOCK(idx, bin_arg_ptr, bin_arg_size, x0, x0_s, \)==""\n"
R"==(x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \)==""\n"
R"==(x5_s); \)==""\n"
R"==(REPLICATE_DATA(bin_arg_ptr, bin_arg_size, x0_s, X_NELEMS(x1_s), \)==""\n"
R"==(x2_s, x3_s, x4_s, x5_s); \)==""\n"
R"==(} else { \)==""\n"
R"==(const auto x1_jump = is_burst ? (int)get_sub_group_size() : 1; \)==""\n"
R"==(const auto x1_size = x1_s / x1_jump; \)==""\n"
R"==(FILL_BIN_ARG_SERIAL(idx, bin_arg_ptr, x0, x0_s, (x1 + x1_incr), \)==""\n"
R"==(x1_s, x1_jump, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s); \)==""\n"
R"==(REPLICATE_DATA(bin_arg_ptr, bin_arg_size, x0_s, x1_size, x2_s, \)==""\n"
R"==(x3_s, x4_s, x5_s); \)==""\n"
R"==(} \)==""\n"
R"==(FWD_XNARY_GENERIC_DT(PO_BINARY, CONCAT3(PO_, idx, _ALG), accumulator, \)==""\n"
R"==(accumulator, bin_arg_size, bin_arg_ptr, bin_arg_size, 0.0f, \)==""\n"
R"==(0.0f, 1.0f); \)==""\n"
R"==(})==""\n"
R"==(#define APPLY_PO_SUM( \)==""\n"
R"==(idx, accumulator, acc_size, acc_elem_dt, sum_src, sum_elem_dt) \)==""\n"
R"==(FMA_MIXED(acc_size, sum_src, sum_elem_dt, CONCAT3(PO_, idx, _SUM_SCALE), \)==""\n"
R"==(accumulator, acc_elem_dt);)==""\n"
R"==(#define APPLY_PO_ELTWISE(idx, accumulator, nelems) \)==""\n"
R"==(FWD_XNARY_GENERIC_DT(PO_ELTWISE, CONCAT3(PO_, idx, _ALG), accumulator, \)==""\n"
R"==(accumulator, nelems, accumulator, nelems, \)==""\n"
R"==(CONCAT3(PO_, idx, _ELTWISE_ALPHA), \)==""\n"
R"==(CONCAT3(PO_, idx, _ELTWISE_BETA), \)==""\n"
R"==(CONCAT3(PO_, idx, _ELTWISE_SCALE));)==""\n"
R"==(#define APPLY_PO_STAGE(idx, acc, acc_elem_dt, nelems, sum_src, sum_elem_dt, \)==""\n"
R"==(x0, x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \)==""\n"
R"==(is_burst) \)==""\n"
R"==(switch (CONCAT3(PO_, idx, _KIND)) { \)==""\n"
R"==(case PO_BINARY: \)==""\n"
R"==(APPLY_PO_BINARY(idx, acc, x0, x0_s, x1, x1_s, x1_incr, x2, x2_s, \)==""\n"
R"==(x3, x3_s, x4, x4_s, x5, x5_s, is_burst, nelems); \)==""\n"
R"==(break; \)==""\n"
R"==(case PO_ELTWISE: APPLY_PO_ELTWISE(idx, acc, nelems); break; \)==""\n"
R"==(case PO_SUM: \)==""\n"
R"==(APPLY_PO_SUM(idx, acc, nelems, acc_elem_dt, sum_src, sum_elem_dt); \)==""\n"
R"==(break; \)==""\n"
R"==(})==""\n"
R"==(#define APPLY_PO_STAGE_0(...))==""\n"
R"==(#define APPLY_PO_STAGE_1(...) APPLY_PO_STAGE(0, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_2(...) APPLY_PO_STAGE_1(__VA_ARGS__) APPLY_PO_STAGE(1, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_3(...) APPLY_PO_STAGE_2(__VA_ARGS__) APPLY_PO_STAGE(2, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_4(...) APPLY_PO_STAGE_3(__VA_ARGS__) APPLY_PO_STAGE(3, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_5(...) APPLY_PO_STAGE_4(__VA_ARGS__) APPLY_PO_STAGE(4, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_6(...) APPLY_PO_STAGE_5(__VA_ARGS__) APPLY_PO_STAGE(5, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_7(...) APPLY_PO_STAGE_6(__VA_ARGS__) APPLY_PO_STAGE(6, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_8(...) APPLY_PO_STAGE_7(__VA_ARGS__) APPLY_PO_STAGE(7, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_9(...) APPLY_PO_STAGE_8(__VA_ARGS__) APPLY_PO_STAGE(8, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_10(...) APPLY_PO_STAGE_9(__VA_ARGS__) APPLY_PO_STAGE(9, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_11(...) APPLY_PO_STAGE_10(__VA_ARGS__) APPLY_PO_STAGE(10, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_12(...) APPLY_PO_STAGE_11(__VA_ARGS__) APPLY_PO_STAGE(11, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_13(...) APPLY_PO_STAGE_12(__VA_ARGS__) APPLY_PO_STAGE(12, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_14(...) APPLY_PO_STAGE_13(__VA_ARGS__) APPLY_PO_STAGE(13, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_15(...) APPLY_PO_STAGE_14(__VA_ARGS__) APPLY_PO_STAGE(14, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_16(...) APPLY_PO_STAGE_15(__VA_ARGS__) APPLY_PO_STAGE(15, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_17(...) APPLY_PO_STAGE_16(__VA_ARGS__) APPLY_PO_STAGE(16, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_18(...) APPLY_PO_STAGE_17(__VA_ARGS__) APPLY_PO_STAGE(17, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_19(...) APPLY_PO_STAGE_18(__VA_ARGS__) APPLY_PO_STAGE(18, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_20(...) APPLY_PO_STAGE_19(__VA_ARGS__) APPLY_PO_STAGE(19, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_21(...) APPLY_PO_STAGE_20(__VA_ARGS__) APPLY_PO_STAGE(20, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_22(...) APPLY_PO_STAGE_21(__VA_ARGS__) APPLY_PO_STAGE(21, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_23(...) APPLY_PO_STAGE_22(__VA_ARGS__) APPLY_PO_STAGE(22, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_24(...) APPLY_PO_STAGE_23(__VA_ARGS__) APPLY_PO_STAGE(23, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_25(...) APPLY_PO_STAGE_24(__VA_ARGS__) APPLY_PO_STAGE(24, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_26(...) APPLY_PO_STAGE_25(__VA_ARGS__) APPLY_PO_STAGE(25, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_27(...) APPLY_PO_STAGE_26(__VA_ARGS__) APPLY_PO_STAGE(26, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_28(...) APPLY_PO_STAGE_27(__VA_ARGS__) APPLY_PO_STAGE(27, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_29(...) APPLY_PO_STAGE_28(__VA_ARGS__) APPLY_PO_STAGE(28, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_30(...) APPLY_PO_STAGE_29(__VA_ARGS__) APPLY_PO_STAGE(29, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_31(...) APPLY_PO_STAGE_30(__VA_ARGS__) APPLY_PO_STAGE(30, __VA_ARGS__))==""\n"
R"==(#define APPLY_PO_STAGE_32(...) APPLY_PO_STAGE_31(__VA_ARGS__) APPLY_PO_STAGE(31, __VA_ARGS__))==""\n"
R"==(#define APPLY_ALL_PO_STAGES(accumulator, acc_elem_dt, ...) \)==""\n"
R"==({ \)==""\n"
R"==(const int nelems = sizeof(accumulator) / sizeof(acc_elem_dt); \)==""\n"
R"==(acc_elem_dt *acc = &accumulator; \)==""\n"
R"==(CONCAT2(APPLY_PO_STAGE_, POST_OP_CHAIN_LENGTH) \)==""\n"
R"==((acc, acc_elem_dt, nelems, __VA_ARGS__) \)==""\n"
R"==(})==""\n"
R"==(#define APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \)==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \)==""\n"
R"==(is_burst) \)==""\n"
R"==(APPLY_ALL_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \)==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \)==""\n"
R"==(is_burst);)==""\n"
R"==(#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \)==""\n"
R"==(sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \)==""\n"
R"==(APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \)==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, oc_serial_incr, 0, 1, 0, 1, \)==""\n"
R"==(0, 1, 0, 1, true))==""\n"
R"==(#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \)==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \)==""\n"
R"==(d3_size, d4_start, d4_size, d5_start, d5_size) \)==""\n"
R"==(APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \)==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, 0, d2_start, d2_size, \)==""\n"
R"==(d3_start, d3_size, d4_start, d4_size, d5_start, d5_size, false))==""\n"
R"==(#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \)==""\n"
R"==(sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \)==""\n"
R"==(APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \)==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, 0, 0, 1, 0, 1, 0, 1, 0, 1, \)==""\n"
R"==(false))==""\n"
R"==(#else)==""\n"
R"==(#define APPLY_POST_OPS_SERIAL(...))==""\n"
R"==(#define APPLY_POST_OPS_SERIAL_BINARY_2D(...))==""\n"
R"==(#define APPLY_POST_OPS_TRY_BURST(...))==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}