namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_scales_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2022-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_SCALES_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_SCALES_H)==""\n"
R"==(inline void block_read_scales(float4 *data, int idx, int sg_local_id,)==""\n"
R"==(__global float *runtime_scales) {)==""\n"
R"==(if (OC > idx + (SUB_GROUP_SIZE * 4)) {)==""\n"
R"==(*data = as_float4(intel_sub_group_block_read4()==""\n"
R"==((__global uint *)&runtime_scales[idx]));)==""\n"
R"==(} else {)==""\n"
R"==(float local_dat[4] = {};)==""\n"
R"==(for (int i = 0; i < 4; ++i))==""\n"
R"==(if (idx + ((i + 1) * SUB_GROUP_SIZE) <= OC) {)==""\n"
R"==(local_dat[i] = as_float(intel_sub_group_block_read()==""\n"
R"==((__global uint *)&runtime_scales[idx)==""\n"
R"==(+ (SUB_GROUP_SIZE * i)]));)==""\n"
R"==(} else if (idx + (i * SUB_GROUP_SIZE) + sg_local_id < OC) {)==""\n"
R"==(local_dat[i] = runtime_scales[idx + (SUB_GROUP_SIZE * i))==""\n"
R"==(+ sg_local_id];)==""\n"
R"==(})==""\n"
R"==((*data).s0 = local_dat[0];)==""\n"
R"==((*data).s1 = local_dat[1];)==""\n"
R"==((*data).s2 = local_dat[2];)==""\n"
R"==((*data).s3 = local_dat[3];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}