namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_convolution_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_philox.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#undef SRC_OFF)==""\n"
R"==(#undef WEI_OFF)==""\n"
R"==(#undef DST_OFF)==""\n"
R"==(#define SRC_OFF CONV_SRC_OFF)==""\n"
R"==(#define WEI_OFF CONV_WEI_OFF)==""\n"
R"==(#define DST_OFF CONV_DST_OFF)==""\n"
R"==(#if WITH_WEI_ZPOINTS_DT_S8)==""\n"
R"==(#define WEI_ZP_T char)==""\n"
R"==(#elif WITH_WEI_ZPOINTS_DT_U8)==""\n"
R"==(#define WEI_ZP_T uchar)==""\n"
R"==(#else)==""\n"
R"==(#define WEI_ZP_T int)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_convolution_fwd()==""\n"
R"==(const __global SRC_DATA_T *src, const __global WEI_DATA_T *wei,)==""\n"
R"==(const __global BIA_DATA_T *bias, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(const __global SRC_SCALES_DATA_T *src_scales,)==""\n"
R"==(const __global WEI_SCALES_DATA_T *wei_scales,)==""\n"
R"==(const __global DST_SCALES_DATA_T *dst_scales,)==""\n"
R"==(const __global int *src_zpoints, const __global WEI_ZP_T *wei_zpoints,)==""\n"
R"==(const __global int *dst_zpoints)==""\n"
R"==(#if WITH_SROUND)==""\n"
R"==(,)==""\n"
R"==(__global uint *sround_seed_buf)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(#if WITH_SROUND)==""\n"
R"==(uint sround_seed = sround_seed_buf[0];)==""\n"
R"==(#endif)==""\n"
R"==(src += SRC_OFFSET0;)==""\n"
R"==(dst += DST_OFFSET0;)==""\n"
R"==(const off_t n = GWS_GET_MB();)==""\n"
R"==(const off_t oc = GWS_GET_OC();)==""\n"
R"==(const off_t g = GWS_GET_G();)==""\n"
R"==(const off_t od = GWS_GET_OD();)==""\n"
R"==(const off_t oh = GWS_GET_OH();)==""\n"
R"==(const off_t ow = GWS_GET_OW();)==""\n"
R"==(ACC_DATA_T d = 0;)==""\n"
R"==(for (off_t ic = 0; ic < IC; ++ic))==""\n"
R"==(for (off_t kd = 0; kd < KD; ++kd))==""\n"
R"==(for (off_t kh = 0; kh < KH; ++kh))==""\n"
R"==(for (off_t kw = 0; kw < KW; ++kw) {)==""\n"
R"==(const off_t id = od * SD - PD + kd * (1 + DD);)==""\n"
R"==(const off_t ih = oh * SH - PH + kh * (1 + DH);)==""\n"
R"==(const off_t iw = ow * SW - PW + kw * (1 + DW);)==""\n"
R"==(if (id < 0 || id >= ID || ih < 0 || ih >= IH || iw < 0)==""\n"
R"==(|| iw >= IW))==""\n"
R"==(continue;)==""\n"
R"==(const off_t src_off = SRC_OFF(n, g * IC + ic, id, ih, iw);)==""\n"
R"==(const off_t wei_off = WEI_OFF(g, oc, ic, kd, kh, kw);)==""\n"
R"==(d += SRC_TO_REF(src[src_off]) * WEI_TO_REF(wei[wei_off]);)==""\n"
R"==(#if WITH_SRC_ZPOINTS)==""\n"
R"==(const int src_zp)==""\n"
R"==(= src_zpoints[WITH_SRC_ZPOINTS_PER_IC ? g * IC + ic)==""\n"
R"==(: 0];)==""\n"
R"==(d -= src_zp * WEI_TO_REF(wei[wei_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_WEI_ZPOINTS)==""\n"
R"==(const int wei_zp = wei_zpoints[0];)==""\n"
R"==(d -= wei_zp * SRC_TO_REF(src[src_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_ZPOINTS)==""\n"
R"==(#if WITH_WEI_ZPOINTS)==""\n"
R"==(d += src_zp * wei_zp;)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T tmp = d;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(tmp *= SRC_SCALES_TO_REF(src_scales[0]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_WEI_SCALES)==""\n"
R"==(#if WEI_SCALES_MASK == 0)==""\n"
R"==(tmp *= WEI_SCALES_TO_REF(wei_scales[0]);)==""\n"
R"==(#else)==""\n"
R"==(tmp *= WEI_SCALES_TO_REF(wei_scales[g * OC + oc]);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(tmp += (POST_OP_DATA_T)BIA_TO_REF(bias[g * OC + oc]);)==""\n"
R"==(#endif)==""\n"
R"==(POST_OP_DATA_T sum_src;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = (POST_OP_DATA_T)SUM_TO_REF()==""\n"
R"==(AS_SUM_DATA_T(dst[DST_OFF(n, g * OC + oc, od, oh, ow)]));)==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 3)==""\n"
R"==(const unsigned po_d2 = ow;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(const unsigned po_d2 = oh;)==""\n"
R"==(const unsigned po_d3 = ow;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 5)==""\n"
R"==(const unsigned po_d2 = od;)==""\n"
R"==(const unsigned po_d3 = oh;)==""\n"
R"==(const unsigned po_d4 = ow;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = 0;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SROUND)==""\n"
R"==(tmp = stochastic_round_fwd()==""\n"
R"==(tmp, DST_OFF(n, g * OC + oc, od, oh, ow), sround_seed);)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(tmp, POST_OP_DATA_T, sum_src, POST_OP_DATA_T, n, 1,)==""\n"
R"==(g * OC + oc, 1, po_d2, 1, po_d3, 1, po_d4, 1, 0, 1);)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(#if DST_SCALES_MASK == 0)==""\n"
R"==(tmp /= DST_SCALES_TO_REF(dst_scales[0]);)==""\n"
R"==(#else)==""\n"
R"==(tmp /= DST_SCALES_TO_REF(dst_scales[g * OC + oc]);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_ZPOINTS)==""\n"
R"==(const int dst_zp = dst_zpoints[WITH_DST_ZPOINTS_PER_OC ? g * OC + oc : 0];)==""\n"
R"==(tmp += dst_zp;)==""\n"
R"==(#endif )==""\n"
R"==(dst[DST_OFF(n, g * OC + oc, od, oh, ow)] = TO_DST(tmp);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD_D)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_convolution_bwd_data(__global SRC_DATA_T *diff_src,)==""\n"
R"==(const __global WEI_DATA_T *wei, const __global DST_DATA_T *diff_dst,)==""\n"
R"==(const __global BIA_DATA_T *bias POST_OP_ARGS,)==""\n"
R"==(const __global float *src_scales, const __global float *wei_scales,)==""\n"
R"==(const __global float *dst_scales, const __global int *src_zpoints,)==""\n"
R"==(const __global WEI_ZP_T *wei_zpoints, const __global int *dst_zpoints) {)==""\n"
R"==(const off_t n = GWS_GET_MB();)==""\n"
R"==(const off_t ic = GWS_GET_IC();)==""\n"
R"==(const off_t g = GWS_GET_G();)==""\n"
R"==(const off_t id = GWS_GET_ID();)==""\n"
R"==(const off_t ih = GWS_GET_IH();)==""\n"
R"==(const off_t iw = GWS_GET_IW();)==""\n"
R"==(ACC_DATA_T d = 0.0;)==""\n"
R"==(for_(off_t oc = 0; oc < OC; ++oc))==""\n"
R"==(for_(off_t kd = 0; kd < KD; ++kd))==""\n"
R"==(for_(off_t kh = 0; kh < KH; ++kh))==""\n"
R"==(for (off_t kw = 0; kw < KW; ++kw) {)==""\n"
R"==(if (iw + PW < kw * (1 + DW) || ih + PH < kh * (1 + DH))==""\n"
R"==(|| id + PD < kd * (1 + DD)))==""\n"
R"==(continue;)==""\n"
R"==(off_t ow = iw - kw * (1 + DW) + PW;)==""\n"
R"==(off_t oh = ih - kh * (1 + DH) + PH;)==""\n"
R"==(off_t od = id - kd * (1 + DD) + PD;)==""\n"
R"==(if (ow % SW != 0 || oh % SH != 0 || od % SD != 0) continue;)==""\n"
R"==(ow /= SW;)==""\n"
R"==(oh /= SH;)==""\n"
R"==(od /= SD;)==""\n"
R"==(if (oh < OH && ow < OW && od < OD) {)==""\n"
R"==(const off_t dst_off = DST_OFF(n, g * OC + oc, od, oh, ow);)==""\n"
R"==(const off_t wei_off = WEI_OFF(g, oc, ic, kd, kh, kw);)==""\n"
R"==(d += DST_TO_REF(diff_dst[dst_off]) * WEI_TO_REF(wei[wei_off]);)==""\n"
R"==(#if WITH_SRC_ZPOINTS)==""\n"
R"==(const int src_zp)==""\n"
R"==(= src_zpoints[WITH_SRC_ZPOINTS_PER_IC ? g * OC + oc : 0];)==""\n"
R"==(d -= src_zp * WEI_TO_REF(wei[wei_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_WEI_ZPOINTS)==""\n"
R"==(const int wei_zp = wei_zpoints[0];)==""\n"
R"==(d -= wei_zp * DST_TO_REF(diff_dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_ZPOINTS)==""\n"
R"==(#if WITH_WEI_ZPOINTS)==""\n"
R"==(d += src_zp * wei_zp;)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T tmp = d;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(tmp *= src_scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_WEI_SCALES)==""\n"
R"==(#if WEI_SCALES_MASK == 0)==""\n"
R"==(tmp *= wei_scales[0];)==""\n"
R"==(#else)==""\n"
R"==(tmp *= wei_scales[g * IC + ic];)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(tmp += (POST_OP_DATA_T)BIA_TO_REF(bias[g * IC + ic]);)==""\n"
R"==(#endif)==""\n"
R"==(POST_OP_DATA_T sum_src;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = (POST_OP_DATA_T)SUM_TO_REF()==""\n"
R"==(AS_SUM_DATA_T(diff_src[SRC_OFF(n, g * IC + ic, id, ih, iw)]));)==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 3)==""\n"
R"==(const unsigned po_d2 = iw;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(const unsigned po_d2 = ih;)==""\n"
R"==(const unsigned po_d3 = iw;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 5)==""\n"
R"==(const unsigned po_d2 = id;)==""\n"
R"==(const unsigned po_d3 = ih;)==""\n"
R"==(const unsigned po_d4 = iw;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = 0;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(tmp, POST_OP_DATA_T, sum_src, POST_OP_DATA_T, n, 1,)==""\n"
R"==(g * IC + ic, 1, po_d2, 1, po_d3, 1, po_d4, 1, 0, 1);)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(tmp /= dst_scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_ZPOINTS)==""\n"
R"==(const int dst_zp = dst_zpoints[WITH_DST_ZPOINTS_PER_OC ? g * IC + ic : 0];)==""\n"
R"==(tmp += dst_zp;)==""\n"
R"==(#endif )==""\n"
R"==(diff_src[SRC_OFF(n, g * IC + ic, id, ih, iw)] = TO_SRC(tmp);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD_W)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_convolution_bwd_weights(const __global SRC_DATA_T *src,)==""\n"
R"==(__global WEI_DATA_T *diff_wei, __global BIA_DATA_T *diff_bias,)==""\n"
R"==(const __global DST_DATA_T *diff_dst) {)==""\n"
R"==(const off_t g = GWS_GET_G();)==""\n"
R"==(const off_t ic = GWS_GET_IC();)==""\n"
R"==(const off_t oc = GWS_GET_OC();)==""\n"
R"==(const off_t kd = GWS_GET_KD();)==""\n"
R"==(const off_t kh = GWS_GET_KH();)==""\n"
R"==(const off_t kw = GWS_GET_KW();)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(if (ic == 0 && kh == 0 && kw == 0 & kd == 0) {)==""\n"
R"==(ACC_DATA_T d = 0.0;)==""\n"
R"==(for (off_t n = 0; n < MB; ++n))==""\n"
R"==(for (off_t od = 0; od < OD; ++od))==""\n"
R"==(for (off_t oh = 0; oh < OH; ++oh))==""\n"
R"==(for (off_t ow = 0; ow < OW; ++ow) {)==""\n"
R"==(d += DST_TO_REF()==""\n"
R"==(diff_dst[DST_OFF(n, g * OC + oc, od, oh, ow)]);)==""\n"
R"==(})==""\n"
R"==(diff_bias[g * OC + oc] = TO_BIA(d);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(ACC_DATA_T dw = 0.0;)==""\n"
R"==(for (off_t n = 0; n < MB; ++n))==""\n"
R"==(for (off_t od = 0; od < OD; ++od))==""\n"
R"==(for (off_t oh = 0; oh < OH; ++oh))==""\n"
R"==(for (off_t ow = 0; ow < OW; ++ow) {)==""\n"
R"==(if (ow * SW + kw * (1 + DW) < PW)==""\n"
R"==(|| oh * SH + kh * (1 + DH) < PH)==""\n"
R"==(|| od * SD + kd * (1 + DD) < PD)==""\n"
R"==(|| ow * SW + kw * (1 + DW) >= IW + PW)==""\n"
R"==(|| oh * SH + kh * (1 + DH) >= IH + PH)==""\n"
R"==(|| od * SD + kd * (1 + DD) >= ID + PD))==""\n"
R"==(continue;)==""\n"
R"==(off_t id = od * SD - PD + kd * (1 + DD);)==""\n"
R"==(off_t ih = oh * SH - PH + kh * (1 + DH);)==""\n"
R"==(off_t iw = ow * SW - PW + kw * (1 + DW);)==""\n"
R"==(dw += DST_TO_REF()==""\n"
R"==(diff_dst[DST_OFF(n, g * OC + oc, od, oh, ow)]))==""\n"
R"==(* SRC_TO_REF()==""\n"
R"==(src[SRC_OFF(n, g * IC + ic, id, ih, iw)]);)==""\n"
R"==(})==""\n"
R"==(diff_wei[WEI_OFF(g, oc, ic, kd, kh, kw)] = TO_WEI(dw);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}