namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_eltwise_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_eltwise.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(#define DATA_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DATA, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define DIFF_DATA_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==(OFF_MD(DIFF_DATA, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define GWS_GET_THREAD_ID(index) (get_global_id(index) + offset.array[index]))==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__kernel void ref_eltwise_fwd(__global DATA_T *src, __global DATA_T *dst,)==""\n"
R"==(float alpha, float beta, int64x3_t offset POST_OP_ARGS) {)==""\n"
R"==(#if USE_GWS_GET)==""\n"
R"==(dim_t d0 = GWS_GET_D0();)==""\n"
R"==(dim_t d1 = GWS_GET_D1();)==""\n"
R"==(dim_t d2 = GWS_GET_D2();)==""\n"
R"==(dim_t d3 = GWS_GET_D3();)==""\n"
R"==(dim_t d4 = GWS_GET_D4();)==""\n"
R"==(dim_t d5 = GWS_GET_D5();)==""\n"
R"==(const dim_t data_off = DATA_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(if (d0 >= DATA_D0 || d1 >= DATA_D1 || d2 >= DATA_D2 || d3 >= DATA_D3)==""\n"
R"==(|| d4 >= DATA_D4 || d5 >= DATA_D5) {)==""\n"
R"==(dst[data_off] = CONVERT_DATA_T(0.f);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const dim_t data_off = get_global_id(0))==""\n"
R"==(#if GWS1 > 1)==""\n"
R"==(+ get_global_id(1) * GWS0)==""\n"
R"==(#endif)==""\n"
R"==(#if GWS2 > 1)==""\n"
R"==(+ get_global_id(2) * GWS0 * GWS1)==""\n"
R"==(#endif)==""\n"
R"==(;)==""\n"
R"==(const dim_t d0 = 0;)==""\n"
R"==(const dim_t d1 = 0;)==""\n"
R"==(const dim_t d2 = 0;)==""\n"
R"==(const dim_t d3 = 0;)==""\n"
R"==(const dim_t d4 = 0;)==""\n"
R"==(const dim_t d5 = 0;)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_F16 == 1)==""\n"
R"==(float tmp_s = CONVERT_FLOAT_T(src[data_off]);)==""\n"
R"==(#else)==""\n"
R"==(float tmp_s = DATA_TO_REF(src[data_off]);)==""\n"
R"==(#endif)==""\n"
R"==(tmp_s = fwd_eltwise(tmp_s, alpha, beta, 1.0f);)==""\n"
R"==(float dst_data;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = convert_float(DATA_TO_REF(dst[data_off]));)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(tmp_s, float, dst_data, float, d0, 1, d1, 1, d2, 1,)==""\n"
R"==(d3, 1, d4, 1, d5, 1);)==""\n"
R"==(dst[data_off] = CONVERT_DATA_T(tmp_s);)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(#if DT_F32 == 1 || DT_BF16 == 1 || DT_F16 == 1)==""\n"
R"==(__kernel void ref_eltwise_bwd(__global DATA_T *src, __global DATA_T *diff_src,)==""\n"
R"==(__global DATA_T *diff_dst, float alpha, float beta, int64x3_t offset) {)==""\n"
R"==(dim_t d0 = GWS_GET_D0();)==""\n"
R"==(dim_t d1 = GWS_GET_D1();)==""\n"
R"==(dim_t d2 = GWS_GET_D2();)==""\n"
R"==(dim_t d3 = GWS_GET_D3();)==""\n"
R"==(dim_t d4 = GWS_GET_D4();)==""\n"
R"==(dim_t d5 = GWS_GET_D5();)==""\n"
R"==(const dim_t data_off = DATA_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(const dim_t diff_data_off = DIFF_DATA_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(if (d0 >= DATA_D0 || d1 >= DATA_D1 || d2 >= DATA_D2 || d3 >= DATA_D3)==""\n"
R"==(|| d4 >= DATA_D4 || d5 >= DATA_D5) {)==""\n"
R"==(diff_src[diff_data_off] = CONVERT_DATA_T(0.f);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T tmp_dd = DATA_TO_REF(diff_dst[diff_data_off]);)==""\n"
R"==(POST_OP_DATA_T tmp_s = DATA_TO_REF(src[data_off]);)==""\n"
R"==(diff_src[diff_data_off])==""\n"
R"==(= CONVERT_DATA_T(bwd_eltwise(tmp_dd, tmp_s, alpha, beta));)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}