namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_layer_normalization_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/layer_norm_common.h")==""\n"
R"==(#if IS_FWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_lnorm_fwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DST_DATA_T *dst,)==""\n"
R"==(__global WEI_DATA_T *scale, __global WEI_DATA_T *shift, float eps,)==""\n"
R"==(__global float *src_scale, __global float *dst_scale) {)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(x[0] = GWS_GET_X0();)==""\n"
R"==(x[1] = GWS_GET_X1();)==""\n"
R"==(x[2] = GWS_GET_X2();)==""\n"
R"==(x[3] = GWS_GET_X3();)==""\n"
R"==(if (x[0] >= DST_D0 || x[1] >= DST_D1 || x[2] >= DST_D2 || x[3] >= DST_D3) {)==""\n"
R"==(for (int c = 0; c < C; ++c) {)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(dst[dst_off] = TO_DST(CONVERT_DATA_T(0.f));)==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(int s_off = STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(ACC_DATA_T v_mean = CALCULATE_STATS ? 0 : mean[s_off];)==""\n"
R"==(ACC_DATA_T v_variance = CALCULATE_STATS ? 0 : variance[s_off];)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(for (int c = 0; c < C; ++c) {)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(v_mean += SRC_TO_REF(src[src_off]);)==""\n"
R"==(})==""\n"
R"==(v_mean /= C;)==""\n"
R"==(for (int c = 0; c < C; ++c) {)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(ACC_DATA_T m = SRC_TO_REF(src[src_off]) - v_mean;)==""\n"
R"==(v_variance += m * m;)==""\n"
R"==(})==""\n"
R"==(v_variance /= C;)==""\n"
R"==(})==""\n"
R"==(ACC_DATA_T rsqrt_variance = rsqrt(v_variance + eps);)==""\n"
R"==(for (int c = 0; c < C; ++c) {)==""\n"
R"==(ACC_DATA_T sm = (scale ? CONVERT_WEI_FLOAT_T(scale[c]) : 1.0f))==""\n"
R"==(* rsqrt_variance;)==""\n"
R"==(ACC_DATA_T sv = shift ? CONVERT_WEI_FLOAT_T(shift[c]) : 0.0f;)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(ACC_DATA_T d = (sm * (SRC_TO_REF(src[src_off]) - v_mean) + sv);)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(d *= src_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(d /= dst_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(dst[dst_off] = TO_DST(d);)==""\n"
R"==(})==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(if (SAVE_STATS) {)==""\n"
R"==(mean[s_off] = convert_float(v_mean);)==""\n"
R"==(variance[s_off] = convert_float(v_variance);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(#if USE_SCALE || USE_SHIFT)==""\n"
R"==(NAMED_KERNEL_ATTR(SCALESHIFT))==""\n"
R"==(__kernel void ref_lnorm_bwd_scaleshift(__global SRC_DATA_T *src,)==""\n"
R"==(__global float *mean, __global float *variance,)==""\n"
R"==(__global DATA_T *diff_dst, __global WEI_DATA_T *diff_scale,)==""\n"
R"==(__global WEI_DATA_T *diff_shift, float eps) {)==""\n"
R"==(const int c = GWS_GET_C();)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(float diff_gamma = 0;)==""\n"
R"==(float diff_beta = 0;)==""\n"
R"==(for (x[0] = 0; x[0] < max(1, STAT_D0); ++x[0]) {)==""\n"
R"==(for (x[1] = 0; x[1] < max(1, STAT_D1); ++x[1]) {)==""\n"
R"==(for (x[2] = 0; x[2] < max(1, STAT_D2); ++x[2]) {)==""\n"
R"==(for (x[3] = 0; x[3] < max(1, STAT_D3); ++x[3]) {)==""\n"
R"==(x[NDIMS - 1] = 0;)==""\n"
R"==(const int s_off)==""\n"
R"==(= STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off)==""\n"
R"==(= SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off)==""\n"
R"==(= DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const float inv_sqrt_variance)==""\n"
R"==(= rsqrt(variance[s_off] + eps);)==""\n"
R"==(const float dd = DST_TO_REF(diff_dst[dst_off]);)==""\n"
R"==(diff_gamma += (SRC_TO_REF(src[src_off]) - mean[s_off]) * dd)==""\n"
R"==(* inv_sqrt_variance;)==""\n"
R"==(diff_beta += dd;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(if (diff_scale) diff_scale[c] = CONVERT_WEI_DATA_T(diff_gamma);)==""\n"
R"==(if (diff_shift) diff_shift[c] = CONVERT_WEI_DATA_T(diff_beta);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_lnorm_bwd(__global SRC_DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global WEI_DATA_T *scale, __global SRC_DATA_T *diff_src, float eps) {)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(x[0] = GWS_GET_X0();)==""\n"
R"==(x[1] = GWS_GET_X1();)==""\n"
R"==(x[2] = GWS_GET_X2();)==""\n"
R"==(x[3] = GWS_GET_X3();)==""\n"
R"==(const int s_off = STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const ACC_DATA_T mean_val = mean[s_off];)==""\n"
R"==(const ACC_DATA_T inv_sqrt_variance = rsqrt(variance[s_off] + eps);)==""\n"
R"==(ACC_DATA_T dd_gamma = 0;)==""\n"
R"==(ACC_DATA_T dd_gamma_x = 0;)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(for (int c = 0; c < C; ++c) {)==""\n"
R"==(const ACC_DATA_T gamma)==""\n"
R"==(= scale ? CONVERT_WEI_FLOAT_T(scale[c]) : 1.0f;)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const ACC_DATA_T dd = DST_TO_REF(diff_dst[dst_off]);)==""\n"
R"==(dd_gamma += dd * gamma;)==""\n"
R"==(dd_gamma_x += dd * gamma * (SRC_TO_REF(src[src_off]) - mean_val);)==""\n"
R"==(})==""\n"
R"==(dd_gamma_x *= inv_sqrt_variance;)==""\n"
R"==(})==""\n"
R"==(for (int c = 0; c < C; ++c) {)==""\n"
R"==(const ACC_DATA_T gamma = scale ? CONVERT_WEI_FLOAT_T(scale[c]) : 1.0f;)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(ACC_DATA_T v_diff_src = DST_TO_REF(diff_dst[dst_off]) * gamma;)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(v_diff_src -= dd_gamma / C)==""\n"
R"==(+ (SRC_TO_REF(src[src_off]) - mean_val) * dd_gamma_x)==""\n"
R"==(* inv_sqrt_variance / C;)==""\n"
R"==(})==""\n"
R"==(v_diff_src *= inv_sqrt_variance;)==""\n"
R"==(diff_src[src_off] = TO_SRC(v_diff_src);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}