namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *rnn_grid_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/rnn/cell_compute.h")==""\n"
R"==(#include "gpu/intel/ocl/rnn/cell_kind_utility.h")==""\n"
R"==(#include "gpu/intel/ocl/rnn/rnn_common.h")==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(simple_rnn_copy_init_layer(__global WS_STATE_DATA_T *dst_base,)==""\n"
R"==(__global char *src_base, __global AUX_DATA_T *scratch_diff_states,)==""\n"
R"==(int lr, int rl, int batch, int dhc, int slc, int n_iter, int n_layer,)==""\n"
R"==(int n_dir, int n_states, int states_ws_ld, int scratch_diff_states_ld,)==""\n"
R"==(int64x3_t strides) {)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(const int it = get_global_id(2);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int c = get_global_id(0);)==""\n"
R"==(if (c >= slc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global WS_STATE_DATA_T *dst;)==""\n"
R"==(__global WS_STATE_DATA_T *src = (__global WS_STATE_DATA_T *)src_base)==""\n"
R"==(+ src_l_off(strides, it, b, c);)==""\n"
R"==(if (lr) {)==""\n"
R"==(dst = dst_base)==""\n"
R"==(+ off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld, -1,)==""\n"
R"==(0, it, b, c);)==""\n"
R"==(dst[0] = src[0];)==""\n"
R"==(})==""\n"
R"==(if (rl) {)==""\n"
R"==(dst = dst_base)==""\n"
R"==(+ off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld, -1,)==""\n"
R"==(n_dir - 1, n_iter - it - 1, b, c);)==""\n"
R"==(dst[0] = src[0];)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(const int it = get_global_id(2);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(if (s >= dhc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global AUX_DATA_T *dst = scratch_diff_states;)==""\n"
R"==(#if DIRECTION_KIND == CONCAT)==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base)==""\n"
R"==(+ diff_dst_l_off(strides, it, b, s);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[0];)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 1, n_states, n_iter - it - 1, b,)==""\n"
R"==(s)])==""\n"
R"==(= src[dhc];)==""\n"
R"==(#elif DIRECTION_KIND == SUM)==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base)==""\n"
R"==(+ diff_dst_l_off(strides, it, b, s);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[0];)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 1, n_states, n_iter - it - 1, b,)==""\n"
R"==(s)])==""\n"
R"==(= src[0];)==""\n"
R"==(#elif DIRECTION_KIND == L2R)==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base)==""\n"
R"==(+ diff_dst_l_off(strides, it, b, s);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[0];)==""\n"
R"==(#elif DIRECTION_KIND == R2L)==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base)==""\n"
R"==(+ diff_dst_l_off(strides, n_iter - it - 1, b, s);)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, n_layer, 0, n_states, it, b, s)])==""\n"
R"==(= src[0];)==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported direction_kind")==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__kernel void simple_rnn_copy_init_iter(__global WS_STATE_DATA_T *dst_base,)==""\n"
R"==(__global AUX_DATA_T *dst_c_base, __global char *src_base,)==""\n"
R"==(__global char *src_c_base, __global AUX_DATA_T *scratch_diff_states,)==""\n"
R"==(int batch, int dhc, int sic, int n_iter, int n_layer, int n_dir,)==""\n"
R"==(int n_states, int states_ws_ld,)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(int64x4_t src_iter_strides,)==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(int64x4_t src_iter_c_strides,)==""\n"
R"==(#endif )==""\n"
R"==(const float shift, const float scale, const int quantize,)==""\n"
R"==(#else )==""\n"
R"==(int64x4_t diff_dst_iter_strides,)==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(int64x4_t diff_dst_iter_c_strides,)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(int scratch_diff_states_ld) {)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int lay = get_global_id(2) / n_dir;)==""\n"
R"==(const int dir = get_global_id(2) % n_dir;)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__global INPUT_DATA_T *src = (__global INPUT_DATA_T *)(src_base);)==""\n"
R"==(__global WS_STATE_DATA_T *dst = dst_base;)==""\n"
R"==(int ws_state_offset = off_ws_state()==""\n"
R"==(n_layer, n_dir, n_iter, batch, states_ws_ld, lay, dir, -1, b, s);)==""\n"
R"==(if (s < sic) {)==""\n"
R"==(int src_i_offset = src_i_off(src_iter_strides, lay, dir, b, s);)==""\n"
R"==(dst[ws_state_offset] = src_base)==""\n"
R"==(? (quantize ? TO_WS_STATE(src[src_i_offset] * scale + shift))==""\n"
R"==(: src[src_i_offset]))==""\n"
R"==(: TO_WS_STATE(0.0f);)==""\n"
R"==(})==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(__global SRC_C_DATA_T *src_c = (__global SRC_C_DATA_T *)(src_c_base);)==""\n"
R"==(__global AUX_DATA_T *dst_c = dst_c_base;)==""\n"
R"==(if (s < dhc) {)==""\n"
R"==(int ws_c_state_offset = off_ws_c_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay, dir, -1, b, s);)==""\n"
R"==(dst_c[ws_c_state_offset] = src_c_base)==""\n"
R"==(? TO_AUX(src_c[src_i_c_off(src_iter_c_strides, lay, dir, b, s)]))==""\n"
R"==(: TO_AUX(0.0f);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(src_base);)==""\n"
R"==(__global AUX_DATA_T *dst = scratch_diff_states;)==""\n"
R"==(if (s < dhc))==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, lay, dir, 0, n_iter, b, s)])==""\n"
R"==(= src_base)==""\n"
R"==(? src[diff_dst_i_off(diff_dst_iter_strides, lay, dir, b, s)])==""\n"
R"==(: 0.0f;)==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(__global DIFF_DATA_T *src_c = (__global DIFF_DATA_T *)(src_c_base);)==""\n"
R"==(if (s < dhc) {)==""\n"
R"==(dst[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter, batch,)==""\n"
R"==(scratch_diff_states_ld, lay, dir, 1, n_iter, b, s)])==""\n"
R"==(= src_c_base ? src_c[diff_dst_i_c_off()==""\n"
R"==(diff_dst_iter_c_strides, lay, dir, b, s)])==""\n"
R"==(: 0.0f;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(simple_rnn_copy_res_layer()==""\n"
R"==(__global WS_STATE_DATA_T *src_base, __global char *dst_base,)==""\n"
R"==(__global AUX_DATA_T *scratch_diff_states, int lr, int rl, int batch,)==""\n"
R"==(int dhc, int slc, int n_iter, int n_layer, int n_dir, int n_states,)==""\n"
R"==(int states_ws_ld, int scratch_diff_states_ld, int64x3_t strides)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(,)==""\n"
R"==(const float shift, const float scale, const int dequantize)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int it = get_global_id(2);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(if (s >= dhc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global WS_STATE_DATA_T *src = src_base;)==""\n"
R"==(__global DST_DATA_T *dst = (__global DST_DATA_T *)(dst_base);)==""\n"
R"==(int dir = 0;)==""\n"
R"==(if (lr) {)==""\n"
R"==(bool dequantize_at_copy = dequantize && DIRECTION_KIND != SUM;)==""\n"
R"==(dst[dst_l_off(strides, it, b, dir * dhc + s)] = dequantize_at_copy)==""\n"
R"==(? TO_DST(((float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, n_layer - 1, dir, it, b, s)])==""\n"
R"==(- shift))==""\n"
R"==(/ scale))==""\n"
R"==(: src[off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld,)==""\n"
R"==(n_layer - 1, dir, it, b, s)];)==""\n"
R"==(dir = 1;)==""\n"
R"==(})==""\n"
R"==(if (rl) {)==""\n"
R"==(#if DIRECTION_KIND == SUM)==""\n"
R"==(if (dequantize) {)==""\n"
R"==(float val = (float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, n_layer - 1, dir, n_iter - it - 1,)==""\n"
R"==(b, s)])==""\n"
R"==(+ dst[dst_l_off(strides, it, b, s)];)==""\n"
R"==(val = min(max(val, 0.f), 255.f);)==""\n"
R"==(dst[dst_l_off(strides, it, b, s)])==""\n"
R"==(= TO_DST((val - 2 * shift) / scale);)==""\n"
R"==(} else {)==""\n"
R"==(#if defined(SRC_DT_U8) && defined(DST_DT_U8))==""\n"
R"==(dst[dst_l_off(strides, it, b, s)] = convert_uchar_sat()==""\n"
R"==(convert_short(src[off_ws_state(n_layer, n_dir, n_iter,)==""\n"
R"==(batch, states_ws_ld, n_layer - 1, dir,)==""\n"
R"==(n_iter - it - 1, b, s)]))==""\n"
R"==(+ convert_short(dst[dst_l_off(strides, it, b, s)]));)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T temp_src = DST_TO_REF(dst[dst_l_off(strides, it, b, s)]);)==""\n"
R"==(temp_src += DST_TO_REF(src[off_ws_state(n_layer, n_dir, n_iter,)==""\n"
R"==(batch, states_ws_ld, n_layer - 1, dir, n_iter - it - 1, b,)==""\n"
R"==(s)]);)==""\n"
R"==(dst[dst_l_off(strides, it, b, s)] = REF_TO_DST(temp_src);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(dst[dst_l_off(strides, it, b, dir * dhc + s)] = dequantize)==""\n"
R"==(? TO_DST(((float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, n_layer - 1, dir,)==""\n"
R"==(n_iter - it - 1, b, s)])==""\n"
R"==(- shift))==""\n"
R"==(/ scale))==""\n"
R"==(: src[off_ws_state(n_layer, n_dir, n_iter, batch, states_ws_ld,)==""\n"
R"==(n_layer - 1, dir, n_iter - it - 1, b, s)];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(if (s >= slc || b >= batch || it >= n_iter) return;)==""\n"
R"==(__global AUX_DATA_T *src = scratch_diff_states;)==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base);)==""\n"
R"==(int dir = 0;)==""\n"
R"==(#if DIRECTION_KIND == R2L)==""\n"
R"==(const int iter = n_iter - 1 - it;)==""\n"
R"==(#else)==""\n"
R"==(const int iter = it;)==""\n"
R"==(#endif)==""\n"
R"==(DIFF_DATA_T res = src[off_scratch_diff_states(n_layer, n_dir, n_states,)==""\n"
R"==(n_iter, batch, scratch_diff_states_ld, 0, 0, n_states, it, b, s)];)==""\n"
R"==(if (n_dir > 1) {)==""\n"
R"==(res += src[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, 0, 1, n_states, n_iter - 1 - it,)==""\n"
R"==(b, s)];)==""\n"
R"==(})==""\n"
R"==(dst[diff_src_l_off(strides, iter, b, dir * slc + s)] = res;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__kernel void simple_rnn_copy_res_iter()==""\n"
R"==(__global WS_STATE_DATA_T *src_base, __global AUX_DATA_T *src_c_base,)==""\n"
R"==(__global char *dst_base, __global char *dst_c_base,)==""\n"
R"==(__global AUX_DATA_T *scratch_diff_states, int batch, int dhc, int sic,)==""\n"
R"==(int n_iter, int n_layer, int n_dir, int n_states, int states_ws_ld,)==""\n"
R"==(int scratch_diff_states_ld, int64x4_t strides)==""\n"
R"==(#if (IS_FWD && WITH_DST_ITER_C) || (!IS_FWD && WITH_SRC_ITER_C))==""\n"
R"==(,)==""\n"
R"==(int64x4_t c_strides)==""\n"
R"==(#endif )==""\n"
R"==(#if IS_FWD)==""\n"
R"==(,)==""\n"
R"==(const float shift, const float scale, const int dequantize)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int s = get_global_id(0);)==""\n"
R"==(const int b = get_global_id(1);)==""\n"
R"==(const int lay = get_global_id(2) / n_dir;)==""\n"
R"==(const int dir = get_global_id(2) % n_dir;)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__global WS_STATE_DATA_T *src = src_base;)==""\n"
R"==(__global OUTPUT_DATA_T *dst = (__global OUTPUT_DATA_T *)(dst_base);)==""\n"
R"==(if (dst_base && s < dhc) {)==""\n"
R"==(dst[dst_i_off(strides, lay, dir, b, s)] = dequantize)==""\n"
R"==(? TO_OUTPUT()==""\n"
R"==(((float)src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay, dir, n_iter - 1, b, s)])==""\n"
R"==(- shift))==""\n"
R"==(/ scale))==""\n"
R"==(: TO_OUTPUT(src[off_ws_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay, dir, n_iter - 1, b, s)]);)==""\n"
R"==(})==""\n"
R"==(#if WITH_DST_ITER_C)==""\n"
R"==(__global AUX_DATA_T *src_c = src_c_base;)==""\n"
R"==(__global DST_C_DATA_T *dst_c = (__global DST_C_DATA_T *)(dst_c_base);)==""\n"
R"==(if (dst_c_base && s < dhc) {)==""\n"
R"==(dst_c[dst_i_c_off(c_strides, lay, dir, b, s)])==""\n"
R"==(= src_c[off_ws_c_state(n_layer, n_dir, n_iter, batch,)==""\n"
R"==(states_ws_ld, lay, dir, n_iter - 1, b, s)];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(__global AUX_DATA_T *src = scratch_diff_states;)==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base);)==""\n"
R"==(__global DIFF_DATA_T *dst_c = (__global DIFF_DATA_T *)(dst_c_base);)==""\n"
R"==(if (dst_base && s < sic) {)==""\n"
R"==(dst[diff_src_i_off(strides, lay, dir, b, s)])==""\n"
R"==(= src[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 0, 0, b, s)];)==""\n"
R"==(})==""\n"
R"==(#if WITH_SRC_ITER_C)==""\n"
R"==(if (dst_base && s < dhc) {)==""\n"
R"==(dst_c[diff_src_i_c_off(c_strides, lay, dir, b, s)])==""\n"
R"==(= src[off_scratch_diff_states(n_layer, n_dir, n_states, n_iter,)==""\n"
R"==(batch, scratch_diff_states_ld, lay, dir, 1, 0, b, s)];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(__kernel void rnn_bias_prepare(__global float *ws_bias, __global float *scales,)==""\n"
R"==(__global char *wei_layer, __global char *wei_iter,)==""\n"
R"==(__global BIAS_DATA_T *bias, int dhc, int n_layer, int n_dir,)==""\n"
R"==(float data_shift, float data_scale, int wei_l_comp_off,)==""\n"
R"==(int wei_i_comp_off, int64x4_t bias_strides) {)==""\n"
R"==(#if COPY_BIAS)==""\n"
R"==(const int dhc_ = get_global_id(0);)==""\n"
R"==(const int nbias_ = get_global_id(1);)==""\n"
R"==(const int layer_ = get_global_id(2) / n_dir;)==""\n"
R"==(const int dir_ = get_global_id(2) % n_dir;)==""\n"
R"==(const float wei_scale)==""\n"
R"==(#if WEI_QPARAM_MASK)==""\n"
R"==(= scales[nbias_ * dhc + dhc_];)==""\n"
R"==(#else)==""\n"
R"==(= scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(__global char *temp = (__global char *)(wei_iter + wei_i_comp_off);)==""\n"
R"==(__global float *wei_iter_comp)==""\n"
R"==(= (__global float *)(((unsigned long)temp + (sizeof(float) - 1)))==""\n"
R"==(& -sizeof(float));)==""\n"
R"==(temp = (__global char *)(wei_layer + wei_l_comp_off);)==""\n"
R"==(__global float *wei_layer_comp)==""\n"
R"==(= (__global float *)(((unsigned long)temp + (sizeof(float) - 1)))==""\n"
R"==(& -sizeof(float));)==""\n"
R"==(const int off = comp_off(n_dir, dhc, layer_, dir_, nbias_, dhc_);)==""\n"
R"==(const float comp = wei_layer_comp[off] + wei_iter_comp[off];)==""\n"
R"==(ws_bias[off_ws_bias(n_layer, n_dir, dhc, layer_, dir_, nbias_, dhc_)])==""\n"
R"==(= bias[bias_off(bias_strides, layer_, dir_, nbias_, dhc_)])==""\n"
R"==(- comp * data_shift / (wei_scale * data_scale);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if IS_INT8 && CELL_KIND == VANILLA_LSTM)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(simple_rnn_elemwise_fwd(int dir, int lay, int iter,)==""\n"
R"==(__global ACC_DATA_T *scratch_gates_, dim_t scratch_gates_off,)==""\n"
R"==(__global float *scales, float alpha, float data_shift, float data_scale,)==""\n"
R"==(__global float *tm_scales, __global WS_STATE_DATA_T *h_states_t_l_,)==""\n"
R"==(dim_t h_states_t_l_off, __global float *c_states_t_l_,)==""\n"
R"==(dim_t c_states_t_l_off, __global float *c_states_tm1_l_,)==""\n"
R"==(dim_t c_states_tm1_l_off, __global AUX_DATA_T *ws_gates_,)==""\n"
R"==(dim_t ws_gates_off, __global float *ws_bias, int states_ws_ld,)==""\n"
R"==(int scratch_gates_ld, int batch, int dhc, int n_layer, int n_dir,)==""\n"
R"==(float tm_cscale) {)==""\n"
R"==(const int i = get_global_id(1); )==""\n"
R"==(const int j = get_global_id(0); )==""\n"
R"==(if (j >= dhc || i >= batch) return;)==""\n"
R"==(__global ACC_DATA_T *scratch_gates = scratch_gates_ + scratch_gates_off;)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l = h_states_t_l_ + h_states_t_l_off;)==""\n"
R"==(__global float *c_states_t_l = c_states_t_l_ + c_states_t_l_off;)==""\n"
R"==(__global float *c_states_tm1_l = c_states_tm1_l_ + c_states_tm1_l_off;)==""\n"
R"==(__global AUX_DATA_T *ws_gates = ws_gates_ + ws_gates_off;)==""\n"
R"==(float G0 = logistic_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)],)==""\n"
R"==(0, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias(n_layer, n_dir, dhc, lay, dir, 0, j)],)==""\n"
R"==(tm_scales[0]);)==""\n"
R"==(float G1 = logistic_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 1, j)],)==""\n"
R"==(1, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias(n_layer, n_dir, dhc, lay, dir, 1, j)],)==""\n"
R"==(tm_scales[1]);)==""\n"
R"==(float G2 = tanh_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 2, j)],)==""\n"
R"==(2, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias(n_layer, n_dir, dhc, lay, dir, 2, j)],)==""\n"
R"==(tm_scales[2]);)==""\n"
R"==(float G3 = logistic_fwd_tm(deq_w(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 3, j)],)==""\n"
R"==(3, j, scales, data_scale, dhc))==""\n"
R"==(+ ws_bias[off_ws_bias(n_layer, n_dir, dhc, lay, dir, 3, j)],)==""\n"
R"==(tm_scales[3]);)==""\n"
R"==(float tmp)==""\n"
R"==(= G1 * c_states_tm1_l[cell_ws_state(states_ws_ld, i, j)] + G0 * G2;)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(= q_d(G3 * tanh_fwd_tm(tmp, tm_cscale), data_scale, data_shift);)==""\n"
R"==(c_states_t_l[cell_ws_state(states_ws_ld, i, j)] = tmp;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(simple_rnn_elemwise_fwd(__global ACC_DATA_T *scratch_gates_,)==""\n"
R"==(dim_t scratch_gates_off, __global BIAS_DATA_T *bias_, dim_t bias_off,)==""\n"
R"==(float alpha, __global float *tm_scales,)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l_, dim_t h_states_t_l_off,)==""\n"
R"==(__global AUX_DATA_T *c_states_t_l_, dim_t c_states_t_l_off,)==""\n"
R"==(__global AUX_DATA_T *c_states_tm1_l_, dim_t c_states_tm1_l_off,)==""\n"
R"==(__global AUX_DATA_T *ws_gates_, dim_t ws_gates_off,)==""\n"
R"==(__global AUX_DATA_T *ws_grid_, dim_t ws_grid_off, int states_ws_ld,)==""\n"
R"==(int gates_ws_ld, int scratch_gates_ld, int batch, int dhc,)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM || CELL_KIND == VANILLA_RNN)==""\n"
R"==(float tm_cscale)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_tm_l_, dim_t h_states_tm_l_off,)==""\n"
R"==(__global char *scr_cell)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_tm_l_, dim_t h_states_tm_l_off,)==""\n"
R"==(int n_part)==""\n"
R"==(#endif)==""\n"
R"==() {)==""\n"
R"==(const int i = get_global_id(1); )==""\n"
R"==(const int j = get_global_id(0); )==""\n"
R"==(if (j >= dhc || i >= batch) return;)==""\n"
R"==(__global ACC_DATA_T *scratch_gates = scratch_gates_ + scratch_gates_off;)==""\n"
R"==(__global BIAS_DATA_T *bias = bias_ + bias_off;)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l = h_states_t_l_ + h_states_t_l_off;)==""\n"
R"==(__global AUX_DATA_T *c_states_t_l = c_states_t_l_ + c_states_t_l_off;)==""\n"
R"==(__global AUX_DATA_T *c_states_tm1_l = c_states_tm1_l_ + c_states_tm1_l_off;)==""\n"
R"==(__global AUX_DATA_T *ws_gates = ws_gates_ + ws_gates_off;)==""\n"
R"==(__global AUX_DATA_T *ws_grid = ws_grid_ + ws_grid_off;)==""\n"
R"==(#if CELL_KIND == LBR_GRU || CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_tm_l)==""\n"
R"==(= h_states_tm_l_ + h_states_tm_l_off;)==""\n"
R"==(#endif)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(float G[vanilla_lstm_n_gates];)==""\n"
R"==(float B[vanilla_lstm_n_bias];)==""\n"
R"==(for (int gate_idx = 0; gate_idx < vanilla_lstm_n_gates; gate_idx++) {)==""\n"
R"==(G[gate_idx] = convert_float(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, gate_idx, j)]);)==""\n"
R"==(B[gate_idx] = convert_float(bias[off_ker_bias(dhc, gate_idx, j)]);)==""\n"
R"==(})==""\n"
R"==(vanilla_lstm_gates_t gates = vanilla_lstm_compute_gates(G, B, tm_scales);)==""\n"
R"==(vanilla_lstm_store(ws_gates, gates_ws_ld, h_states_t_l, c_states_t_l,)==""\n"
R"==(c_states_tm1_l, states_ws_ld, dhc, i, j, tm_cscale, gates);)==""\n"
R"==(#elif CELL_KIND == VANILLA_RNN)==""\n"
R"==(float g = vanilla_rnn_compute_gates()==""\n"
R"==(convert_float(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)]),)==""\n"
R"==(convert_float(bias[off_ker_bias(dhc, 0, j)]), alpha, tm_scales);)==""\n"
R"==(store_vanilla_rnn()==""\n"
R"==(ws_gates, gates_ws_ld, h_states_t_l, states_ws_ld, dhc, i, j, g);)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global AUX_DATA_T *scratch_cell = (__global AUX_DATA_T *)(scr_cell);)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter = h_states_tm_l;)==""\n"
R"==(lbr_gru_gates_t gates = compute_gates_lbr_gru(scratch_gates, scratch_cell,)==""\n"
R"==(bias, tm_scales, scratch_gates_ld, dhc, i, j);)==""\n"
R"==(float Wh_b = gates.Wh_b;)==""\n"
R"==(float G0 = gates.G[0];)==""\n"
R"==(float G1 = gates.G[1];)==""\n"
R"==(float G2 = gates.G[2];)==""\n"
R"==(float Ht = G0 * TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]))==""\n"
R"==(+ (1 - G0) * G2;)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)] = TO_WS_STATE(Ht);)==""\n"
R"==(if (!RECOMPUTE_GATES && IS_TRAINING) {)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] = G0;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)] = G1;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)] = G2;)==""\n"
R"==(ws_grid[cell_ws_grid_comp(dhc, i, j)] = Wh_b;)==""\n"
R"==(})==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter = h_states_tm_l;)==""\n"
R"==(if (n_part == 1) {)==""\n"
R"==(float G0 = logistic_fwd_tm()==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(+ bias[off_ker_bias(dhc, 0, j)],)==""\n"
R"==(tm_scales[0]);)==""\n"
R"==(float G1 = logistic_fwd_tm()==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(+ bias[off_ker_bias(dhc, 1, j)],)==""\n"
R"==(tm_scales[1]);)==""\n"
R"==(/* TODO from CPU: Can be optimized for fwd_training by using)==""\n"
R"==(ws_gates instead of scratch_gates in p2 */)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_ACC(G0);)==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_ACC(G1);)==""\n"
R"==(float tmp = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)] = TO_WS_STATE(tmp * G1);)==""\n"
R"==(if (!RECOMPUTE_GATES && IS_TRAINING) {)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)] = G0;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)] = G1;)==""\n"
R"==(})==""\n"
R"==(} else if (n_part == 2) {)==""\n"
R"==(float G0 = convert_float(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)]);)==""\n"
R"==(float G2 = tanh_fwd_tm()==""\n"
R"==(scratch_gates[cell_scratch_mem(scratch_gates_ld, dhc, i, 2, j)])==""\n"
R"==(+ bias[off_ker_bias(dhc, 2, j)],)==""\n"
R"==(tm_scales[2]);)==""\n"
R"==(float tmp = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(= TO_WS_STATE(tmp * G0 + (1.0f - G0) * G2);)==""\n"
R"==(if (!RECOMPUTE_GATES && IS_TRAINING) {)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)] = G2;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(#error "Wrong Cell Kind")==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if !IS_FWD)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(simple_rnn_elemwise_bwd(int dir, int lay, int iter,)==""\n"
R"==(__global SRC_DATA_T *scratch_diff_gates_, dim_t scratch_diff_gates_off,)==""\n"
R"==(__global AUX_DATA_T *scratch_gates_, dim_t scratch_gates_off,)==""\n"
R"==(__global BIAS_DATA_T *bias_, dim_t bias_off, float alpha,)==""\n"
R"==(__global float *tm_scales, __global WS_STATE_DATA_T *states_tm1_l_,)==""\n"
R"==(dim_t states_tm1_l_off, __global AUX_DATA_T *c_states_t_l_,)==""\n"
R"==(dim_t c_states_t_l_off, __global AUX_DATA_T *c_states_tm1_l_,)==""\n"
R"==(dim_t c_states_tm1_l_off, __global AUX_DATA_T *ws_gates_,)==""\n"
R"==(dim_t ws_gates_off, __global AUX_DATA_T *ws_grid_, dim_t ws_grid_off,)==""\n"
R"==(int states_ws_ld, int gates_ws_ld, int scratch_diff_gates_ld,)==""\n"
R"==(int scratch_gates_ld, int batch, int dhc, int scratch_diff_states_ld,)==""\n"
R"==(int diff_states_layer_ld,)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM || CELL_KIND == VANILLA_RNN)==""\n"
R"==(float tm_cscale,)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global char *scr_gate_r,)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(int n_part, __global char *scr_cell, __global DIFF_DATA_T *dhG1_,)==""\n"
R"==(dim_t dhG1_off,)==""\n"
R"==(#endif)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_l_, dim_t diff_states_t_l_off,)==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l_, dim_t diff_states_tp1_l_off,)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_lp1_, dim_t diff_states_t_lp1_off,)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_l_s1_, dim_t diff_states_t_l_s1_off,)==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l_s1_,)==""\n"
R"==(dim_t diff_states_tp1_l_s1_off,)==""\n"
R"==(#endif)==""\n"
R"==(MAYBE_ATOMIC DIFF_BIAS_DATA_T *diff_bias_base,)==""\n"
R"==(int64x4_t diff_bias_strides) {)==""\n"
R"==(const int i_ = get_global_id(1) * ELEMWISE_BWD_BATCH_BLOCK; )==""\n"
R"==(const int j = get_global_id(0); )==""\n"
R"==(MAYBE_ATOMIC DIFF_BIAS_DATA_T *diff_bias)==""\n"
R"==(= diff_bias_base + diff_bias_off(diff_bias_strides, lay, dir, 0, 0);)==""\n"
R"==(if (j >= dhc) return;)==""\n"
R"==(__global SRC_DATA_T *scratch_diff_gates)==""\n"
R"==(= scratch_diff_gates_ + scratch_diff_gates_off;)==""\n"
R"==(__global AUX_DATA_T *scratch_gates = scratch_gates_ + scratch_gates_off;)==""\n"
R"==(__global BIAS_DATA_T *bias = bias_ + bias_off;)==""\n"
R"==(__global WS_STATE_DATA_T *states_tm1_l = states_tm1_l_ + states_tm1_l_off;)==""\n"
R"==(__global AUX_DATA_T *c_states_t_l = c_states_t_l_ + c_states_t_l_off;)==""\n"
R"==(__global AUX_DATA_T *c_states_tm1_l = c_states_tm1_l_ + c_states_tm1_l_off;)==""\n"
R"==(__global AUX_DATA_T *ws_gates = ws_gates_ + ws_gates_off;)==""\n"
R"==(__global AUX_DATA_T *ws_grid = ws_grid_ + ws_grid_off;)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_l)==""\n"
R"==(= diff_states_t_l_ + diff_states_t_l_off;)==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l)==""\n"
R"==(= diff_states_tp1_l_ + diff_states_tp1_l_off;)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_lp1)==""\n"
R"==(= diff_states_t_lp1_ + diff_states_t_lp1_off;)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_l_s1)==""\n"
R"==(= diff_states_t_l_s1_ + diff_states_t_l_s1_off;)==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l_s1)==""\n"
R"==(= diff_states_tp1_l_s1_ + diff_states_tp1_l_s1_off;)==""\n"
R"==(#endif)==""\n"
R"==(DIFF_DATA_T diff_bias_acc[n_bias] = {0};)==""\n"
R"==(for (int batch_id = 0; batch_id < ELEMWISE_BWD_BATCH_BLOCK; batch_id++) {)==""\n"
R"==(int i = i_ + batch_id;)==""\n"
R"==(if (i >= batch) break;)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(#if !RECOMPUTE_GATES)==""\n"
R"==(float G0 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)];)==""\n"
R"==(float G1 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(float G2 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)];)==""\n"
R"==(float G3 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 3, j)];)==""\n"
R"==(#else)==""\n"
R"==(float G[vanilla_lstm_n_gates];)==""\n"
R"==(float B[vanilla_lstm_n_bias];)==""\n"
R"==(for (int gate_idx = 0; gate_idx < vanilla_lstm_n_gates; gate_idx++) {)==""\n"
R"==(G[gate_idx] = convert_float(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, gate_idx, j)]);)==""\n"
R"==(B[gate_idx] = convert_float(bias[off_ker_bias(dhc, gate_idx, j)]);)==""\n"
R"==(})==""\n"
R"==(vanilla_lstm_gates_t gates)==""\n"
R"==(= vanilla_lstm_compute_gates(G, B, tm_scales);)==""\n"
R"==(float G0 = gates.G[0];)==""\n"
R"==(float G1 = gates.G[1];)==""\n"
R"==(float G2 = gates.G[2];)==""\n"
R"==(float G3 = gates.G[3];)==""\n"
R"==(#endif)==""\n"
R"==(float Ct = c_states_t_l[cell_ws_state(states_ws_ld, i, j)];)==""\n"
R"==(float tanhCt = tanh_fwd_tm(Ct, tm_cscale);)==""\n"
R"==(float dHt = (float)diff_states_tp1_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(+ diff_states_t_lp1[cell_scratch_diff_states()==""\n"
R"==(batch, diff_states_layer_ld, i, j)];)==""\n"
R"==(float dCt = (float)diff_states_tp1_l_s1[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(+ one_m_square(tanhCt) * G3 * dHt;)==""\n"
R"==(float dG1 = (float)c_states_tm1_l[cell_ws_state(states_ws_ld, i, j)])==""\n"
R"==(* dCt * x_m_square(G1);)==""\n"
R"==(float dG0 = G2 * dCt * x_m_square(G0);)==""\n"
R"==(float dG3 = tanhCt * dHt * x_m_square(G3);)==""\n"
R"==(float dG2 = G0 * dCt * one_m_square(G2);)==""\n"
R"==(diff_states_t_l_s1[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(= dCt * G1;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_SRC(dG0);)==""\n"
R"==(diff_bias_acc[0] += dG0;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_SRC(dG1);)==""\n"
R"==(diff_bias_acc[1] += dG1;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_SRC(dG2);)==""\n"
R"==(diff_bias_acc[2] += dG2;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 3, j)])==""\n"
R"==(= TO_SRC(dG3);)==""\n"
R"==(diff_bias_acc[3] += dG3;)==""\n"
R"==(#elif CELL_KIND == LBR_GRU)==""\n"
R"==(__global SRC_DATA_T *scratch_gate_r)==""\n"
R"==(= (__global SRC_DATA_T *)(scr_gate_r);)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter = states_tm1_l; )==""\n"
R"==(float h = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(#if !RECOMPUTE_GATES)==""\n"
R"==(float Wh_b = ws_grid[cell_ws_grid_comp(dhc, i, j)];)==""\n"
R"==(float G0 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)];)==""\n"
R"==(float G1 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(float G2 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)];)==""\n"
R"==(#else)==""\n"
R"==(lbr_gru_gates_t gates = compute_gates_lbr_gru(scratch_gates,)==""\n"
R"==(scratch_cell, bias, tm_scales, scratch_gates_ld, dhc, i, j);)==""\n"
R"==(float Wh_b = gates.Wh_b;)==""\n"
R"==(float G0 = gates.G[0];)==""\n"
R"==(float G1 = gates.G[1];)==""\n"
R"==(float G2 = gates.G[2];)==""\n"
R"==(#endif)==""\n"
R"==(float dHt = diff_states_tp1_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(+ diff_states_t_lp1[cell_scratch_diff_states()==""\n"
R"==(batch, diff_states_layer_ld, i, j)];)==""\n"
R"==(float dG0 = (h - G2) * dHt * x_m_square(G0);)==""\n"
R"==(float dG2 = (1.0f - G0) * one_m_square(G2) * dHt;)==""\n"
R"==(float dG1 = Wh_b * dG2 * x_m_square(G1);)==""\n"
R"==(diff_states_t_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(= dHt * G0;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_SRC(dG0);)==""\n"
R"==(diff_bias_acc[0] += dG0;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_SRC(dG1);)==""\n"
R"==(diff_bias_acc[1] += dG1;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_SRC(dG2);)==""\n"
R"==(diff_bias_acc[2] += dG2;)==""\n"
R"==(scratch_gate_r[cell_scratch_mem(scratch_diff_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_SRC(dG0);)==""\n"
R"==(scratch_gate_r[cell_scratch_mem(scratch_diff_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_SRC(dG1);)==""\n"
R"==(float tmp = dG2 * ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(scratch_gate_r[cell_scratch_mem(scratch_diff_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_SRC(tmp);)==""\n"
R"==(diff_bias_acc[3] += tmp;)==""\n"
R"==(#elif CELL_KIND == VANILLA_RNN)==""\n"
R"==(float dH = diff_states_tp1_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(+ diff_states_t_lp1[cell_scratch_diff_states()==""\n"
R"==(batch, diff_states_layer_ld, i, j)];)==""\n"
R"==(#if !RECOMPUTE_GATES)==""\n"
R"==(float g = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)];)==""\n"
R"==(#else)==""\n"
R"==(float g = vanilla_rnn_compute_gates()==""\n"
R"==(convert_float(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, i, 0, j)]),)==""\n"
R"==(convert_float(bias[off_ker_bias(dhc, 0, j)]), alpha, tm_scales);)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_TESTMODE)==""\n"
R"==(float tmp = = dH * activation_bwd(g, tm_scales[0], 0.);)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_SRC(tmp);)==""\n"
R"==(diff_bias_acc[0] += tmp;)==""\n"
R"==(#else)==""\n"
R"==(float tmp = dH * activation_bwd(g, alpha, 0.);)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_SRC(tmp);)==""\n"
R"==(diff_bias_acc[0] += tmp;)==""\n"
R"==(#endif)==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU)==""\n"
R"==(__global WS_STATE_DATA_T *src_iter = states_tm1_l; )==""\n"
R"==(float h = TO_REF(src_iter[cell_ws_state(states_ws_ld, i, j)]);)==""\n"
R"==(if (n_part == 1) {)==""\n"
R"==(float dHt = diff_states_tp1_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(+ diff_states_t_lp1[cell_scratch_diff_states()==""\n"
R"==(batch, diff_states_layer_ld, i, j)];)==""\n"
R"==(float dG2 = (1.0f)==""\n"
R"==(- ws_gates[cell_ws_gates()==""\n"
R"==(gates_ws_ld, dhc, i, 0, j)]))==""\n"
R"==(* dHt)==""\n"
R"==(* one_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]);)==""\n"
R"==(float dG0 = (h - ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 2, j)]))==""\n"
R"==(* dHt)==""\n"
R"==(* x_m_square()==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)]);)==""\n"
R"==(diff_states_t_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(= dHt * ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 0, j)];)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 0, j)])==""\n"
R"==(= TO_SRC(dG0);)==""\n"
R"==(diff_bias_acc[0] += dG0;)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 2, j)])==""\n"
R"==(= TO_SRC(dG2);)==""\n"
R"==(diff_bias_acc[2] += dG2;)==""\n"
R"==(} else if (n_part == 2) {)==""\n"
R"==(__global SRC_DATA_T *scratch_cell)==""\n"
R"==(= (__global SRC_DATA_T *)(scr_cell);)==""\n"
R"==(__global DIFF_DATA_T *dhG1 = dhG1_ + dhG1_off;)==""\n"
R"==(float dG1 = ws_gates[cell_ws_gates(gates_ws_ld, dhc, i, 1, j)];)==""\n"
R"==(diff_states_t_l[cell_scratch_diff_states()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(+= dhG1[off_scratch_dhg1()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(* dG1;)==""\n"
R"==(float tmp = dhG1[off_scratch_dhg1()==""\n"
R"==(batch, scratch_diff_states_ld, i, j)])==""\n"
R"==(* h * x_m_square(dG1);)==""\n"
R"==(scratch_diff_gates[cell_scratch_mem()==""\n"
R"==(scratch_diff_gates_ld, dhc, i, 1, j)])==""\n"
R"==(= TO_SRC(tmp);)==""\n"
R"==(diff_bias_acc[1] += tmp;)==""\n"
R"==(scratch_cell[off_scratch_cell(batch, states_ws_ld, i, j)])==""\n"
R"==(= TO_SRC(dG1 * h);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(#error "Wrong Cell Kind")==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(unroll_for(int k = 0; k < n_bias; k++) {)==""\n"
R"==(#if NEED_BIAS_ATOMIC_REDUCE)==""\n"
R"==(atomic_add_global(&diff_bias[k * dhc + j], diff_bias_acc[k]);)==""\n"
R"==(#else)==""\n"
R"==(diff_bias[k * dhc + j] += diff_bias_acc[k];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(__kernel void simple_rnn_elemwise_bwd() {})==""\n"
R"==(#endif )==""\n"
R"==(#if CELL_COMP_ENABLED)==""\n"
R"==(void gemm_sum_inner(float(C)[M_THR_BLOCK][N_THR_BLOCK],)==""\n"
R"==(const __global WS_STATE_DATA_T *restrict A, const int a_stride,)==""\n"
R"==(const __global WEI_LAYER_DATA_T *restrict B, const int b_stride,)==""\n"
R"==(const int m_thr_stride, const int n_thr_stride, int m_l_end,)==""\n"
R"==(int k_l_end, int n_l_end, bool mn_valid) {)==""\n"
R"==(float A_l[M_THR_BLOCK] = {};)==""\n"
R"==(unroll_for(int m_l = 0; m_l < M_THR_BLOCK; m_l++) {)==""\n"
R"==(load(A_l + m_l, A + m_l * m_thr_stride * a_stride,)==""\n"
R"==((mn_valid || (m_l * m_thr_stride) < m_l_end))==""\n"
R"==(&& (int)get_sub_group_local_id() < k_l_end);)==""\n"
R"==(})==""\n"
R"==(float B_l[gemm_k_block][N_THR_BLOCK] = {};)==""\n"
R"==(unroll_for(int n_l = 0; n_l < N_THR_BLOCK; n_l++) {)==""\n"
R"==(unroll_for(int k_l = 0; k_l < gemm_k_block; k_l++) {)==""\n"
R"==(load(&B_l[k_l][n_l], &B[k_l * b_stride + n_l * n_thr_stride],)==""\n"
R"==(k_l < k_l_end)==""\n"
R"==(&& (mn_valid)==""\n"
R"==(|| (int)get_sub_group_local_id())==""\n"
R"==(< (n_l_end - n_l * n_thr_stride)));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(unroll_for(int m_l = 0; m_l < M_THR_BLOCK; m_l++) {)==""\n"
R"==(unroll_for(int k_l = 0; k_l < gemm_k_block; k_l++) {)==""\n"
R"==(unroll_for(int n_l = 0; n_l < N_THR_BLOCK; n_l++) {)==""\n"
R"==(C[m_l][n_l] += B_l[k_l][n_l] * sg_get(A_l[m_l], k_l);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(void gemm_sum(float(C)[N_OUTER_BLOCK][M_THR_BLOCK][N_THR_BLOCK],)==""\n"
R"==(const __global WS_STATE_DATA_T *restrict A, const int a_stride,)==""\n"
R"==(const __global WEI_LAYER_DATA_T *restrict B, const int b_stride,)==""\n"
R"==(gemm_dims_t size, int m_sg, int m_thr_stride, int n_sg,)==""\n"
R"==(int n_thr_stride, bool enable_m_tail, bool enable_k_tail,)==""\n"
R"==(bool enable_n_tail) {)==""\n"
R"==(bool valid_mn)==""\n"
R"==(= (!enable_m_tail || m_sg + m_thr_stride * M_THR_BLOCK <= size.m))==""\n"
R"==(&& (!enable_n_tail)==""\n"
R"==(|| n_sg + n_thr_stride * N_THR_BLOCK <= size.n_inner);)==""\n"
R"==(if (valid_mn) {)==""\n"
R"==(int k_outer = 0;)==""\n"
R"==(while (valid_mn && k_outer < size.k - gemm_k_block + 1) {)==""\n"
R"==(int k_l_end = gemm_k_block;)==""\n"
R"==(const int m_l_end = m_thr_stride * M_THR_BLOCK;)==""\n"
R"==(const int n_l_end = n_thr_stride * N_THR_BLOCK;)==""\n"
R"==(const int a_off_base = m_sg * a_stride + k_outer;)==""\n"
R"==(for (int n_outer = 0; n_outer < N_OUTER_BLOCK; n_outer++) {)==""\n"
R"==(const int b_off_base)==""\n"
R"==(= n_outer * size.n_inner + k_outer * b_stride + n_sg;)==""\n"
R"==(gemm_sum_inner(C[n_outer], A + a_off_base, a_stride,)==""\n"
R"==(B + b_off_base, b_stride, m_thr_stride, n_thr_stride,)==""\n"
R"==(m_l_end, k_l_end, n_l_end, true);)==""\n"
R"==(})==""\n"
R"==(k_outer += gemm_k_block;)==""\n"
R"==(})==""\n"
R"==(while (enable_k_tail && k_outer < size.k) {)==""\n"
R"==(int k_l_end = size.k - k_outer;)==""\n"
R"==(const int m_l_end = size.m - m_sg;)==""\n"
R"==(const int n_l_end = size.n_inner - n_sg;)==""\n"
R"==(const int a_off_base = m_sg * a_stride + k_outer;)==""\n"
R"==(for (int n_outer = 0; n_outer < N_OUTER_BLOCK; n_outer++) {)==""\n"
R"==(const int b_off_base)==""\n"
R"==(= n_outer * size.n_inner + k_outer * b_stride + n_sg;)==""\n"
R"==(gemm_sum_inner(C[n_outer], A + a_off_base, a_stride,)==""\n"
R"==(B + b_off_base, b_stride, m_thr_stride, n_thr_stride,)==""\n"
R"==(m_l_end, k_l_end, n_l_end, true);)==""\n"
R"==(})==""\n"
R"==(k_outer += gemm_k_block;)==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(int k_outer = 0;)==""\n"
R"==(while (k_outer < size.k) {)==""\n"
R"==(int k_l_end = enable_k_tail ? size.k - k_outer : gemm_k_block;)==""\n"
R"==(const int m_l_end = size.m - m_sg;)==""\n"
R"==(const int n_l_end = size.n_inner - n_sg;)==""\n"
R"==(const int a_off_base = m_sg * a_stride + k_outer;)==""\n"
R"==(for (int n_outer = 0; n_outer < N_OUTER_BLOCK; n_outer++) {)==""\n"
R"==(const int b_off_base)==""\n"
R"==(= n_outer * size.n_inner + k_outer * b_stride + n_sg;)==""\n"
R"==(gemm_sum_inner(C[n_outer], A + a_off_base, a_stride,)==""\n"
R"==(B + b_off_base, b_stride, m_thr_stride, n_thr_stride,)==""\n"
R"==(m_l_end, k_l_end, n_l_end, false);)==""\n"
R"==(})==""\n"
R"==(k_outer += gemm_k_block;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(void cell_common_inner(const_wei_layer_cell_t wei_layer,)==""\n"
R"==(const_wei_iter_cell_t wei_iter, const_ws_state_cell_t cell_layer,)==""\n"
R"==(const_ws_state_cell_t cell_iter, aux_cell_t gates,)==""\n"
R"==(ws_state_cell_t states, const_aux_cell_t scratch_gates, cell_ctx_t ctx,)==""\n"
R"==(cell_dims_t outer, cell_dims_t dims) {)==""\n"
R"==(const int local_sgid0)==""\n"
R"==(= get_sub_group_id() * SUBGROUP_SIZE % get_local_size(0);)==""\n"
R"==(const int local_sgid1)==""\n"
R"==(= get_sub_group_id() * SUBGROUP_SIZE / get_local_size(0);)==""\n"
R"==(const int c_tg = outer.dhc + get_group_id(0) * DHC_LOCAL;)==""\n"
R"==(const int c_sg = c_tg + local_sgid0 * CELL_DHC_THR;)==""\n"
R"==(const int c_thr = c_sg + get_sub_group_local_id();)==""\n"
R"==(const int c_thr_stride = SUBGROUP_SIZE;)==""\n"
R"==(const int n_tg = outer.mb + get_group_id(1) * BATCH_LOCAL;)==""\n"
R"==(const int n_sg = n_tg + local_sgid1 * CELL_BATCH_THR;)==""\n"
R"==(const int n_thr = n_sg;)==""\n"
R"==(const int n_thr_stride = 1;)==""\n"
R"==(float C[n_gates][CELL_BATCH_THR][CELL_DHC_THR] = {};)==""\n"
R"==(if (NEED_SCRATCH_GATES) {)==""\n"
R"==(for_(int gate_idx = 0; gate_idx < n_gates; gate_idx++))==""\n"
R"==(for (int n_l = 0; n_l < CELL_BATCH_THR; n_l++) {)==""\n"
R"==(int n = n_thr + n_l * n_thr_stride;)==""\n"
R"==(if (CELL_MB_TAIL && n >= dims.mb) break;)==""\n"
R"==(for (int c_l = 0; c_l < CELL_DHC_THR; c_l++) {)==""\n"
R"==(int c = c_thr + c_l * c_thr_stride;)==""\n"
R"==(if (CELL_DHC_TAIL && c >= dims.dhc) break;)==""\n"
R"==(C[gate_idx][n_l])==""\n"
R"==([c_l] = convert_float(scratch_gates.ptr[cell_scratch_mem()==""\n"
R"==(scratch_gates.strides.mb, dims.dhc, n, gate_idx, c)]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(if (CELL_COMPUTE_GEMM_LAYER) {)==""\n"
R"==(gemm_dims_t size = {.m = dims.mb,)==""\n"
R"==(.k = dims.slc,)==""\n"
R"==(.n_inner = dims.dhc,)==""\n"
R"==(.n_outer = n_gates};)==""\n"
R"==(gemm_sum(C, cell_layer.ptr, cell_layer.strides.mb, wei_layer.ptr,)==""\n"
R"==(wei_layer.strides.slc, size, n_sg, n_thr_stride, c_sg,)==""\n"
R"==(c_thr_stride, CELL_DHC_TAIL, CELL_GEMM_LAYER_K_TAIL,)==""\n"
R"==(CELL_MB_TAIL);)==""\n"
R"==(})==""\n"
R"==(if (CELL_COMPUTE_GEMM_ITER) {)==""\n"
R"==(gemm_dims_t size = {.m = dims.mb,)==""\n"
R"==(.k = dims.sic,)==""\n"
R"==(.n_inner = dims.dhc,)==""\n"
R"==(.n_outer = n_gates};)==""\n"
R"==(gemm_sum(C, cell_iter.ptr, cell_iter.strides.mb, wei_iter.ptr,)==""\n"
R"==(wei_iter.strides.sic, size, n_sg, n_thr_stride, c_sg,)==""\n"
R"==(c_thr_stride, CELL_DHC_TAIL, CELL_GEMM_ITER_K_TAIL,)==""\n"
R"==(CELL_MB_TAIL);)==""\n"
R"==(})==""\n"
R"==(for (int n_l = 0; n_l < CELL_BATCH_THR; n_l++) {)==""\n"
R"==(int n = n_thr + n_l * n_thr_stride;)==""\n"
R"==(if (CELL_MB_TAIL && n >= dims.mb) break;)==""\n"
R"==(for (int c_l = 0; c_l < CELL_DHC_THR; c_l++) {)==""\n"
R"==(int c = c_thr + c_l * c_thr_stride;)==""\n"
R"==(if (CELL_DHC_TAIL && c >= dims.dhc) break;)==""\n"
R"==(if (CELL_KIND == VANILLA_LSTM) {)==""\n"
R"==(float G[vanilla_lstm_n_gates];)==""\n"
R"==(float B[vanilla_lstm_n_bias];)==""\n"
R"==(for (int gate_idx = 0; gate_idx < vanilla_lstm_n_gates;)==""\n"
R"==(gate_idx++) {)==""\n"
R"==(G[gate_idx] = C[gate_idx][n_l][c_l];)==""\n"
R"==(B[gate_idx] = convert_float()==""\n"
R"==(ctx.lstm.bias[off_ker_bias(dims.dhc, gate_idx, c)]);)==""\n"
R"==(})==""\n"
R"==(vanilla_lstm_gates_t g)==""\n"
R"==(= vanilla_lstm_compute_gates(G, B, ctx.lstm.tm_scales);)==""\n"
R"==(vanilla_lstm_store(gates.ptr, gates.strides.mb, states.ptr,)==""\n"
R"==(ctx.lstm.c_states, ctx.lstm.c_states_iter,)==""\n"
R"==(states.strides.mb, dims.dhc, n, c, ctx.lstm.tm_cscale,)==""\n"
R"==(g);)==""\n"
R"==(} else if (CELL_KIND == VANILLA_RNN) {)==""\n"
R"==(float g = vanilla_rnn_compute_gates(C[0][n_l][c_l],)==""\n"
R"==(ctx.rnn.bias[off_ker_bias(dims.dhc, 0, c)],)==""\n"
R"==(ctx.rnn.alpha, ctx.rnn.tm_scales);)==""\n"
R"==(store_vanilla_rnn(gates.ptr, gates.strides.mb, states.ptr,)==""\n"
R"==(states.strides.mb, dims.dhc, n, c, g);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(void cell_common(const_wei_layer_cell_t wei_layer,)==""\n"
R"==(const_wei_iter_cell_t wei_iter, const_ws_state_cell_t cell_layer,)==""\n"
R"==(const_ws_state_cell_t cell_iter, aux_cell_t gates,)==""\n"
R"==(ws_state_cell_t states, const_aux_cell_t scratch_gates, cell_ctx_t ctx,)==""\n"
R"==(cell_dims_t dims, cell_loops_t loops) {)==""\n"
R"==(for_(cell_dim_t mb_outer = 0; mb_outer < loops.mb; mb_outer += BATCH_LOCAL))==""\n"
R"==(for (cell_dim_t dhc_outer = 0; dhc_outer < loops.dhc;)==""\n"
R"==(dhc_outer += DHC_LOCAL) {)==""\n"
R"==(cell_dims_t outer = {.mb = mb_outer, .dhc = dhc_outer};)==""\n"
R"==(cell_common_inner(wei_layer, wei_iter, cell_layer, cell_iter, gates,)==""\n"
R"==(states, scratch_gates, ctx, outer, dims);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void)==""\n"
R"==(simple_rnn_cell_fwd(__global const WEI_LAYER_DATA_T *wei_layer_,)==""\n"
R"==(dim_t wei_layer_off, int64x5_t wei_layer_strides_,)==""\n"
R"==(__global const WEI_ITER_DATA_T *wei_iter_, dim_t wei_iter_off,)==""\n"
R"==(int64x5_t wei_iter_strides_,)==""\n"
R"==(__global const WS_STATE_DATA_T *cell_layer_, dim_t cell_layer_off,)==""\n"
R"==(int64x2_t cell_layer_strides_,)==""\n"
R"==(__global const WS_STATE_DATA_T *cell_iter_, dim_t cell_iter_off,)==""\n"
R"==(int64x2_t cell_iter_strides_, __global AUX_DATA_T *gates_,)==""\n"
R"==(dim_t gates_off, int64x2_t gates_strides_,)==""\n"
R"==(__global WS_STATE_DATA_T *states_, dim_t states_off,)==""\n"
R"==(int64x2_t states_strides_,)==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM)==""\n"
R"==(__global AUX_DATA_T *c_states_, dim_t c_states_off,)==""\n"
R"==(__global const AUX_DATA_T *c_states_iter_, dim_t c_states_iter_off,)==""\n"
R"==(float tm_cscale,)==""\n"
R"==(#endif)==""\n"
R"==(#if NEED_SCRATCH_GATES)==""\n"
R"==(__global AUX_DATA_T *scratch_gates_, dim_t scratch_gates_off,)==""\n"
R"==(int64x2_t scratch_gates_strides_,)==""\n"
R"==(#endif)==""\n"
R"==(#if CELL_ENABLE_ITER_BLOCK)==""\n"
R"==(dim_t iter_loop,)==""\n"
R"==(#endif)==""\n"
R"==(__global BIAS_DATA_T *bias_, dim_t bias_off, float alpha,)==""\n"
R"==(__global float *tm_scales, dim_t mb, dim_t dhc, dim_t slc, dim_t sic,)==""\n"
R"==(dim_t dhc_loop) {)==""\n"
R"==(#if !NEED_SCRATCH_GATES)==""\n"
R"==(__global AUX_DATA_T *scratch_gates_ = NULL;)==""\n"
R"==(dim_t scratch_gates_off = 0;)==""\n"
R"==(int64x2_t scratch_gates_strides_ = {};)==""\n"
R"==(#endif)==""\n"
R"==(#if !CELL_ENABLE_ITER_BLOCK)==""\n"
R"==(const dim_t iter_loop = 1;)==""\n"
R"==(#endif)==""\n"
R"==(grid_strides_t wei_layer_strides)==""\n"
R"==(= {.iter = 0, .cell = {.slc = wei_layer_strides_.array[2]}};)==""\n"
R"==(grid_strides_t wei_iter_strides)==""\n"
R"==(= {.iter = 0, .cell = {.sic = wei_iter_strides_.array[2]}};)==""\n"
R"==(grid_strides_t cell_layer_strides = {.iter = cell_layer_strides_.array[0],)==""\n"
R"==(.cell = {.mb = cell_layer_strides_.array[1]}};)==""\n"
R"==(grid_strides_t cell_iter_strides = {.iter = cell_iter_strides_.array[0],)==""\n"
R"==(.cell = {.mb = cell_iter_strides_.array[1]}};)==""\n"
R"==(grid_strides_t gates_strides = {.iter = gates_strides_.array[0],)==""\n"
R"==(.cell = {.mb = gates_strides_.array[1]}};)==""\n"
R"==(grid_strides_t states_strides = {.iter = states_strides_.array[0],)==""\n"
R"==(.cell = {.mb = states_strides_.array[1]}};)==""\n"
R"==(grid_strides_t scratch_gates_strides)==""\n"
R"==(= {.iter = scratch_gates_strides_.array[0],)==""\n"
R"==(.cell = {.mb = scratch_gates_strides_.array[1]}};)==""\n"
R"==(cell_dims_t dims = {.mb = mb, .dhc = dhc, .slc = slc, .sic = sic};)==""\n"
R"==(cell_loops_t cell_loops = {.mb = BATCH_LOCAL, .dhc = dhc_loop};)==""\n"
R"==(const_wei_layer_cell_t wei_layer = {.ptr = wei_layer_ + wei_layer_off,)==""\n"
R"==(.strides = wei_layer_strides.cell};)==""\n"
R"==(const_wei_iter_cell_t wei_iter = {)==""\n"
R"==(.ptr = wei_iter_ + wei_iter_off, .strides = wei_iter_strides.cell};)==""\n"
R"==(__global BIAS_DATA_T *bias = bias_ + bias_off;)==""\n"
R"==(for (dim_t iter = 0; iter < iter_loop; iter++) {)==""\n"
R"==(const_ws_state_cell_t cell_layer = {.ptr)==""\n"
R"==(= cell_layer_ + cell_layer_off + cell_layer_strides.iter * iter,)==""\n"
R"==(.strides = cell_layer_strides.cell};)==""\n"
R"==(const_ws_state_cell_t cell_iter = {.ptr)==""\n"
R"==(= cell_iter_ + cell_iter_off + cell_iter_strides.iter * iter,)==""\n"
R"==(.strides = cell_iter_strides.cell};)==""\n"
R"==(aux_cell_t gates)==""\n"
R"==(= {.ptr = gates_ + gates_off + gates_strides.iter * iter,)==""\n"
R"==(.strides = gates_strides.cell};)==""\n"
R"==(ws_state_cell_t states)==""\n"
R"==(= {.ptr = states_ + states_off + states_strides.iter * iter,)==""\n"
R"==(.strides = states_strides.cell};)==""\n"
R"==(const_aux_cell_t scratch_gates = {.ptr = scratch_gates_)==""\n"
R"==(+ scratch_gates_off + scratch_gates_strides.iter * iter,)==""\n"
R"==(.strides = scratch_gates_strides.cell};)==""\n"
R"==(#if CELL_KIND == VANILLA_RNN)==""\n"
R"==(cell_ctx_t cell_ctx = {)==""\n"
R"==(.rnn = {.alpha = alpha, .bias = bias, .tm_scales = tm_scales}};)==""\n"
R"==(__global AUX_DATA_T *c_states_ = NULL;)==""\n"
R"==(#elif CELL_KIND == VANILLA_LSTM)==""\n"
R"==(cell_ctx_t cell_ctx)==""\n"
R"==(= {.lstm = {.c_states = c_states_ + c_states_off)==""\n"
R"==(+ states_strides.iter * iter,)==""\n"
R"==(.c_states_iter = c_states_iter_ + c_states_iter_off)==""\n"
R"==(+ states_strides.iter * iter,)==""\n"
R"==(.bias = bias,)==""\n"
R"==(.tm_scales = tm_scales,)==""\n"
R"==(.tm_cscale = tm_cscale}};)==""\n"
R"==(#endif)==""\n"
R"==(cell_common(wei_layer, wei_iter, cell_layer, cell_iter, gates, states,)==""\n"
R"==(scratch_gates, cell_ctx, dims, cell_loops);)==""\n"
R"==(if (iter < iter_loop - 1) barrier(CLK_GLOBAL_MEM_FENCE);)==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(__kernel void simple_rnn_cell_fwd() {})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}