namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *subbyte_pack_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#define DT_UNDEF 1)==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(__kernel void subbyte_pack(__global uchar *restrict src,)==""\n"
R"==(__global uchar *restrict dst, off_t n, int bits, int64x3_t offset) {)==""\n"
R"==(const uchar mask = (1 << bits) - 1;)==""\n"
R"==(const off_t dst_off = get_global_id(0) + offset.array[0];)==""\n"
R"==(const off_t src_off = (8 / bits) * dst_off;)==""\n"
R"==(uchar packed = 0;)==""\n"
R"==(for (int i = 0, j = 0; i < 8; i += bits, ++j) {)==""\n"
R"==(uchar byte = src_off + j < n ? src[src_off + j] : 0;)==""\n"
R"==(packed |= (byte & mask) << i;)==""\n"
R"==(})==""\n"
R"==(dst[dst_off] = packed;)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}