namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *vectorized_lnorm_fused_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2023-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifdef VECT_DT_N)==""\n"
R"==(#undef VECT_DT_N)==""\n"
R"==(#endif)==""\n"
R"==(#define VECT_DT_N VECT_SIZE_FUSED)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#undef SRC_OFF)==""\n"
R"==(#undef DST_OFF)==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DST, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define STAT_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(STAT, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#if NDIMS > 3)==""\n"
R"==(#error "NDIMS > 3 not supported")==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 2)==""\n"
R"==(#define SRC_PLAIN_OFF(n, c) SRC_OFF(n, c, 0, 0, 0, 0))==""\n"
R"==(#define DST_PLAIN_OFF(n, c) DST_OFF(n, c, 0, 0, 0, 0))==""\n"
R"==(#define STAT_PLAIN_OFF(n) STAT_OFF(n, 0, 0, 0, 0, 0))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_PLAIN_OFF(n, c) SRC_OFF(0, n, c, 0, 0, 0))==""\n"
R"==(#define DST_PLAIN_OFF(n, c) DST_OFF(0, n, c, 0, 0, 0))==""\n"
R"==(#define STAT_PLAIN_OFF(n) STAT_OFF(0, n, 0, 0, 0, 0))==""\n"
R"==(#endif)==""\n"
R"==(#define VLEN_C (C / (SUB_GROUP_SIZE * VECT_DT_N)))==""\n"
R"==(#define VLEN_C_BLOCK \)==""\n"
R"==(((C / NUM_NORM_BLOCKS_FUSED) / (SUB_GROUP_SIZE * VECT_DT_N)))==""\n"
R"==(#define C_BLOCK (C / NUM_NORM_BLOCKS_FUSED))==""\n"
R"==(#define LOAD_VECT_FLOAT(ptr) \)==""\n"
R"==(AS_VECT_FLOAT_T(VECT_UINT_READ((const __global uint *)(ptr))))==""\n"
R"==(#define STORE_FLOAT_SGx1(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(ptr), as_uint(val)))==""\n"
R"==(#define STORE_FLOAT_SGx2(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(ptr), as_uint2(val)))==""\n"
R"==(#define STORE_FLOAT_SGx4(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write4((__global uint *)(ptr), as_uint4(val)))==""\n"
R"==(#define STORE_FLOAT_SGx8(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(ptr), as_uint8(val)))==""\n"
R"==(#define STORE_VECT_FLOAT(ptr, val) CONCAT2(STORE_FLOAT_SGx, VECT_DT_N)(ptr, val))==""\n"
R"==(#define STORE_LOCAL_FLOAT_SGx1(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write((__local uint *)(ptr), as_uint(val)))==""\n"
R"==(#define STORE_LOCAL_FLOAT_SGx2(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write2((__local uint *)(ptr), as_uint2(val)))==""\n"
R"==(#define STORE_LOCAL_FLOAT_SGx4(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write4((__local uint *)(ptr), as_uint4(val)))==""\n"
R"==(#define STORE_LOCAL_FLOAT_SGx8(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write8((__local uint *)(ptr), as_uint8(val)))==""\n"
R"==(#define STORE_VECT_LOCAL_FLOAT(ptr, val) \)==""\n"
R"==(CONCAT2(STORE_LOCAL_FLOAT_SGx, VECT_DT_N)(ptr, val))==""\n"
R"==(#define MIN(a, b) ((a) < (b) ? (a) : (b)))==""\n"
R"==(#define MAX(a, b) ((a) > (b) ? (a) : (b)))==""\n"
R"==(#define DIV_UP(a, b) ((a) + ((b)-1)) / (b))==""\n"
R"==(#define MAX_CHUNKS MAX(NUM_ACROSS_BLOCKS, NUM_NORM_BLOCKS_FUSED))==""\n"
R"==(NAMED_KERNEL_ATTR(FUSED))==""\n"
R"==(__kernel void vectorized_lnorm_bwd_fused(__global DATA_T *src,)==""\n"
R"==(__global float *mean, __global float *variance,)==""\n"
R"==(__global DATA_T *diff_dst, __global WEI_DATA_T *diff_scale,)==""\n"
R"==(__global WEI_DATA_T *diff_shift, __global WEI_DATA_T *scale,)==""\n"
R"==(__global DATA_T *diff_src, float eps) {)==""\n"
R"==(#if USE_SCALE || USE_SHIFT)==""\n"
R"==(const int c_uid = GWS_GET_C_fused();)==""\n"
R"==(const int n_uid = GWS_GET_N_fused();)==""\n"
R"==(__local float local_reduce_mem[2 * NUM_ACROSS_BLOCKS * NORM_BLOCK_FUSED];)==""\n"
R"==(if (n_uid < NUM_ACROSS_BLOCKS) {)==""\n"
R"==(const int c_block_off = (c_uid / SUB_GROUP_SIZE) * NORM_BLOCK_FUSED;)==""\n"
R"==(const int n_start = ACROSS_BLOCK * n_uid;)==""\n"
R"==(const int n_end = MIN(n_start + ACROSS_BLOCK, N);)==""\n"
R"==(__local float *tmp_diff_scale)==""\n"
R"==(= local_reduce_mem + n_uid * NORM_BLOCK_FUSED;)==""\n"
R"==(__local float *tmp_diff_shift)==""\n"
R"==(= tmp_diff_scale + NUM_ACROSS_BLOCKS * NORM_BLOCK_FUSED;)==""\n"
R"==(for (int c = 0; c < VLEN_C_BLOCK; c++) {)==""\n"
R"==(const int c_idx = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(const int c_slm_idx = c * SUB_GROUP_SIZE * VECT_DT_N;)==""\n"
R"==(VECT_FLOAT_T diff_gamma_vect = 0;)==""\n"
R"==(VECT_FLOAT_T diff_beta_vect = 0;)==""\n"
R"==(for (int n_idx = n_start; n_idx < n_end; n_idx++) {)==""\n"
R"==(const float mean_vect = mean[n_idx];)==""\n"
R"==(const float variance_vect = variance[n_idx];)==""\n"
R"==(const float inv_sqrt_variance = rsqrt(variance_vect + eps);)==""\n"
R"==(const int src_off = SRC_PLAIN_OFF(n_idx, c_idx);)==""\n"
R"==(const int dst_off = DST_PLAIN_OFF(n_idx, c_idx);)==""\n"
R"==(const VECT_FLOAT_T src_vect = CONVERT_VECT_FLOAT_T()==""\n"
R"==(AS_VECT_DATA_T(VECT_BLOCK_READ((const __global)==""\n"
R"==(BLOCK_DATA_T *)(&src[src_off]))));)==""\n"
R"==(const VECT_FLOAT_T diff_dst_vect = CONVERT_VECT_FLOAT_T()==""\n"
R"==(AS_VECT_DATA_T(VECT_BLOCK_READ((const __global)==""\n"
R"==(BLOCK_DATA_T *)(&diff_dst[dst_off]))));)==""\n"
R"==(diff_gamma_vect += (src_vect - mean_vect) * diff_dst_vect)==""\n"
R"==(* inv_sqrt_variance;)==""\n"
R"==(diff_beta_vect += diff_dst_vect;)==""\n"
R"==(})==""\n"
R"==(if (USE_SCALE))==""\n"
R"==(STORE_VECT_LOCAL_FLOAT()==""\n"
R"==(&tmp_diff_scale[c_slm_idx], diff_gamma_vect);)==""\n"
R"==(if (USE_SHIFT))==""\n"
R"==(STORE_VECT_LOCAL_FLOAT()==""\n"
R"==(&tmp_diff_shift[c_slm_idx], diff_beta_vect);)==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (n_uid == 0) {)==""\n"
R"==(for (int c = 0; c < VLEN_C_BLOCK; c++) {)==""\n"
R"==(const int c_idx = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(const int c_slm_idx = c * SUB_GROUP_SIZE * VECT_DT_N;)==""\n"
R"==(VECT_FLOAT_T diff_gamma_vect = 0;)==""\n"
R"==(VECT_FLOAT_T diff_beta_vect = 0;)==""\n"
R"==(for (int n_idx = 0; n_idx < NUM_ACROSS_BLOCKS; n_idx++) {)==""\n"
R"==(if (USE_SCALE) {)==""\n"
R"==(diff_gamma_vect += AS_VECT_FLOAT_T(VECT_UINT_READ()==""\n"
R"==((const __local uint *)&tmp_diff_scale[c_slm_idx)==""\n"
R"==(+ n_idx * NORM_BLOCK_FUSED]));)==""\n"
R"==(})==""\n"
R"==(if (USE_SHIFT) {)==""\n"
R"==(diff_beta_vect += AS_VECT_FLOAT_T(VECT_UINT_READ()==""\n"
R"==((const __local uint *)&tmp_diff_shift[c_slm_idx)==""\n"
R"==(+ n_idx * NORM_BLOCK_FUSED]));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(if (USE_SCALE))==""\n"
R"==(SAVE_VECT_WEI(&diff_scale[c_idx], diff_gamma_vect);)==""\n"
R"==(if (USE_SHIFT))==""\n"
R"==(SAVE_VECT_WEI(&diff_shift[c_idx], diff_beta_vect);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(} else if (n_uid < MAX_CHUNKS) {)==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#define SRC_BUF_SIZE (NORM_BLOCK_FUSED / (SUB_GROUP_SIZE * VECT_DT_N)))==""\n"
R"==(#define GAMMA_SLM_SIZE (SUB_GROUP_SIZE * NUM_NORM_BLOCKS_FUSED))==""\n"
R"==(if (GWS_GET_C_fused() >= SUB_GROUP_SIZE) return;)==""\n"
R"==(const int c_uni_id = GWS_GET_C_fused();)==""\n"
R"==(const int n_uni_id = GWS_GET_N_fused() / MAX_CHUNKS;)==""\n"
R"==(const int c_block_id = GWS_GET_N_fused() % MAX_CHUNKS;)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int local_id = get_local_id(1);)==""\n"
R"==(float dd_gamma = 0, dd_gamma_x = 0;)==""\n"
R"==(#if CALCULATE_STATS)==""\n"
R"==(__local float dd_gamma_slm[GAMMA_SLM_SIZE];)==""\n"
R"==(__local float dd_gamma_x_slm[GAMMA_SLM_SIZE];)==""\n"
R"==(#endif)==""\n"
R"==(if (local_id >= NUM_NORM_BLOCKS_FUSED) {)==""\n"
R"==(#if CALCULATE_STATS)==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(#endif)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(const float rC = 1.0 / C;)==""\n"
R"==(const int s_off = STAT_PLAIN_OFF(n_uni_id);)==""\n"
R"==(const int c_block_off = c_block_id * NORM_BLOCK_FUSED;)==""\n"
R"==(VECT_FLOAT_T dd_gamma_vect = 0, dd_gamma_x_vect = 0;)==""\n"
R"==(VECT_FLOAT_T v_src[SRC_BUF_SIZE];)==""\n"
R"==(VECT_FLOAT_T v_diff_dst[SRC_BUF_SIZE];)==""\n"
R"==(const float mean_val = mean[s_off];)==""\n"
R"==(const float inv_sqrt_variance = rsqrt(variance[s_off] + eps);)==""\n"
R"==(for (int c = 0; c < SRC_BUF_SIZE; c++) {)==""\n"
R"==(const int c_idx = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(const int src_off = SRC_PLAIN_OFF(n_uni_id, c_idx);)==""\n"
R"==(const int dst_off = DST_PLAIN_OFF(n_uni_id, c_idx);)==""\n"
R"==(v_src[c] = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(v_diff_dst[c] = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&diff_dst[dst_off])));)==""\n"
R"==(})==""\n"
R"==(#if CALCULATE_STATS)==""\n"
R"==(for (int c = 0; c < SRC_BUF_SIZE; c++) {)==""\n"
R"==(const int c_idx = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(VECT_FLOAT_T gamma = 1.0f;)==""\n"
R"==(if (scale) { gamma = LOAD_VECT_WEI(&scale[c_idx]); })==""\n"
R"==(const VECT_FLOAT_T src_vect = v_src[c];)==""\n"
R"==(const VECT_FLOAT_T dst_vect = v_diff_dst[c];)==""\n"
R"==(dd_gamma_vect += dst_vect * gamma;)==""\n"
R"==(dd_gamma_x_vect += dst_vect * gamma * (src_vect - mean_val);)==""\n"
R"==(})==""\n"
R"==(const int slm_off = SUB_GROUP_SIZE * local_id + simd_id;)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(dd_gamma_slm[slm_off] = dd_gamma_vect;)==""\n"
R"==(dd_gamma_x_slm[slm_off] = dd_gamma_x_vect;)==""\n"
R"==(#else)==""\n"
R"==(dd_gamma_slm[slm_off] = 0;)==""\n"
R"==(dd_gamma_x_slm[slm_off] = 0;)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) {)==""\n"
R"==(dd_gamma_slm[slm_off] += dd_gamma_vect[i];)==""\n"
R"==(dd_gamma_x_slm[slm_off] += dd_gamma_x_vect[i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(for (int i = 0; i < GAMMA_SLM_SIZE; i++) {)==""\n"
R"==(dd_gamma += dd_gamma_slm[i];)==""\n"
R"==(dd_gamma_x += dd_gamma_x_slm[i];)==""\n"
R"==(})==""\n"
R"==(dd_gamma_x *= inv_sqrt_variance;)==""\n"
R"==(#endif )==""\n"
R"==(for (int c = 0; c < SRC_BUF_SIZE; c++) {)==""\n"
R"==(VECT_FLOAT_T gamma = 1.0f;)==""\n"
R"==(if (scale) {)==""\n"
R"==(gamma = LOAD_VECT_WEI()==""\n"
R"==(&scale[c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off]);)==""\n"
R"==(})==""\n"
R"==(const VECT_FLOAT_T src_vect = v_src[c];)==""\n"
R"==(VECT_FLOAT_T v_diff_src_vect = v_diff_dst[c];)==""\n"
R"==(v_diff_src_vect *= gamma;)==""\n"
R"==(#if CALCULATE_STATS)==""\n"
R"==(v_diff_src_vect -= dd_gamma * rC)==""\n"
R"==(+ (src_vect - mean_val) * dd_gamma_x * inv_sqrt_variance * rC;)==""\n"
R"==(#endif)==""\n"
R"==(v_diff_src_vect *= inv_sqrt_variance;)==""\n"
R"==(const int c_idx = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(const int src_off = SRC_PLAIN_OFF(n_uni_id, c_idx);)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src[src_off],)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(v_diff_src_vect)));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}