namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *vectorized_lnorm_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#undef SRC_OFF)==""\n"
R"==(#undef DST_OFF)==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DST, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define STAT_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(STAT, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define VLEN_C (C / (SUB_GROUP_SIZE * VECT_DT_N)))==""\n"
R"==(#define VLEN_C_BLOCK ((C / NUM_NORM_BLOCKS) / (SUB_GROUP_SIZE * VECT_DT_N)))==""\n"
R"==(#define C_BLOCK (C / NUM_NORM_BLOCKS))==""\n"
R"==(#if (GWS_LWS0_DEFAULT * GWS_LWS1_DEFAULT * GWS_LWS2_DEFAULT) == GWS_SGS_DEFAULT)==""\n"
R"==(#define GROUP_REDUCE_ADD sub_group_reduce_add)==""\n"
R"==(#else)==""\n"
R"==(#define GROUP_REDUCE_ADD work_group_reduce_add)==""\n"
R"==(#endif)==""\n"
R"==(#define LOAD_VECT_FLOAT(ptr) \)==""\n"
R"==(AS_VECT_FLOAT_T(VECT_UINT_READ((const __global uint *)(ptr))))==""\n"
R"==(#if IS_FWD)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(#define CALC_V_STAT(v, acc) v = acc;)==""\n"
R"==(#else)==""\n"
R"==(#define CALC_V_STAT(v, acc) \)==""\n"
R"==(v = 0; \)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) { \)==""\n"
R"==(v += acc[i]; \)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#define STORE_VECT_DATA(ptr, val) \)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(val))))==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void vectorized_lnorm_fwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *dst,)==""\n"
R"==(__global WEI_DATA_T *scale, __global WEI_DATA_T *shift, float eps,)==""\n"
R"==(__global float *src_scale, __global float *dst_scale) {)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(x[0] = GWS_GET_X0();)==""\n"
R"==(x[1] = GWS_GET_X1();)==""\n"
R"==(x[2] = GWS_GET_X2();)==""\n"
R"==(x[3] = GWS_GET_X3();)==""\n"
R"==(int s_off = STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(float v_mean = CALCULATE_STATS ? 0 : mean[s_off];)==""\n"
R"==(float v_variance = CALCULATE_STATS ? 0 : variance[s_off];)==""\n"
R"==(const float rC = 1.f / C;)==""\n"
R"==(const int c_block_off = (x[NDIMS - 1] / SUB_GROUP_SIZE) * NORM_BLOCK;)==""\n"
R"==(#if USE_SRC_BUFFER)==""\n"
R"==(VECT_FLOAT_T v_src[VLEN_C_BLOCK];)==""\n"
R"==(for (int c = 0; c < VLEN_C_BLOCK; c++) {)==""\n"
R"==(x[NDIMS - 1] = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(v_src[c] = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(})==""\n"
R"==(#if CALCULATE_STATS)==""\n"
R"==(VECT_FLOAT_T v_acc = 0;)==""\n"
R"==(for (int c = 0; c < VLEN_C_BLOCK; c++) {)==""\n"
R"==(v_acc += v_src[c];)==""\n"
R"==(})==""\n"
R"==(CALC_V_STAT(v_mean, v_acc);)==""\n"
R"==(v_mean = GROUP_REDUCE_ADD(v_mean) * rC;)==""\n"
R"==(v_acc = 0;)==""\n"
R"==(VECT_FLOAT_T m = 0;)==""\n"
R"==(for (int c = 0; c < VLEN_C_BLOCK; c++) {)==""\n"
R"==(m = v_src[c] - v_mean;)==""\n"
R"==(v_acc += m * m;)==""\n"
R"==(})==""\n"
R"==(CALC_V_STAT(v_variance, v_acc);)==""\n"
R"==(v_variance = GROUP_REDUCE_ADD(v_variance) * rC;)==""\n"
R"==(#endif )==""\n"
R"==(const float rsqrt_variance = rsqrt(v_variance + eps);)==""\n"
R"==(for (int c = 0; c < VLEN_C_BLOCK; c++) {)==""\n"
R"==(const VECT_FLOAT_T sm)==""\n"
R"==(#if USE_SCALE)==""\n"
R"==(= LOAD_VECT_WEI()==""\n"
R"==(&scale[c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off]))==""\n"
R"==(* rsqrt_variance;)==""\n"
R"==(#else)==""\n"
R"==(= rsqrt_variance;)==""\n"
R"==(#endif)==""\n"
R"==(const VECT_FLOAT_T sv)==""\n"
R"==(#if USE_SHIFT)==""\n"
R"==(= LOAD_VECT_WEI()==""\n"
R"==(&shift[c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off]);)==""\n"
R"==(#else)==""\n"
R"==(= 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(x[NDIMS - 1] = c * SUB_GROUP_SIZE * VECT_DT_N + c_block_off;)==""\n"
R"==(int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(VECT_FLOAT_T v_dst = sm * (v_src[c] - v_mean) + sv;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(v_dst *= src_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(v_dst /= dst_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(STORE_VECT_DATA(&dst[dst_off], v_dst);)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(#if CALCULATE_STATS)==""\n"
R"==(VECT_FLOAT_T v_acc = 0;)==""\n"
R"==(for (int c = 0; c < C_BLOCK; c += SUB_GROUP_SIZE * VECT_DT_N) {)==""\n"
R"==(x[NDIMS - 1] = c + c_block_off;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(v_acc += CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(})==""\n"
R"==(CALC_V_STAT(v_mean, v_acc);)==""\n"
R"==(v_mean = GROUP_REDUCE_ADD(v_mean) * rC;)==""\n"
R"==(v_acc = 0;)==""\n"
R"==(VECT_FLOAT_T m = 0;)==""\n"
R"==(for (int c = 0; c < C_BLOCK; c += SUB_GROUP_SIZE * VECT_DT_N) {)==""\n"
R"==(x[NDIMS - 1] = c + c_block_off;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(m = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(m -= v_mean;)==""\n"
R"==(v_acc += m * m;)==""\n"
R"==(})==""\n"
R"==(CALC_V_STAT(v_variance, v_acc);)==""\n"
R"==(v_variance = GROUP_REDUCE_ADD(v_variance) * rC;)==""\n"
R"==(#endif )==""\n"
R"==(const float r_sqrt_variance = rsqrt(v_variance + eps);)==""\n"
R"==(for (int c = 0; c < C_BLOCK; c += SUB_GROUP_SIZE * VECT_DT_N) {)==""\n"
R"==(const VECT_FLOAT_T sm)==""\n"
R"==(#if USE_SCALE)==""\n"
R"==(= LOAD_VECT_WEI(&scale[c + c_block_off]) * r_sqrt_variance;)==""\n"
R"==(#else)==""\n"
R"==(= r_sqrt_variance;)==""\n"
R"==(#endif)==""\n"
R"==(const VECT_FLOAT_T sv)==""\n"
R"==(#if USE_SHIFT)==""\n"
R"==(= LOAD_VECT_WEI(&shift[c + c_block_off]);)==""\n"
R"==(#else)==""\n"
R"==(= 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(x[NDIMS - 1] = c + c_block_off;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const VECT_FLOAT_T v_src = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(VECT_FLOAT_T v_dst = sm * (v_src - v_mean) + sv;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(v_dst *= src_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(v_dst /= dst_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(STORE_VECT_DATA(&dst[dst_off], v_dst);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if CALCULATE_STATS && SAVE_STATS)==""\n"
R"==(if (get_local_linear_id() == 0) {)==""\n"
R"==(mean[s_off] = v_mean;)==""\n"
R"==(variance[s_off] = v_variance;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if IS_BWD)==""\n"
R"==(#define STORE_FLOAT_SGx1(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(ptr), as_uint(val)))==""\n"
R"==(#define STORE_FLOAT_SGx2(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(ptr), as_uint2(val)))==""\n"
R"==(#define STORE_FLOAT_SGx4(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write4((__global uint *)(ptr), as_uint4(val)))==""\n"
R"==(#define STORE_FLOAT_SGx8(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(ptr), as_uint8(val)))==""\n"
R"==(#define STORE_VECT_FLOAT(ptr, val) CONCAT2(STORE_FLOAT_SGx, VECT_DT_N)(ptr, val))==""\n"
R"==(#if USE_SCALE || USE_SHIFT)==""\n"
R"==(NAMED_KERNEL_ATTR(SCALESHIFT))==""\n"
R"==(__kernel void vectorized_lnorm_bwd_scaleshift(__global DATA_T *src,)==""\n"
R"==(__global float *mean, __global float *variance,)==""\n"
R"==(__global DATA_T *diff_dst, __global float *diff_scale,)==""\n"
R"==(__global float *diff_shift, float eps) {)==""\n"
R"==(const int c = GWS_GET_C() * VECT_DT_N;)==""\n"
R"==(const int n_chunk_idx = GWS_GET_N();)==""\n"
R"==(const int n_start = n_chunk_idx * N_CHUNK_SIZE;)==""\n"
R"==(const int n_end = min(n_start + N_CHUNK_SIZE, N);)==""\n"
R"==(const int shift_off = N_CHUNKS * C;)==""\n"
R"==(diff_shift += shift_off;)==""\n"
R"==(VECT_FLOAT_T diff_gamma_vect = 0;)==""\n"
R"==(VECT_FLOAT_T diff_beta_vect = 0;)==""\n"
R"==(for (int n_off = n_start; n_off < n_end; n_off++) {)==""\n"
R"==(const float mean_vect = mean[n_off];)==""\n"
R"==(const float variance_vect = variance[n_off];)==""\n"
R"==(const float inv_sqrt_variance = rsqrt(variance_vect + eps);)==""\n"
R"==(#if NDIMS == 2)==""\n"
R"==(const int src_off = SRC_OFF(n_off, c, 0, 0, 0, 0);)==""\n"
R"==(const int dst_off = DST_OFF(n_off, c, 0, 0, 0, 0);)==""\n"
R"==(#else)==""\n"
R"==(const int src_off = SRC_OFF(0, n_off, c, 0, 0, 0);)==""\n"
R"==(const int dst_off = DST_OFF(0, n_off, c, 0, 0, 0);)==""\n"
R"==(#endif)==""\n"
R"==(const VECT_FLOAT_T src_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)(&src[src_off]))));)==""\n"
R"==(const VECT_FLOAT_T diff_dst_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)(&diff_dst[dst_off]))));)==""\n"
R"==(diff_gamma_vect)==""\n"
R"==(+= (src_vect - mean_vect) * diff_dst_vect * inv_sqrt_variance;)==""\n"
R"==(diff_beta_vect += diff_dst_vect;)==""\n"
R"==(})==""\n"
R"==(const int result_offset = n_chunk_idx * C + c;)==""\n"
R"==(if (USE_SCALE))==""\n"
R"==(STORE_VECT_FLOAT(&diff_scale[result_offset], diff_gamma_vect);)==""\n"
R"==(if (USE_SHIFT) STORE_VECT_FLOAT(&diff_shift[result_offset], diff_beta_vect);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(SCALESHIFT_FINALIZE))==""\n"
R"==(__kernel void vectorized_lnorm_bwd_scaleshift_final()==""\n"
R"==(__global float *tmp_reduce_mem, __global WEI_DATA_T *diff_scale,)==""\n"
R"==(__global WEI_DATA_T *diff_shift) {)==""\n"
R"==(const int c = GWS_GET_C_finalize();)==""\n"
R"==(const int n_chunk = div_up(N_CHUNKS, FINALIZE_N_CHUNKS);)==""\n"
R"==(const int n = GWS_GET_N_finalize() * n_chunk;)==""\n"
R"==(const int lid = get_local_id(0);)==""\n"
R"==(const int diff_shift_off = N_CHUNKS * C;)==""\n"
R"==(__global float *tmp_diff_scale = tmp_reduce_mem;)==""\n"
R"==(__global float *tmp_diff_shift = tmp_reduce_mem + diff_shift_off;)==""\n"
R"==(float diff_gamma = 0;)==""\n"
R"==(float diff_beta = 0;)==""\n"
R"==(for (int n_idx = n; n_idx < min(n + n_chunk, N_CHUNKS); n_idx++) {)==""\n"
R"==(const int result_off = n_idx * C + c;)==""\n"
R"==(diff_gamma += tmp_diff_scale[result_off];)==""\n"
R"==(diff_beta += tmp_diff_shift[result_off];)==""\n"
R"==(})==""\n"
R"==(diff_gamma = work_group_reduce_add(diff_gamma);)==""\n"
R"==(diff_beta = work_group_reduce_add(diff_beta);)==""\n"
R"==(if (diff_scale && lid == 0) diff_scale[c] = CONVERT_WEI_DATA_T(diff_gamma);)==""\n"
R"==(if (diff_shift && lid == 0) diff_shift[c] = CONVERT_WEI_DATA_T(diff_beta);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void vectorized_lnorm_bwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global WEI_DATA_T *scale, __global DATA_T *diff_src, float eps) {)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(x[0] = GWS_GET_X0();)==""\n"
R"==(x[1] = GWS_GET_X1();)==""\n"
R"==(x[2] = GWS_GET_X2();)==""\n"
R"==(x[3] = GWS_GET_X3();)==""\n"
R"==(const int s_off = STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const float mean_val = mean[s_off];)==""\n"
R"==(const float inv_sqrt_variance = rsqrt(variance[s_off] + eps);)==""\n"
R"==(float dd_gamma = 0, dd_gamma_x = 0;)==""\n"
R"==(VECT_FLOAT_T dd_gamma_vect = 0;)==""\n"
R"==(VECT_FLOAT_T dd_gamma_x_vect = 0;)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(for (int c = 0; c < C; c += VECT_DT_N * SUB_GROUP_SIZE) {)==""\n"
R"==(VECT_FLOAT_T gamma = 1.0f;)==""\n"
R"==(if (scale) { gamma = LOAD_VECT_WEI(&scale[c]); })==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const VECT_FLOAT_T src_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(const VECT_FLOAT_T dst_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ(()==""\n"
R"==(const __global BLOCK_DATA_T *)&diff_dst[dst_off])));)==""\n"
R"==(dd_gamma_vect += dst_vect * gamma;)==""\n"
R"==(dd_gamma_x_vect += dst_vect * gamma * (src_vect - mean_val);)==""\n"
R"==(})==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(dd_gamma = dd_gamma_vect;)==""\n"
R"==(dd_gamma_x = dd_gamma_x_vect;)==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) {)==""\n"
R"==(dd_gamma += dd_gamma_vect[i];)==""\n"
R"==(dd_gamma_x += dd_gamma_x_vect[i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(dd_gamma = sub_group_reduce_add(dd_gamma);)==""\n"
R"==(dd_gamma_x = sub_group_reduce_add(dd_gamma_x);)==""\n"
R"==(dd_gamma_x *= inv_sqrt_variance;)==""\n"
R"==(})==""\n"
R"==(for (int c = 0; c < C; c += VECT_DT_N * SUB_GROUP_SIZE) {)==""\n"
R"==(VECT_FLOAT_T gamma = 1.0f;)==""\n"
R"==(if (scale) { gamma = LOAD_VECT_WEI(&scale[c]); })==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const VECT_FLOAT_T src_vect = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(VECT_FLOAT_T v_diff_src_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&diff_dst[dst_off])));)==""\n"
R"==(v_diff_src_vect *= gamma;)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(v_diff_src_vect -= dd_gamma / C)==""\n"
R"==(+ (src_vect - mean_val) * dd_gamma_x * inv_sqrt_variance)==""\n"
R"==(/ C;)==""\n"
R"==(})==""\n"
R"==(v_diff_src_vect *= inv_sqrt_variance;)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src[src_off],)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(v_diff_src_vect)));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}